/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define(["exports"],t):t((e=e||self).tf=e.tf||{})}(this,(function(e){"use strict";class t{constructor(e){this.global=e,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags()}setPlatform(e,t){null!=this.platform&&console.warn(`Platform ${this.platformName} has already been set. Overwriting the platform with ${t}.`),this.platformName=e,this.platform=t}registerFlag(e,t,n){if(this.flagRegistry[e]={evaluationFn:t,setHook:n},null!=this.urlFlags[e]){const t=this.urlFlags[e];console.warn(`Setting feature override from URL ${e}: ${t}.`),this.set(e,t)}}async getAsync(e){return e in this.flags||(this.flags[e]=await this.evaluateFlag(e)),this.flags[e]}get(e){if(e in this.flags)return this.flags[e];const t=this.evaluateFlag(e);if(t instanceof Promise)throw new Error(`Flag ${e} cannot be synchronously evaluated. Please use getAsync() instead.`);return this.flags[e]=t,this.flags[e]}getNumber(e){return this.get(e)}getBool(e){return this.get(e)}getFlags(){return this.flags}get features(){return this.flags}set(e,t){if(null==this.flagRegistry[e])throw new Error(`Cannot set flag ${e} as it has not been registered.`);this.flags[e]=t,null!=this.flagRegistry[e].setHook&&this.flagRegistry[e].setHook(t)}evaluateFlag(e){if(null==this.flagRegistry[e])throw new Error(`Cannot evaluate flag '${e}': no evaluation function found.`);return this.flagRegistry[e].evaluationFn()}setFlags(e){this.flags=Object.assign({},e)}reset(){this.flags={},this.urlFlags={},this.populateURLFlags()}populateURLFlags(){if(void 0===this.global||void 0===this.global.location||void 0===this.global.location.search)return;const e=function(e){const t={};return e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(e,...n)=>(function(e,t,n){e[decodeURIComponent(t)]=decodeURIComponent(n||"")}(t,n[0],n[1]),n.join("="))),t}(this.global.location.search);if("tfjsflags"in e){e.tfjsflags.split(",").forEach(e=>{const[t,n]=e.split(":");this.urlFlags[t]=function(e,t){if("true"===(t=t.toLowerCase())||"false"===t)return"true"===t;if(""+ +t===t)return+t;throw new Error(`Could not parse value flag value ${t} for flag ${e}.`)}(t,n)})}}}function n(){return e.ENV}let r;function o(){if(null==r){let e;if("undefined"!=typeof window)e=window;else if("undefined"!=typeof global)e=global;else if("undefined"!=typeof process)e=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");e=self}r=e}return r}function s(e,t){const n=function(){const e=o();return null==e._tfGlobals&&(e._tfGlobals=new Map),e._tfGlobals}();if(n.has(e))return n.get(e);{const r=t();return n.set(e,r),n.get(e)}}e.ENV=null;const a=s("kernelRegistry",()=>new Map),i=s("gradRegistry",()=>new Map);function u(e,t){const n=p(e,t);return a.get(n)}function l(e){return i.get(e)}function c(e){const t=a.entries(),n=[];for(;;){const{done:r,value:o}=t.next();if(r)break;const[s,a]=o,[i]=s.split("_");i===e&&n.push(a)}return n}function h(e){const{kernelName:t}=e;i.has(t)&&n().getBool("DEBUG")&&console.warn(`Overriding the gradient for '${t}'`),i.set(t,e)}function p(e,t){return`${t}_${e}`}function d(e){let t=e.length,n=0,r=0;for(;t>0;)r=Math.random()*t|0,t--,n=e[t],e[t]=e[r],e[r]=n}function f(e,t,n){return Math.max(e,Math.min(t,n))}function m(e,t){if(!e)throw new Error("string"==typeof t?t:t())}function g(e,t,n=""){m(k(e,t),()=>n+` Shapes ${e} and ${t} must match`)}function b(e){m(null!=e,()=>"The input to the tensor constructor must be a non-null value.")}function y(e,t=[],n=!1){if(null==t&&(t=[]),Array.isArray(e)||M(e)&&!n)for(let r=0;r<e.length;++r)y(e[r],t,n);else t.push(e);return t}function w(e){if(0===e.length)return 1;let t=e[0];for(let n=1;n<e.length;n++)t*=e[n];return t}function k(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(e.length!==t.length)return!1;for(let n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function v(e){return e%1==0}function x(e,t){return t<=e.length?e:e+" ".repeat(t-e.length)}function S(e,t){let n=1,r=-1;for(let t=0;t<e.length;++t)if(e[t]>=0)n*=e[t];else if(-1===e[t]){if(-1!==r)throw Error(`Shapes can only have 1 implicit size. Found -1 at dim ${r} and dim ${t}`);r=t}else if(e[t]<0)throw Error(`Shapes can not be < 0. Found ${e[t]} at dim ${t}`);if(-1===r){if(t>0&&t!==n)throw Error(`Size(${t}) must match the product of shape ${e}`);return e}if(0===n)throw Error(`Cannot infer the missing size in [${e}] when there are 0 elements`);if(t%n!=0)throw Error(`The implicit shape can't be a fractional number. Got ${t} / ${n}`);const o=e.slice();return o[r]=t/n,o}function E(e,t){const n=t.length;return m((e=null==e?t.map((e,t)=>t):[].concat(e)).every(e=>e>=-n&&e<n),()=>`All values in axis param must be in range [-${n}, ${n}) but got axis `+e),m(e.every(e=>v(e)),()=>"All values in axis param must be integers but got axis "+e),e.map(e=>e<0?n+e:e)}function D(e,t){const n=[],r=[],o=null!=t&&Array.isArray(t)&&0===t.length,s=null==t||o?null:E(t,e).sort();let a=0;for(let t=0;t<e.length;++t){if(null!=s){if(s[a]===t&&1!==e[t])throw new Error(`Can't squeeze axis ${t} since its dim '${e[t]}' is not 1`);(null==s[a]||s[a]>t)&&1===e[t]&&(n.push(e[t]),r.push(t)),s[a]<=t&&a++}1!==e[t]&&(n.push(e[t]),r.push(t))}return{newShape:n,keptDims:r}}function N(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else{if("bool"!==e)throw new Error("Unknown data type "+e);n=new Uint8Array(t)}return n}function I(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else if("bool"===e)n=new Uint8Array(t);else{if("string"!==e)throw new Error("Unknown data type "+e);n=new Array(t)}return n}function F(e,t){for(let n=0;n<e.length;n++){const r=e[n];if(isNaN(r)||!isFinite(r))throw Error(`A tensor of type ${t} being uploaded contains ${r}.`)}}function A(e){return"bool"===e||"complex64"===e||"float32"===e||"int32"===e||"string"===e}function T(e,t){return"complex64"!==t&&(("float32"!==t||"complex64"===e)&&(("int32"!==t||"float32"===e||"complex64"===e)&&("bool"!==t||"bool"!==e)))}function M(e){return e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array}function $(e){if("float32"===e||"int32"===e)return 4;if("complex64"===e)return 8;if("bool"===e)return 1;throw new Error("Unknown dtype "+e)}function _(e){if(null==e)return 0;let t=0;return e.forEach(e=>t+=e.length),t}function B(e){return"string"==typeof e||e instanceof String}function C(e){return"boolean"==typeof e}function R(e){return"number"==typeof e}function P(e){return Array.isArray(e)?P(e[0]):e instanceof Float32Array?"float32":e instanceof Int32Array||e instanceof Uint8Array?"int32":R(e)?"float32":B(e)?"string":C(e)?"bool":"float32"}function z(e){return!!(e&&e.constructor&&e.call&&e.apply)}function L(e,t){for(let n=t;n<e;++n)if(e%n==0)return n;return e}function q(e){const t=e.length;if(t<2)return[];const n=new Array(t-1);n[t-2]=e[t-1];for(let r=t-3;r>=0;--r)n[r]=n[r+1]*e[r+1];return n}function O(e,t){if("string"===t)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(e)&&(e=y(e)),n().getBool("DEBUG")&&F(e,t),function(e,t){return e instanceof Float32Array&&"float32"===t||e instanceof Int32Array&&"int32"===t||e instanceof Uint8Array&&"bool"===t}(e,t))return e;if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t){const t=new Uint8Array(e.length);for(let n=0;n<t.length;++n)0!==Math.round(e[n])&&(t[n]=1);return t}throw new Error("Unknown data type "+t)}function W(e,t){if(0===e.length)return t[0];const n=e.reduce((e,t)=>e*t);if(0===n)return[];if(n!==t.length)throw new Error(`[${e}] does not match the input size ${t.length}.`);return function e(t,n,r){const o=new Array;if(1===n.length){const e=n[0];for(let n=0;n<e;n++)o[n]=r[t+n]}else{const s=n[0],a=n.slice(1),i=a.reduce((e,t)=>e*t);for(let n=0;n<s;n++)o[n]=e(t+n*i,a,r)}return o}(0,e,t)}function K(e,t){const n=G(e,t);for(let e=0;e<n.length;e++)n[e]=1;return n}function G(e,t){if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t)return new Uint8Array(e);throw new Error("Unknown data type "+t)}function U(){return n().platform.now()}function V(e){e.forEach(t=>{m(Number.isInteger(t)&&t>=0,()=>`Tensor must have a shape comprised of positive integers but got shape [${e}].`)})}function H(e,t="utf-8"){return t=t||"utf-8",n().platform.encode(e,t)}function j(e,t="utf-8"){return t=t||"utf-8",n().platform.decode(e,t)}var J=Object.freeze({__proto__:null,shuffle:d,clamp:f,nearestLargerEven:function(e){return e%2==0?e:e+1},sum:function(e){let t=0;for(let n=0;n<e.length;n++)t+=e[n];return t},randUniform:function(e,t){const n=Math.random();return t*n+(1-n)*e},distSquared:function(e,t){let n=0;for(let r=0;r<e.length;r++){const o=Number(e[r])-Number(t[r]);n+=o*o}return n},assert:m,assertShapesMatch:g,assertNonNull:b,flatten:y,sizeFromShape:w,isScalarShape:function(e){return 0===e.length},arraysEqual:k,isInt:v,tanh:function(e){if(null!=Math.tanh)return Math.tanh(e);if(e===1/0)return 1;if(e===-1/0)return-1;{const t=Math.exp(2*e);return(t-1)/(t+1)}},sizeToSquarishShape:function(e){const t=Math.ceil(Math.sqrt(e));return[t,Math.ceil(e/t)]},createShuffledIndices:function(e){const t=new Uint32Array(e);for(let n=0;n<e;++n)t[n]=n;return d(t),t},rightPad:x,repeatedTry:function(e,t=(e=>0),n){return new Promise((r,o)=>{let s=0;const a=()=>{if(e())return void r();s++;const i=t(s);null!=n&&s>=n?o():setTimeout(a,i)};a()})},inferFromImplicitShape:S,parseAxisParam:E,squeezeShape:D,getTypedArrayFromDType:N,getArrayFromDType:I,checkConversionForErrors:F,isValidDtype:A,hasEncodingLoss:T,isTypedArray:M,bytesPerElement:$,bytesFromStringArray:_,isString:B,isBoolean:C,isNumber:R,inferDtype:P,isFunction:z,nearestDivisor:L,computeStrides:q,toTypedArray:O,toNestedArray:W,makeOnesTypedArray:K,makeZerosTypedArray:G,makeZerosNestedTypedArray:function(e,t){const n=e.reduce((e,t)=>e*t,1);if(null==t||"float32"===t)return W(e,new Float32Array(n));if("int32"===t)return W(e,new Int32Array(n));if("bool"===t)return W(e,new Uint8Array(n));throw new Error("Unknown data type "+t)},now:U,assertNonNegativeIntegerDimensions:V,fetch:function(e,t){return n().platform.fetch(e,t)},encodeString:H,decodeString:j,locToIndex:function(e,t,n){if(0===t)return 0;if(1===t)return e[0];let r=e[e.length-1];for(let t=0;t<e.length-1;++t)r+=n[t]*e[t];return r},indexToLoc:function(e,t,n){if(0===t)return[];if(1===t)return[e];const r=new Array(t);for(let t=0;t<r.length-1;++t)r[t]=Math.floor(e/n[t]),e-=r[t]*n[t];return r[r.length-1]=e,r}});class Y{constructor(e,t){this.backendTimer=e,this.logger=t,null==t&&(this.logger=new X)}profileKernel(e,t,n){let r;const o=this.backendTimer.time(()=>{r=n()});for(let t=0;t<r.length;t++){const n=r[t];n.data().then(t=>{Z(t,n.dtype,e)})}return{kernelName:e,outputs:r,inputs:t,timeMs:o.then(e=>e.kernelMs),extraInfo:o.then(e=>null!=e.getExtraProfileInfo?e.getExtraProfileInfo():"")}}logKernelProfile(e){const{kernelName:t,outputs:n,timeMs:r,inputs:o,extraInfo:s}=e;n.forEach(e=>{Promise.all([e.data(),r,s]).then(n=>{this.logger.logKernelProfile(t,e,n[0],n[1],o,n[2])})})}}function Z(e,t,n){if("float32"!==t)return!1;for(let t=0;t<e.length;t++){const r=e[t];if(isNaN(r)||!isFinite(r))return console.warn(`Found ${r} in the result of '${n}'`),!0}return!1}class X{logKernelProfile(e,t,n,r,o,s){const a="number"==typeof r?x(r+"ms",9):r.error,i=x(e,25),u=t.rank,l=t.size,c=x(t.shape.toString(),14);let h="";for(const e in o){const n=o[e];if(null!=n){const r=n.shape||t.shape,o=r.length;h+=`${e}: ${o}D ${o>0?r:""} `}}console.log(`%c${i}\t%c${a}\t%c${u}D ${c}\t%c${l}\t%c${h}\t%c${s}`,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")}}function Q(e,t,n,r){const o=q(t),s=function(e,t,n,r){const o=w(t),s=r[r.length-1],a=new Array(s).fill(0),i=t.length,u="complex64"===n?ne(e):e;if(i>1)for(let e=0;e<o/s;e++){const t=e*s;for(let e=0;e<s;e++)a[e]=Math.max(a[e],ee(u[t+e],0,n).length)}return a}(e,t,n,o),a=t.length,i=function e(t,n,r,o,s,a=!0){const i="complex64"===r?2:1,u=n[0],l=n.length;if(0===l){if("complex64"===r){return[ee(ne(t)[0],0,r)]}return"bool"===r?[te(t[0])]:[t[0].toString()]}if(1===l){if(u>20){const e=3*i;let n=Array.from(t.slice(0,e)),o=Array.from(t.slice((u-3)*i,u*i));return"complex64"===r&&(n=ne(n),o=ne(o)),["["+n.map((e,t)=>ee(e,s[t],r)).join(", ")+", ..., "+o.map((e,t)=>ee(e,s[u-3+t],r)).join(", ")+"]"]}return["["+("complex64"===r?ne(t):Array.from(t)).map((e,t)=>ee(e,s[t],r)).join(", ")+"]"]}const c=n.slice(1),h=o.slice(1),p=o[0]*i,d=[];if(u>20){for(let n=0;n<3;n++){const o=n*p,a=o+p;d.push(...e(t.slice(o,a),c,r,h,s,!1))}d.push("...");for(let n=u-3;n<u;n++){const o=n*p,a=o+p;d.push(...e(t.slice(o,a),c,r,h,s,n===u-1))}}else for(let n=0;n<u;n++){const o=n*p,a=o+p;d.push(...e(t.slice(o,a),c,r,h,s,n===u-1))}const f=2===l?",":"";d[0]="["+d[0]+f;for(let e=1;e<d.length-1;e++)d[e]=" "+d[e]+f;let m=",\n";for(let e=2;e<l;e++)m+="\n";return d[d.length-1]=" "+d[d.length-1]+"]"+(a?"":m),d}(e,t,n,o,s),u=["Tensor"];return r&&(u.push("  dtype: "+n),u.push("  rank: "+a),u.push(`  shape: [${t}]`),u.push("  values:")),u.push(i.map(e=>"    "+e).join("\n")),u.join("\n")}function ee(e,t,n){let r;return r=Array.isArray(e)?parseFloat(e[0].toFixed(7))+" + "+parseFloat(e[1].toFixed(7))+"j":B(e)?`'${e}'`:"bool"===n?te(e):parseFloat(e.toFixed(7)).toString(),x(r,t)}function te(e){return 0===e?"false":"true"}function ne(e){const t=[];for(let n=0;n<e.length;n+=2)t.push([e[n],e[n+1]]);return t}class re{constructor(e,t,n){if(this.dtype=t,this.shape=e.slice(),this.size=w(e),null!=n){const e=n.length;m(e===this.size,()=>`Length of values '${e}' does not match the size inferred by the shape '${this.size}'.`)}if("complex64"===t)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||I(t,this.size),this.strides=q(e)}set(e,...t){0===t.length&&(t=[0]),m(t.length===this.rank,()=>`The number of provided coordinates (${t.length}) must match the rank (${this.rank})`);const n=this.locToIndex(t);this.values[n]=e}get(...e){0===e.length&&(e=[0]);let t=0;for(const n of e){if(n<0||n>=this.shape[t]){const t=`Requested out of range element at ${e}.   Buffer shape=`+this.shape;throw new Error(t)}t++}let n=e[e.length-1];for(let t=0;t<e.length-1;++t)n+=this.strides[t]*e[t];return this.values[n]}locToIndex(e){if(0===this.rank)return 0;if(1===this.rank)return e[0];let t=e[e.length-1];for(let n=0;n<e.length-1;++n)t+=this.strides[n]*e[n];return t}indexToLoc(e){if(0===this.rank)return[];if(1===this.rank)return[e];const t=new Array(this.shape.length);for(let n=0;n<t.length-1;++n)t[n]=Math.floor(e/this.strides[n]),e-=t[n]*this.strides[n];return t[t.length-1]=e,t}get rank(){return this.shape.length}toTensor(){return oe().makeTensor(this.values,this.shape,this.dtype)}}let oe=null,se=null;class ae{constructor(e,t,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=e.slice(),this.dtype=t||"float32",this.size=w(e),this.strides=q(e),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}get rank(){return this.shape.length}async buffer(){const e=await this.data();return se.buffer(this.shape,this.dtype,e)}bufferSync(){return se.buffer(this.shape,this.dtype,this.dataSync())}async array(){const e=await this.data();return W(this.shape,e)}arraySync(){return W(this.shape,this.dataSync())}async data(){this.throwIfDisposed();const e=oe().read(this.dataId);if("string"===this.dtype){const t=await e;try{return t.map(e=>j(e))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}}return e}dataSync(){this.throwIfDisposed();const e=oe().readSync(this.dataId);if("string"===this.dtype)try{return e.map(e=>j(e))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return e}async bytes(){this.throwIfDisposed();const e=await oe().read(this.dataId);return"string"===this.dtype?e:new Uint8Array(e.buffer)}dispose(){this.isDisposed||(oe().disposeTensor(this),this.isDisposedInternal=!0)}get isDisposed(){return this.isDisposedInternal}throwIfDisposed(){if(this.isDisposed)throw new Error("Tensor is disposed.")}print(e=!1){return se.print(this,e)}clone(){return this.throwIfDisposed(),se.clone(this)}toString(e=!1){return Q(this.dataSync(),this.shape,this.dtype,e)}cast(e){return this.throwIfDisposed(),se.cast(this,e)}variable(e=!0,t,n){return this.throwIfDisposed(),oe().makeVariable(this,e,t,n)}}Object.defineProperty(ae,Symbol.hasInstance,{value:e=>!!e&&null!=e.data&&null!=e.dataSync&&null!=e.throwIfDisposed});class ie extends ae{constructor(e,t,n,r){super(e.shape,e.dtype,e.dataId,r),this.trainable=t,this.name=n}assign(e){if(e.dtype!==this.dtype)throw new Error(`dtype of the new value (${e.dtype}) and previous value (${this.dtype}) must match`);if(!k(e.shape,this.shape))throw new Error(`shape of the new value (${e.shape}) and previous value (${this.shape}) must match`);oe().disposeTensor(this),this.dataId=e.dataId,oe().incRef(this,null)}dispose(){oe().disposeVariable(this),this.isDisposedInternal=!0}}var ue,le,ce,he,pe;Object.defineProperty(ie,Symbol.hasInstance,{value:e=>e instanceof ae&&null!=e.assign&&e.assign instanceof Function}),(ue=e.Rank||(e.Rank={})).R0="R0",ue.R1="R1",ue.R2="R2",ue.R3="R3",ue.R4="R4",ue.R5="R5",ue.R6="R6",function(e){e.float32="float32",e.int32="int32",e.bool="int32",e.complex64="complex64"}(le||(le={})),function(e){e.float32="float32",e.int32="int32",e.bool="bool",e.complex64="complex64"}(ce||(ce={})),function(e){e.float32="float32",e.int32="float32",e.bool="float32",e.complex64="complex64"}(he||(he={})),function(e){e.float32="complex64",e.int32="complex64",e.bool="complex64",e.complex64="complex64"}(pe||(pe={}));const de={float32:he,int32:le,bool:ce,complex64:pe};function fe(e,t){if("string"===e||"string"===t){if("string"===e&&"string"===t)return"string";throw new Error(`Can not upcast ${e} with ${t}`)}return de[e][t]}function me(e,t){if(e.dtype===t.dtype)return[e,t];const n=fe(e.dtype,t.dtype);return[e.cast(n),t.cast(n)]}function ge(e,t){m(e.dtype===t.dtype,()=>`The dtypes of the first(${e.dtype}) and second(${t.dtype}) input must match`)}function be(e){const t=[];return function e(t,n,r){if(null==t)return;if(t instanceof ae)return void n.push(t);if(o=t,!Array.isArray(o)&&"object"!=typeof o)return;var o;const s=t;for(const t in s){const o=s[t];r.has(o)||(r.add(o),e(o,n,r))}}(e,t,new Set),t}var ye=Object.freeze({__proto__:null,makeTypesMatch:me,assertTypesMatch:ge,isTensorInList:function(e,t){return t.some(t=>t.id===e.id)},getTensorsInContainer:be});class we{constructor(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null}}dispose(){for(const e in this.registeredVariables)this.registeredVariables[e].dispose()}}class ke{constructor(e){this.ENV=e,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new we}async ready(){if(null!=this.pendingBackendInit)return this.pendingBackendInit.then(()=>{});if(null!=this.backendInstance)return;const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t];if(await this.initializeBackend(n).success)return void await this.setBackend(n)}throw new Error("Could not initialize any backends, all backend initializations failed.")}get backend(){if(null!=this.pendingBackendInit)throw new Error(`Backend '${this.backendName}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);if(null==this.backendInstance){const{name:e,asyncInit:t}=this.initializeBackendsAndReturnBest();if(t)throw new Error(`The highest priority backend '${e}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);this.setBackend(e)}return this.backendInstance}backendNames(){return Object.keys(this.registryFactory)}findBackend(e){if(!(e in this.registry)){if(!(e in this.registryFactory))return null;{const{asyncInit:t}=this.initializeBackend(e);if(t)return null}}return this.registry[e]}findBackendFactory(e){return e in this.registryFactory?this.registryFactory[e].factory:null}registerBackend(e,t,n=1){return e in this.registryFactory?(console.warn(e+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[e]={factory:t,priority:n},!0)}async setBackend(e){if(null==this.registryFactory[e])throw new Error(`Backend name '${e}' not found in registry`);if(this.backendName=e,null==this.registry[e]){this.backendInstance=null;const{success:t,asyncInit:n}=this.initializeBackend(e);if(!(n?await t:t))return!1}return this.backendInstance=this.registry[e],this.setupRegisteredKernels(),this.profiler=new Y(this.backendInstance),!0}setupRegisteredKernels(){c(this.backendName).forEach(e=>{null!=e.setupFunc&&e.setupFunc(this.backendInstance)})}disposeRegisteredKernels(e){c(e).forEach(t=>{null!=t.disposeFunc&&t.disposeFunc(this.registry[e])})}initializeBackend(e){const t=this.registryFactory[e];if(null==t)throw new Error(`Cannot initialize backend ${e}, no registration found.`);try{const n=t.factory();if(Promise.resolve(n)===n){const t=++this.pendingBackendInitId,r=n.then(n=>!(t<this.pendingBackendInitId)&&(this.registry[e]=n,this.pendingBackendInit=null,!0)).catch(n=>(t<this.pendingBackendInitId||(this.pendingBackendInit=null,console.warn(`Initialization of backend ${e} failed`),console.warn(n.stack||n.message)),!1));return this.pendingBackendInit=r,{success:r,asyncInit:!0}}return this.registry[e]=n,{success:!0,asyncInit:!1}}catch(t){return console.warn(`Initialization of backend ${e} failed`),console.warn(t.stack||t.message),{success:!1,asyncInit:!1}}}removeBackend(e){if(!(e in this.registryFactory))throw new Error(e+" backend not found in registry");this.backendName===e&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,e in this.registry&&(this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e]),delete this.registryFactory[e],this.backendName===e&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)}getSortedBackends(){if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((e,t)=>this.registryFactory[t].priority-this.registryFactory[e].priority)}initializeBackendsAndReturnBest(){const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t],{success:r,asyncInit:o}=this.initializeBackend(n);if(o||r)return{name:n,asyncInit:o}}throw new Error("Could not initialize any backends, all backend initializations failed.")}moveData(e,t){const n=this.state.tensorInfo.get(t),r=n.backend,o=this.readSync(t);r.disposeData(t),n.backend=e,e.move(t,o,n.shape,n.dtype),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++}tidy(e,t){let n,r=null;if(null==t){if("function"!=typeof e)throw new Error("Please provide a function to tidy()");t=e}else{if("string"!=typeof e&&!(e instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof t)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");r=e}return this.scopedRun(()=>this.startScope(r),()=>this.endScope(n),()=>(n=t(),n instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n))}scopedRun(e,t,n){e();try{const e=n();return t(),e}catch(e){throw t(),e}}nextTensorId(){return ke.nextTensorId++}nextVariableId(){return ke.nextVariableId++}clone(e){const t=this.makeTensorFromDataId(e.dataId,e.shape,e.dtype),n={x:e};return this.addTapeNode(this.state.activeScope.name,n,[t],e=>({x:()=>{const t={x:e},n={dtype:"float32"};return xe.runKernelFunc(t=>t.cast(e,"float32"),t,null,"Cast",n)}}),[],{}),t}runKernel(e,t,n,r,o){return this.runKernelFunc(null,t,null,e,n,r,o)}shouldCheckForMemLeaks(){return this.ENV.getBool("IS_TEST")}checkKernelForMemLeak(e,t,n){const r=this.backend.numDataIds();let o=0;n.forEach(e=>{o+="complex64"===e.dtype?3:1});const s=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],a=r-t-o-s;if(a>0)throw new Error(`Backend '${this.backendName}' has an internal memory leak (${a} data ids) after running '${e}'`)}runKernelFunc(e,t,n,r,o,s,a){let i,l=[];const c=this.isTapeOn();null==r&&(r=null!=this.state.activeScope?this.state.activeScope.name:"");const h=this.state.numBytes,p=this.state.numTensors;let d;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0);const f=u(r,this.backendName);let m,g;if(null!=f)d=()=>{const e=this.backend.numDataIds();m=f.kernelFunc({inputs:t,attrs:o,backend:this.backend});const n=Array.isArray(m)?m:[m];this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(r,e,n);const i=n.map(({dataId:e,shape:t,dtype:n})=>this.makeTensorFromDataId(e,t,n));if(c){let e=this.getTensorsForGradient(r,t,i);if(null==e){null==a&&(a=[]);const t=i.filter((e,t)=>a[t]);e=(s||[]).slice().concat(t)}l=this.saveTensorsForBackwardMode(e)}return i};else{const t=e=>{c&&(l=e.map(e=>this.keep(this.clone(e))))};d=()=>{const n=this.backend.numDataIds();m=this.tidy(()=>e(this.backend,t));const o=Array.isArray(m)?m:[m];return this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(r,n,o),o}}return this.scopedRun(()=>this.state.kernelDepth++,()=>this.state.kernelDepth--,()=>{this.ENV.getBool("DEBUG")||this.state.profiling?(g=this.profiler.profileKernel(r,t,()=>d()),this.ENV.getBool("DEBUG")&&this.profiler.logKernelProfile(g),i=g.outputs):i=d()}),c&&this.addTapeNode(r,t,i,n,l,o),this.state.profiling&&this.state.activeProfile.kernels.push({name:r,bytesAdded:this.state.numBytes-h,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-p,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(t).map(e=>null!=t[e]?t[e].shape:null),outputShapes:i.map(e=>e.shape),kernelTimeMs:g.timeMs,extraInfo:g.extraInfo}),Array.isArray(m)?i:i[0]}saveTensorsForBackwardMode(e){return e.map(e=>this.keep(this.clone(e)))}getTensorsForGradient(e,t,n){const r=l(e);if(null!=r){const e=r.inputsToSave||[],o=r.outputsToSave||[];let s;r.saveAllInputs?(m(Array.isArray(t),()=>"saveAllInputs is true, expected inputs to be an array."),s=Object.keys(t).map(e=>t[e])):s=e.map(e=>t[e]);const a=n.filter((e,t)=>o[t]);return s.concat(a)}return null}makeTensor(e,t,n,r){if(null==e)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;let o=e;"string"===n&&B(e[0])&&(o=e.map(e=>H(e)));const s=r.write(o,t,n),a=new ae(t,n,s,this.nextTensorId());if(this.incRef(a,r),"string"===n){const e=this.state.tensorInfo.get(s),t=_(o);this.state.numBytes+=t-e.bytes,e.bytes=t}return a}makeTensorFromDataId(e,t,n,r){const o=new ae(t,n=n||"float32",e,this.nextTensorId());return this.incRef(o,r),o}makeVariable(e,t=!0,n,r){n=n||this.nextVariableId().toString(),null!=r&&r!==e.dtype&&(e=e.cast(r));const o=new ie(e,t,n,this.nextTensorId());if(null!=this.state.registeredVariables[o.name])throw new Error(`Variable with name ${o.name} was already registered`);return this.state.registeredVariables[o.name]=o,this.incRef(o,this.backend),o}incRef(e,t){const n=this.state.tensorInfo.has(e.dataId)?this.state.tensorInfo.get(e.dataId).refCount:0;if(this.state.numTensors++,"string"===e.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;let n=0;"complex64"!==e.dtype&&"string"!==e.dtype&&(n=e.size*$(e.dtype)),this.state.tensorInfo.set(e.dataId,{backend:t||this.backend,dtype:e.dtype,shape:e.shape,bytes:n,refCount:0}),this.state.numBytes+=n}this.state.tensorInfo.get(e.dataId).refCount++,e instanceof ie||this.track(e)}disposeTensor(e){if(!this.state.tensorInfo.has(e.dataId))return;this.state.numTensors--,"string"===e.dtype&&this.state.numStringTensors--;const t=this.state.tensorInfo.get(e.dataId);t.refCount<=1?("complex64"!==e.dtype&&(this.state.numBytes-=t.bytes),this.state.numDataBuffers--,t.backend.disposeData(e.dataId),this.state.tensorInfo.delete(e.dataId)):this.state.tensorInfo.get(e.dataId).refCount--}disposeVariables(){for(const e in this.state.registeredVariables){const t=this.state.registeredVariables[e];this.disposeVariable(t)}}disposeVariable(e){this.disposeTensor(e),null!=this.state.registeredVariables[e.name]&&delete this.state.registeredVariables[e.name]}memory(){const e=this.backend.memory();return e.numTensors=this.state.numTensors,e.numDataBuffers=this.state.numDataBuffers,e.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(e.unreliable=!0,null==e.reasons&&(e.reasons=[]),e.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),e}async profile(e){this.state.profiling=!0;const t=this.state.numBytes,n=this.state.numTensors;this.state.activeProfile.kernels=[],this.state.activeProfile.result=await e(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max(...this.state.activeProfile.kernels.map(e=>e.totalBytesSnapshot)),this.state.activeProfile.newBytes=this.state.numBytes-t,this.state.activeProfile.newTensors=this.state.numTensors-n;for(const e of this.state.activeProfile.kernels)e.kernelTimeMs=await e.kernelTimeMs,e.extraInfo=await e.extraInfo;return this.state.activeProfile}isTapeOn(){return this.state.gradientDepth>0&&0===this.state.kernelDepth}addTapeNode(e,t,n,r,o,s){const a={id:this.state.nextTapeNodeId++,kernelName:e,inputs:t,outputs:n,saved:o},i=l(e);null!=i&&(r=i.gradFunc),null!=r&&(a.gradient=e=>(e=e.map((e,t)=>{if(null==e){const e=n[t],r=G(e.size,e.dtype);return this.makeTensor(r,e.shape,e.dtype)}return e}),r(e.length>1?e:e[0],o,s))),this.state.activeTape.push(a)}keep(e){return e.kept=!0,e}startTape(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++}endTape(){this.state.gradientDepth--}startScope(e){const t={track:[],name:"unnamed scope",id:this.state.nextScopeId++};e&&(t.name=e),this.state.scopeStack.push(t),this.state.activeScope=t}endScope(e){const t=be(e),n=new Set(t.map(e=>e.id));for(let e=0;e<this.state.activeScope.track.length;e++){const t=this.state.activeScope.track[e];t.kept||n.has(t.id)||t.dispose()}const r=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],t.forEach(e=>{e.kept||e.scopeId!==r.id||this.track(e)})}gradients(e,t,n,r=!1){if(m(t.length>0,()=>"gradients() received an empty list of xs."),null!=n&&"float32"!==n.dtype)throw new Error(`dy must have 'float32' dtype, but has '${n.dtype}'`);const o=this.scopedRun(()=>this.startTape(),()=>this.endTape(),()=>this.tidy("forward",e));m(o instanceof ae,()=>"The result y returned by f() must be a tensor.");const s=function(e,t,n){const r={},o={};for(let e=0;e<t.length;e++)r[t[e].id]=!0;for(let n=0;n<e.length;n++){const s=e[n],a=s.inputs;for(const e in a){const n=a[e];let i=!1;for(let e=0;e<t.length;e++)if(r[n.id]){s.outputs.forEach(e=>r[e.id]=!0),i=!0,o[s.id]=!0;break}if(i)break}}const s={};s[n.id]=!0;const a={};for(let t=e.length-1;t>=0;t--){const n=e[t],r=n.inputs;for(let e=0;e<n.outputs.length;e++)if(s[n.outputs[e].id]){for(const e in r)s[r[e].id]=!0,a[n.id]=!0;break}}const i=[];for(let t=0;t<e.length;t++){const n=e[t];if(o[n.id]&&a[n.id]){const e={};for(const t in n.inputs){const o=n.inputs[t];r[o.id]&&(e[t]=o)}const t=Object.assign({},n);t.inputs=e,t.outputs=n.outputs,i.push(t)}}return i}(this.state.activeTape,t,o);if(!r&&0===s.length&&t.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",()=>{const e={};e[o.id]=null==n?function(e){const t=K(w(e),"float32");return xe.makeTensor(t,e,"float32")}(o.shape):n,function(e,t,n,r){for(let o=t.length-1;o>=0;o--){const s=t[o],a=[];if(s.outputs.forEach(t=>{const n=e[t.id];null!=n?a.push(n):a.push(null)}),null==s.gradient)throw new Error(`Cannot compute gradient: gradient function not found for ${s.kernelName}.`);const i=s.gradient(a);for(const t in s.inputs){if(!(t in i))throw new Error(`Cannot backprop through input ${t}. Available gradients found: ${Object.keys(i)}.`);const o=n(()=>i[t]());if("float32"!==o.dtype)throw new Error(`Error in gradient for op ${s.kernelName}. The gradient of input ${t} must have 'float32' dtype, but has '${o.dtype}'`);const a=s.inputs[t];if(!k(o.shape,a.shape))throw new Error(`Error in gradient for op ${s.kernelName}. The gradient of input '${t}' has shape '${o.shape}', which does not match the shape of the input '${a.shape}'`);if(null==e[a.id])e[a.id]=o;else{const t=e[a.id];e[a.id]=r(t,o),t.dispose()}}}}(e,s,e=>this.tidy(e),Se);const r=t.map(t=>e[t.id]);return 0===this.state.gradientDepth&&(this.state.activeTape.forEach(e=>{for(const t of e.saved)t.dispose()}),this.state.activeTape=null),{value:o,grads:r}})}customGrad(e){return m(z(e),()=>"The f passed in customGrad(f) must be a function."),(...t)=>{let n;m(t.every(e=>e instanceof ae),()=>"The args passed in customGrad(f)(x1, x2,...) must all be tensors");const r={};return t.forEach((e,t)=>{r[t]=e}),this.runKernelFunc((r,o)=>(n=e(...t,o),m(n.value instanceof ae,()=>"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"),m(z(n.gradFunc),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."),n.value),r,(e,r)=>{const o=n.gradFunc(e,r),s=Array.isArray(o)?o:[o];m(s.length===t.length,()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."),m(s.every(e=>e instanceof ae),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors.");const a={};return s.forEach((e,t)=>{a[t]=()=>e}),a})}}readSync(e){return this.state.tensorInfo.get(e).backend.readSync(e)}read(e){return this.state.tensorInfo.get(e).backend.read(e)}async time(e){const t=U(),n=await this.backend.time(e);return n.wallMs=U()-t,n}track(e){return null!=this.state.activeScope&&(e.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(e)),e}get registeredVariables(){return this.state.registeredVariables}reset(){this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new we;for(const e in this.registry)this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null}}function ve(){const n=o();if(null==n._tfengine){const e=new t(n);n._tfengine=new ke(e)}var r;return r=n._tfengine.ENV,e.ENV=r,oe=()=>n._tfengine,n._tfengine}ke.nextTensorId=0,ke.nextVariableId=0;const xe=ve();function Se(e,t){const n={a:e,b:t};return xe.runKernelFunc((n,r)=>{const o=n.add(e,t);return r([e,t]),o},n,null,"Add")}function Ee(){return"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope}var De=Object.freeze({__proto__:null,isMobile:function(){if("undefined"!=typeof navigator&&null!=navigator){const e=navigator.userAgent||navigator.vendor||window.opera;return/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(e)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(e.substr(0,4))}return!1},isBrowser:Ee});const Ne=n();function Ie(e,t){let r=e;if(M(e))return"string"===t?[]:[e.length];if(!Array.isArray(e))return[];const o=[];for(;Array.isArray(r)||M(r)&&"string"!==t;)o.push(r.length),r=r[0];return Array.isArray(e)&&n().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&function e(t,n,r){if(r=r||[],!Array.isArray(t)&&!M(t))return void m(0===n.length,()=>`Element arr[${r.join("][")}] is a primitive, but should be an array/TypedArray of ${n[0]} elements`);m(n.length>0,()=>`Element arr[${r.join("][")}] should be a primitive, but is an array of ${t.length} elements`),m(t.length===n[0],()=>`Element arr[${r.join("][")}] should have ${n[0]} elements, but has ${t.length} elements`);const o=n.slice(1);for(let n=0;n<t.length;++n)e(t[n],o,r.concat(n))}(e,o,[]),o}function Fe(e,t,n,r){if(null!=e&&("numeric"!==e&&e!==t||"numeric"===e&&"string"===t))throw new Error(`Argument '${n}' passed to '${r}' must be ${e} tensor, but got ${t} tensor`)}function Ae(e,t,n,r="numeric"){if(e instanceof ae)return Fe(r,e.dtype,t,n),e;let o=P(e);if("string"!==o&&["bool","int32","float32"].indexOf(r)>=0&&(o=r),Fe(r,o,t,n),null==e||!M(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e){const r=null==e?"null":e.constructor.name;throw new Error(`Argument '${t}' passed to '${n}' must be a Tensor or TensorLike, but got '${r}'`)}const s=Ie(e,o);M(e)||Array.isArray(e)||(e=[e]);const a="string"!==o?O(e,o):y(e,[],!0);return xe.makeTensor(a,s,o)}function Te(e,t,n,r="numeric"){if(!Array.isArray(e))throw new Error(`Argument ${t} passed to ${n} must be a \`Tensor[]\` or \`TensorLike[]\``);return e.map((e,r)=>Ae(e,`${t}[${r}]`,n),r)}Ne.registerFlag("DEBUG",()=>!1,e=>{e&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")}),Ne.registerFlag("IS_BROWSER",()=>Ee()),Ne.registerFlag("IS_NODE",()=>"undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node),Ne.registerFlag("IS_CHROME",()=>"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)),Ne.registerFlag("PROD",()=>!1),Ne.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",()=>Ne.getBool("DEBUG")),Ne.registerFlag("DEPRECATION_WARNINGS_ENABLED",()=>!0),Ne.registerFlag("IS_TEST",()=>!1);function Me(e){const t=Object.keys(e);if(1!==t.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+t.length+" keys.");let n=t[0];const r=e[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+="__op";const o=(...e)=>{xe.startScope(n);try{const t=r(...e);return t instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),xe.endScope(t),t}catch(e){throw xe.endScope(null),e}};return Object.defineProperty(o,"name",{value:n,configurable:!0}),o}const $e=Me({complex_:function(e,t){const n=Ae(e,"real","complex"),r=Ae(t,"imag","complex");g(n.shape,r.shape,`real and imag shapes, ${n.shape} and ${r.shape}, must match in call to tf.complex().`);const o={real:n,imag:r};return xe.runKernelFunc(e=>e.complex(n,r),o,null,"Complex")}});function _e(e,t,n,r){if(null==r&&(r=P(e)),"complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!M(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=t){V(t);const e=w(t),r=w(n);m(e===r,()=>`Based on the provided shape, [${t}], the tensor should have ${e} values but has ${r}`);for(let e=0;e<n.length;++e){const r=n[e],o=e!==n.length-1||r!==w(t.slice(e));m(n[e]===t[e]||!o,()=>`Error creating a new Tensor. Inferred shape (${n}) does not match the provided shape (${t}). `)}}return M(e)||Array.isArray(e)||(e=[e]),t=t||n,e="string"!==r?O(e,r):y(e,[],!0),xe.makeTensor(e,t,r)}function Be(e,t,n){return _e(e,t,Ie(e,n),n)}const Ce={float32:4,float16:2,int32:4,uint16:2,uint8:1,bool:1,complex64:8};function Re(e,t){const n={};let r,o=0;for(const s of t){const t=s.name,a=s.dtype,i=s.shape,u=w(i);let l;if("quantization"in s){const n=s.quantization;if("uint8"===n.dtype||"uint16"===n.dtype){if(!("min"in n)||!("scale"in n))throw new Error(`Weight ${s.name} with quantization ${n.dtype} doesn't have corresponding metadata min and scale.`)}else{if("float16"!==n.dtype)throw new Error(`Weight ${s.name} has unknown quantization dtype ${n.dtype}. Supported quantization dtypes are: 'uint8', 'uint16', and 'float16'.`);if("float32"!==a)throw new Error(`Weight ${s.name} is quantized with ${n.dtype} which only supports weights of type float32 not ${a}.`)}const i=Ce[n.dtype],c=e.slice(o,o+u*i),h="uint8"===n.dtype?new Uint8Array(c):new Uint16Array(c);if("float32"===a)if("uint8"===n.dtype||"uint16"===n.dtype){l=new Float32Array(h.length);for(let e=0;e<h.length;e++){const t=h[e];l[e]=t*n.scale+n.min}}else{if("float16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type float32.`);void 0===r&&(r=Ke()),l=r(h)}else{if("int32"!==a)throw new Error(`Unsupported dtype in weight '${t}': ${a}`);if("uint8"!==n.dtype&&"uint16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type int32.`);l=new Int32Array(h.length);for(let e=0;e<h.length;e++){const t=h[e];l[e]=Math.round(t*n.scale+n.min)}}o+=u*i}else if("string"===a){const t=w(s.shape);l=[];for(let n=0;n<t;n++){const t=new Uint32Array(e.slice(o,o+4))[0];o+=4;const n=new Uint8Array(e.slice(o,o+t));l.push(n),o+=t}}else{const r=Ce[a],s=e.slice(o,o+u*r);if("float32"===a)l=new Float32Array(s);else if("int32"===a)l=new Int32Array(s);else if("bool"===a)l=new Uint8Array(s);else{if("complex64"!==a)throw new Error(`Unsupported dtype in weight '${t}': ${a}`);{l=new Float32Array(s);const e=new Float32Array(l.length/2),r=new Float32Array(l.length/2);for(let t=0;t<e.length;t++)e[t]=l[2*t],r[t]=l[2*t+1];const o=Be(e,i,"float32"),a=Be(r,i,"float32");n[t]=$e(o,a)}}o+=u*r}"complex64"!==a&&(n[t]=Be(l,i,a))}return n}function Pe(e){if(null===e)throw new Error("Invalid input value: "+JSON.stringify(e));let t=0;const n=[];e.forEach(e=>{if(t+=e.byteLength,n.push(e.byteLength===e.buffer.byteLength?e:new e.constructor(e)),!(e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+e.constructor.name)});const r=new Uint8Array(t);let o=0;return n.forEach(e=>{r.set(new Uint8Array(e.buffer),o),o+=e.byteLength}),r.buffer}const ze="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function Le(e){return ze?Buffer.byteLength(e):new Blob([e]).size}function qe(e){if(1===e.length)return e[0];let t=0;e.forEach(e=>{t+=e.byteLength});const n=new Uint8Array(t);let r=0;return e.forEach(e=>{n.set(new Uint8Array(e),r),r+=e.byteLength}),n.buffer}function Oe(e){for(e=e.trim();e.endsWith("/");)e=e.slice(0,e.length-1);const t=e.split("/");return t[t.length-1]}function We(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==e.modelTopology?0:Le(JSON.stringify(e.modelTopology)),weightSpecsBytes:null==e.weightSpecs?0:Le(JSON.stringify(e.weightSpecs)),weightDataBytes:null==e.weightData?0:e.weightData.byteLength}}function Ke(){const e=function(){const e=e=>{let t=e<<13,n=0;for(;0==(8388608&t);)n-=8388608,t<<=1;return t&=-8388609,n+=947912704,t|n},t=new Uint32Array(2048);t[0]=0;for(let n=1;n<1024;n++)t[n]=e(n);for(let e=1024;e<2048;e++)t[e]=939524096+(e-1024<<13);return t}(),t=function(){const e=new Uint32Array(64);e[0]=0,e[31]=1199570944,e[32]=2147483648,e[63]=3347054592;for(let t=1;t<31;t++)e[t]=t<<23;for(let t=33;t<63;t++)e[t]=2147483648+(t-32<<23);return e}(),n=function(){const e=new Uint32Array(64);for(let t=0;t<64;t++)e[t]=1024;return e[0]=e[32]=0,e}();return r=>{const o=new ArrayBuffer(4*r.length),s=new Uint32Array(o);for(let o=0;o<r.length;o++){const a=r[o],i=e[n[a>>10]+(1023&a)]+t[a>>10];s[o]=i}return new Float32Array(o)}}class Ge{constructor(){this.saveRouters=[],this.loadRouters=[]}static getInstance(){return null==Ge.instance&&(Ge.instance=new Ge),Ge.instance}static registerSaveRouter(e){Ge.getInstance().saveRouters.push(e)}static registerLoadRouter(e){Ge.getInstance().loadRouters.push(e)}static getSaveHandlers(e){return Ge.getHandlers(e,"save")}static getLoadHandlers(e,t){return Ge.getHandlers(e,"load",t)}static getHandlers(e,t,n){const r=[];return("load"===t?Ge.getInstance().loadRouters:Ge.getInstance().saveRouters).forEach(t=>{const o=t(e,n);null!==o&&r.push(o)}),r}}function Ue(){if(!n().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");const e="undefined"==typeof window?self:window,t=e.indexedDB||e.mozIndexedDB||e.webkitIndexedDB||e.msIndexedDB||e.shimIndexedDB;if(null==t)throw new Error("The current browser does not appear to support IndexedDB.");return t}function Ve(e){const t=e.result;t.createObjectStore("models_store",{keyPath:"modelPath"}),t.createObjectStore("model_info_store",{keyPath:"modelPath"})}class He{constructor(e){if(this.indexedDB=Ue(),null==e||!e)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=e}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return this.databaseAction(this.modelPath,e)}async load(){return this.databaseAction(this.modelPath)}databaseAction(e,t){return new Promise((e,n)=>{const r=this.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=()=>Ve(r),r.onsuccess=()=>{const o=r.result;if(null==t){const t=o.transaction("models_store","readonly"),r=t.objectStore("models_store").get(this.modelPath);r.onsuccess=()=>{if(null==r.result)return o.close(),n(new Error(`Cannot find model with path '${this.modelPath}' in IndexedDB.`));e(r.result.modelArtifacts)},r.onerror=e=>(o.close(),n(r.error)),t.oncomplete=()=>o.close()}else{const r=We(t),s=o.transaction("model_info_store","readwrite");let a=s.objectStore("model_info_store");const i=a.put({modelPath:this.modelPath,modelArtifactsInfo:r});let u;i.onsuccess=()=>{u=o.transaction("models_store","readwrite");const i=u.objectStore("models_store").put({modelPath:this.modelPath,modelArtifacts:t,modelArtifactsInfo:r});i.onsuccess=()=>e({modelArtifactsInfo:r}),i.onerror=e=>{a=s.objectStore("model_info_store");const t=a.delete(this.modelPath);t.onsuccess=()=>(o.close(),n(i.error)),t.onerror=e=>(o.close(),n(i.error))}},i.onerror=e=>(o.close(),n(i.error)),s.oncomplete=()=>{null==u?o.close():u.oncomplete=()=>o.close()}}},r.onerror=e=>n(r.error)})}}He.URL_SCHEME="indexeddb://";const je=e=>{return n().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(He.URL_SCHEME)?(t=e.slice(He.URL_SCHEME.length),new He(t)):null;var t};Ge.registerSaveRouter(je),Ge.registerLoadRouter(je);class Je{constructor(){this.indexedDB=Ue()}async listModels(){return new Promise((e,t)=>{const n=this.indexedDB.open("tensorflowjs",1);n.onupgradeneeded=()=>Ve(n),n.onsuccess=()=>{const r=n.result,o=r.transaction("model_info_store","readonly"),s=o.objectStore("model_info_store").getAll();s.onsuccess=()=>{const t={};for(const e of s.result)t[e.modelPath]=e.modelArtifactsInfo;e(t)},s.onerror=e=>(r.close(),t(s.error)),o.oncomplete=()=>r.close()},n.onerror=e=>t(n.error)})}async removeModel(e){var t;return e=(t=e).startsWith(He.URL_SCHEME)?t.slice(He.URL_SCHEME.length):t,new Promise((t,n)=>{const r=this.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=()=>Ve(r),r.onsuccess=()=>{const o=r.result,s=o.transaction("model_info_store","readwrite"),a=s.objectStore("model_info_store"),i=a.get(e);let u;i.onsuccess=()=>{if(null==i.result)return o.close(),n(new Error(`Cannot find model with path '${e}' in IndexedDB.`));{const r=a.delete(e),s=()=>{u=o.transaction("models_store","readwrite");const r=u.objectStore("models_store").delete(e);r.onsuccess=()=>t(i.result.modelArtifactsInfo),r.onerror=e=>n(i.error)};r.onsuccess=s,r.onerror=e=>(s(),o.close(),n(i.error))}},i.onerror=e=>(o.close(),n(i.error)),s.oncomplete=()=>{null==u?o.close():u.oncomplete=()=>o.close()}},r.onerror=e=>n(r.error)})}}const Ye="tensorflowjs_models",Ze="info",Xe="model_topology",Qe="weight_specs",et="weight_data",tt="model_metadata";function nt(e){return{info:[Ye,e,Ze].join("/"),topology:[Ye,e,Xe].join("/"),weightSpecs:[Ye,e,Qe].join("/"),weightData:[Ye,e,et].join("/"),modelMetadata:[Ye,e,tt].join("/")}}function rt(e){const t=e.split("/");if(t.length<3)throw new Error("Invalid key format: "+e);return t.slice(1,t.length-1).join("/")}class ot{constructor(e){if(!n().getBool("IS_BROWSER")||"undefined"==typeof window||void 0===window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==e||!e)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=e,this.keys=nt(this.modelPath)}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");{const t=JSON.stringify(e.modelTopology),n=JSON.stringify(e.weightSpecs),r=We(e);try{return this.LS.setItem(this.keys.info,JSON.stringify(r)),this.LS.setItem(this.keys.topology,t),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(e){if(ze)return Buffer.from(e).toString("base64");const t=new Uint8Array(e);let n="";for(let e=0,r=t.length;e<r;e++)n+=String.fromCharCode(t[e]);return btoa(n)}(e.weightData)),this.LS.setItem(this.keys.modelMetadata,JSON.stringify({format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,userDefinedMetadata:e.userDefinedMetadata})),{modelArtifactsInfo:r}}catch(e){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error(`Failed to save model '${this.modelPath}' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes=${r.modelTopologyBytes}, weightSpecsBytes=${r.weightSpecsBytes}, weightDataBytes=${r.weightDataBytes}.`)}}}async load(){const e=JSON.parse(this.LS.getItem(this.keys.info));if(null==e)throw new Error(`In local storage, there is no model with name '${this.modelPath}'`);if("JSON"!==e.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");const t={},n=JSON.parse(this.LS.getItem(this.keys.topology));if(null==n)throw new Error(`In local storage, the topology of model '${this.modelPath}' is missing.`);t.modelTopology=n;const r=JSON.parse(this.LS.getItem(this.keys.weightSpecs));if(null==r)throw new Error(`In local storage, the weight specs of model '${this.modelPath}' are missing.`);t.weightSpecs=r;const o=this.LS.getItem(this.keys.modelMetadata);if(null!=o){const e=JSON.parse(o);t.format=e.format,t.generatedBy=e.generatedBy,t.convertedBy=e.convertedBy,t.userDefinedMetadata=e.userDefinedMetadata}const s=this.LS.getItem(this.keys.weightData);if(null==s)throw new Error(`In local storage, the binary weight values of model '${this.modelPath}' are missing.`);return t.weightData=function(e){if(ze){const t=Buffer.from(e,"base64");return t.buffer.slice(t.byteOffset,t.byteOffset+t.byteLength)}const t=atob(e),n=new Uint8Array(t.length);for(let e=0;e<t.length;++e)n.set([t.charCodeAt(e)],e);return n.buffer}(s),t}}ot.URL_SCHEME="localstorage://";const st=e=>{return n().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(ot.URL_SCHEME)?(t=e.slice(ot.URL_SCHEME.length),new ot(t)):null;var t};Ge.registerSaveRouter(st),Ge.registerLoadRouter(st);class at{constructor(){m(n().getBool("IS_BROWSER"),()=>"Current environment is not a web browser"),m("undefined"==typeof window||void 0!==window.localStorage,()=>"Current browser does not appear to support localStorage"),this.LS=window.localStorage}async listModels(){const e={},t=Ye+"/",n="/"+Ze;for(let r=0;r<this.LS.length;++r){const o=this.LS.key(r);if(o.startsWith(t)&&o.endsWith(n)){e[rt(o)]=JSON.parse(this.LS.getItem(o))}}return e}async removeModel(e){var t;const n=nt(e=(t=e).startsWith(ot.URL_SCHEME)?t.slice(ot.URL_SCHEME.length):t);if(null==this.LS.getItem(n.info))throw new Error(`Cannot find model at path '${e}'`);const r=JSON.parse(this.LS.getItem(n.info));return this.LS.removeItem(n.info),this.LS.removeItem(n.topology),this.LS.removeItem(n.weightSpecs),this.LS.removeItem(n.weightData),r}}class it{constructor(){this.managers={}}static getInstance(){return null==it.instance&&(it.instance=new it),it.instance}static registerManager(e,t){m(null!=e,()=>"scheme must not be undefined or null."),e.endsWith("://")&&(e=e.slice(0,e.indexOf("://"))),m(e.length>0,()=>"scheme must not be an empty string.");const n=it.getInstance();m(null==n.managers[e],()=>`A model store manager is already registered for scheme '${e}'.`),n.managers[e]=t}static getManager(e){const t=this.getInstance().managers[e];if(null==t)throw new Error(`Cannot find model manager for scheme '${e}'`);return t}static getSchemes(){return Object.keys(this.getInstance().managers)}}function ut(e){if(-1===e.indexOf("://"))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+it.getSchemes().join(","));return{scheme:e.split("://")[0],path:e.split("://")[1]}}async function lt(e,t,n=!1){m(e!==t,()=>`Old path and new path are the same: '${e}'`);const r=Ge.getLoadHandlers(e);m(r.length>0,()=>`Copying failed because no load handler is found for source URL ${e}.`),m(r.length<2,()=>`Copying failed because more than one (${r.length}) load handlers for source URL ${e}.`);const o=r[0],s=Ge.getSaveHandlers(t);m(s.length>0,()=>`Copying failed because no save handler is found for destination URL ${t}.`),m(s.length<2,()=>`Copying failed because more than one (${r.length}) save handlers for destination URL ${t}.`);const a=s[0],i=ut(e).scheme,u=ut(e).path,l=i===ut(e).scheme,c=await o.load();n&&l&&await it.getManager(i).removeModel(u);const h=await a.save(c);return n&&!l&&await it.getManager(i).removeModel(u),h.modelArtifactsInfo}class ct{fetch(e,t){return fetch(e,t)}now(){return performance.now()}encode(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error("Browser's encoder only supports utf-8, but got "+t);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(e)}decode(e,t){return new TextDecoder(t).decode(e)}}if(n().get("IS_BROWSER")){n().setPlatform("browser",new ct);try{it.registerManager(ot.URL_SCHEME,new at)}catch(e){}try{it.registerManager(He.URL_SCHEME,new Je)}catch(e){}}const ht=()=>require("node-fetch");let pt;class dt{constructor(){this.util=require("util"),this.textEncoder=new this.util.TextEncoder}fetch(e,t){return null!=n().global.fetch?n().global.fetch(e,t):(null==pt&&(pt=ht()),pt(e,t))}now(){const e=process.hrtime();return 1e3*e[0]+e[1]/1e6}encode(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error("Node built-in encoder only supports utf-8, but got "+t);return this.textEncoder.encode(e)}decode(e,t){return 0===e.length?"":new this.util.TextDecoder(t).decode(e)}}function ft(e,t="float32",n){return t=t||"float32",V(e),new re(e,t,n)}n().get("IS_NODE")&&n().setPlatform("node",new dt);const mt=Me({cast_:function(e,t){const n=Ae(e,"x","cast");if(!A(t))throw new Error("Failed to cast to unknown dtype "+t);if("string"===t&&"string"!==n.dtype||"string"!==t&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");const r={x:n},o={dtype:t};return xe.runKernelFunc(e=>e.cast(n,t),r,null,"Cast",o)}});const gt=Me({clone_:function(e){const t=Ae(e,"x","clone",null),n={x:t};return xe.runKernelFunc(()=>xe.makeTensorFromDataId(t.dataId,t.shape,t.dtype),n,null,"Identity")}});function bt(e,t=!1){console.log(e.toString(t))}ve(),se={buffer:ft,cast:mt,clone:gt,print:bt};function yt(e){return new Promise(e=>setTimeout(e)).then(e)}class wt{constructor(e){if(!n().getBool("IS_BROWSER"))throw new Error("browserDownloads() cannot proceed because the current environment is not a browser.");e.startsWith(wt.URL_SCHEME)&&(e=e.slice(wt.URL_SCHEME.length)),null!=e&&0!==e.length||(e="model"),this.modelTopologyFileName=e+".json",this.weightDataFileName=e+".weights.bin"}async save(e){if("undefined"==typeof document)throw new Error("Browser downloads are not supported in this environment since `document` is not present");const t=window.URL.createObjectURL(new Blob([e.weightData],{type:"application/octet-stream"}));if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserDownloads.save() does not support saving model topology in binary formats yet.");{const n=[{paths:["./"+this.weightDataFileName],weights:e.weightSpecs}],r={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,weightsManifest:n},o=window.URL.createObjectURL(new Blob([JSON.stringify(r)],{type:"application/json"})),s=null==this.jsonAnchor?document.createElement("a"):this.jsonAnchor;if(s.download=this.modelTopologyFileName,s.href=o,await yt(()=>s.dispatchEvent(new MouseEvent("click"))),null!=e.weightData){const e=null==this.weightDataAnchor?document.createElement("a"):this.weightDataAnchor;e.download=this.weightDataFileName,e.href=t,await yt(()=>e.dispatchEvent(new MouseEvent("click")))}return{modelArtifactsInfo:We(e)}}}}wt.URL_SCHEME="downloads://";class kt{constructor(e){if(null==e||e.length<1)throw new Error("When calling browserFiles, at least 1 file is required, but received "+e);this.files=e}async load(){const e=this.files[0],t=this.files.slice(1);return new Promise((n,r)=>{const o=new FileReader;o.onload=o=>{const s=JSON.parse(o.target.result),a=s.modelTopology;if(null==a)return void r(new Error("modelTopology field is missing from file "+e.name));0===t.length&&n({modelTopology:a});const i=s.weightsManifest;if(null==i)return void r(new Error("weightManifest field is missing from file "+e.name));let u;try{u=this.checkManifestAndWeightFiles(i,t)}catch(e){return void r(e)}const l=[],c=[],h=[];i.forEach(e=>{e.paths.forEach(e=>{c.push(e),h.push(null)}),l.push(...e.weights)}),i.forEach(e=>{e.paths.forEach(e=>{const t=new FileReader;t.onload=t=>{const r=t.target.result,o=c.indexOf(e);h[o]=r,-1===h.indexOf(null)&&n({modelTopology:a,weightSpecs:l,weightData:qe(h),format:s.format,generatedBy:s.generatedBy,convertedBy:s.convertedBy,userDefinedMetadata:s.userDefinedMetadata})},t.onerror=t=>r(`Failed to weights data from file of path '${e}'.`),t.readAsArrayBuffer(u[e])})})},o.onerror=t=>r(`Failed to read model topology and weights manifest JSON from file '${e.name}'. BrowserFiles supports loading Keras-style tf.Model artifacts only.`),o.readAsText(e)})}checkManifestAndWeightFiles(e,t){const n=[],r=t.map(e=>Oe(e.name)),o={};for(const s of e)s.paths.forEach(e=>{const s=Oe(e);if(-1!==n.indexOf(s))throw new Error(`Duplicate file basename found in weights manifest: '${s}'`);if(n.push(s),-1===r.indexOf(s))throw new Error(`Weight file with basename '${s}' is not provided.`);o[e]=t[r.indexOf(s)]});if(n.length!==t.length)throw new Error(`Mismatch in the number of files in weights manifest (${n.length}) and the number of weight files provided (${t.length}).`);return o}}function vt(e,t,n,r){!function(e){m(null!=e&&Array.isArray(e)&&e.length>0,()=>"promises must be a none empty array")}(e),function(e,t){m(e>=0&&e<=1,()=>"Progress fraction must be in range [0, 1], but got startFraction "+e),m(t>=0&&t<=1,()=>"Progress fraction must be in range [0, 1], but got endFraction "+t),m(t>=e,()=>`startFraction must be no more than endFraction, but got startFraction ${e} and endFraction `+t)}(n=null==n?0:n,r=null==r?1:r);let o=0;return Promise.all(e.map(s=>(s.then(s=>{const a=n+ ++o/e.length*(r-n);return t(a),s}),s)))}async function xt(e,t){null==t&&(t={});const r=null==t.fetchFunc?n().platform.fetch:t.fetchFunc,o=e.map(e=>r(e,t.requestInit,{isBinary:!0})),s=(null==t.onProgress?await Promise.all(o):await vt(o,t.onProgress,0,.5)).map(e=>e.arrayBuffer());return null==t.onProgress?await Promise.all(s):await vt(s,t.onProgress,.5,1)}function St(e){return async(t,n="",r)=>{const o=t.map(()=>!1),s={},a=null!=r?r.map(()=>!1):[],i=[];if(t.forEach((e,t)=>{let n=0;e.weights.forEach(e=>{const u="quantization"in e?e.quantization.dtype:e.dtype,l=Ce[u]*w(e.shape),c=()=>{o[t]=!0,null==s[t]&&(s[t]=[]),s[t].push({manifestEntry:e,groupOffset:n,sizeBytes:l})};null!=r?r.forEach((t,n)=>{t===e.name&&(c(),a[n]=!0)}):c(),i.push(e.name),n+=l})}),!a.every(e=>e)){const e=r.filter((e,t)=>!a[t]);throw new Error("Could not find weights in manifest with names: "+e.join(", ")+". \nManifest JSON has weights with names: "+i.join(", ")+".")}const u=o.reduce((e,t,n)=>(t&&e.push(n),e),[]),l=[];u.forEach(e=>{t[e].paths.forEach(e=>{const t=n+(n.endsWith("/")?"":"/")+e;l.push(t)})});const c=await e(l),h={};let p=0;return u.forEach(e=>{const n=t[e].paths.length;let r=0;for(let e=0;e<n;e++)r+=c[p+e].byteLength;const o=new ArrayBuffer(r),a=new Uint8Array(o);let i=0;for(let e=0;e<n;e++){const t=new Uint8Array(c[p+e]);a.set(t,i),i+=t.byteLength}s[e].forEach(e=>{const t=Re(o.slice(e.groupOffset,e.groupOffset+e.sizeBytes),[e.manifestEntry]);for(const e in t)h[e]=t[e]}),p+=n}),h}}Ge.registerSaveRouter(e=>n().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(wt.URL_SCHEME)?function(e="model"){return new wt(e)}(e.slice(wt.URL_SCHEME.length)):null);class Et{constructor(e,t){if(this.DEFAULT_METHOD="POST",null==t&&(t={}),this.weightPathPrefix=t.weightPathPrefix,this.onProgress=t.onProgress,this.weightUrlConverter=t.weightUrlConverter,null!=t.fetchFunc?(m("function"==typeof t.fetchFunc,()=>"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)"),this.fetch=t.fetchFunc):this.fetch=n().platform.fetch,m(null!=e&&e.length>0,()=>"URL path for http must not be null, undefined or empty."),Array.isArray(e)&&m(2===e.length,()=>`URL paths for http must have a length of 2, (actual length is ${e.length}).`),this.path=e,null!=t.requestInit&&null!=t.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=t.requestInit||{}}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");const t=Object.assign({method:this.DEFAULT_METHOD},this.requestInit);t.body=new FormData;const n=[{paths:["./model.weights.bin"],weights:e.weightSpecs}],r={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,userDefinedMetadata:e.userDefinedMetadata,weightsManifest:n};t.body.append("model.json",new Blob([JSON.stringify(r)],{type:"application/json"}),"model.json"),null!=e.weightData&&t.body.append("model.weights.bin",new Blob([e.weightData],{type:"application/octet-stream"}),"model.weights.bin");const o=await this.fetch(this.path,t);if(o.ok)return{modelArtifactsInfo:We(e),responses:[o]};throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+o.status+".")}async load(){const e=await this.fetch(this.path,this.requestInit);if(!e.ok)throw new Error(`Request to ${this.path} failed with status code `+e.status+". Please verify this URL points to the model JSON of the model to load.");let t;try{t=await e.json()}catch(e){let t=`Failed to parse model JSON of response from ${this.path}.`;throw this.path.endsWith(".pb")?t+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":t+=" Please make sure the server is serving valid JSON for this request.",new Error(t)}const n=t.modelTopology,r=t.weightsManifest,o=t.generatedBy,s=t.convertedBy,a=t.format,i=t.userDefinedMetadata;if(null==n&&null==r)throw new Error(`The JSON from HTTP path ${this.path} contains neither model topology or manifest for weights.`);let u,l;if(null!=r){const e=await this.loadWeights(r);[u,l]=e}return{modelTopology:n,weightSpecs:u,weightData:l,userDefinedMetadata:i,generatedBy:o,convertedBy:s,format:a}}async loadWeights(e){const t=Array.isArray(this.path)?this.path[1]:this.path,[n,r]=function(e){const t=e.lastIndexOf("/"),n=e.lastIndexOf("?"),r=e.substring(0,t),o=n>t?e.substring(n):"";return[r+"/",o]}(t),o=this.weightPathPrefix||n,s=[];for(const t of e)s.push(...t.weights);const a=[],i=[];for(const t of e)for(const e of t.paths)null!=this.weightUrlConverter?i.push(this.weightUrlConverter(e)):a.push(o+e+r);return this.weightUrlConverter&&a.push(...await Promise.all(i)),[s,qe(await xt(a,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress}))]}}function Dt(e){return null!=e.match(Et.URL_SCHEME_REGEX)}Et.URL_SCHEME_REGEX=/^https?:\/\//;const Nt=(e,t)=>{if("undefined"==typeof fetch&&(null==t||null==t.fetchFunc))return null;{let n=!0;if(n=Array.isArray(e)?e.every(e=>Dt(e)):Dt(e),n)return It(e,t)}return null};function It(e,t){return new Et(e,t)}Ge.registerSaveRouter(Nt),Ge.registerLoadRouter(Nt);class Ft{constructor(e){this.modelArtifacts=e}async load(){return this.modelArtifacts}}class At{constructor(e){this.saveHandler=e}async save(e){return this.saveHandler(e)}}var Tt=Object.freeze({__proto__:null,browserFiles:function(e){return new kt(e)},browserHTTPRequest:function(e,t){return It(e,t)},concatenateArrayBuffers:qe,decodeWeights:Re,encodeWeights:async function(e,t){const n=[],r=[],o=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);for(let s=0;s<o.length;++s){const a=o[s],i=Array.isArray(e)?e[s].tensor:e[a];if("float32"!==i.dtype&&"int32"!==i.dtype&&"bool"!==i.dtype&&"string"!==i.dtype&&"complex64"!==i.dtype)throw new Error(`Unsupported dtype in weight '${a}': ${i.dtype}`);const u={name:a,shape:i.shape,dtype:i.dtype};if("string"===i.dtype){const e=new Promise(async e=>{const t=await i.bytes(),n=t.reduce((e,t)=>e+t.length,0)+4*t.length,r=new Uint8Array(n);let o=0;for(let e=0;e<t.length;e++){const n=t[e],s=new Uint8Array(new Uint32Array([n.length]).buffer);r.set(s,o),o+=4,r.set(n,o),o+=n.length}e(r)});r.push(e)}else r.push(i.data());null!=t&&(u.group=t),n.push(u)}return{data:Pe(await Promise.all(r)),specs:n}},fromMemory:function(e,t,n,r){if(1===arguments.length){return null!=e.modelTopology||null!=e.weightSpecs?new Ft(e):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Ft({modelTopology:e}))}return console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Ft({modelTopology:e,weightSpecs:t,weightData:n,trainingConfig:r})},getLoadHandlers:(e,t)=>Ge.getLoadHandlers(e,t),getModelArtifactsInfoForJSON:We,getSaveHandlers:e=>Ge.getSaveHandlers(e),http:It,isHTTPScheme:Dt,loadWeights:async function(e,t="",n,r){return St(e=>xt(e,{requestInit:r}))(e,t,n)},registerLoadRouter:e=>Ge.registerLoadRouter(e),registerSaveRouter:e=>Ge.registerSaveRouter(e),weightsLoaderFactory:St,withSaveHandler:function(e){return new At(e)},copyModel:async function(e,t){return lt(e,t,!1)},listModels:async function(){const e=it.getSchemes(),t={};for(const n of e){const e=await it.getManager(n).listModels();for(const r in e){t[n+"://"+r]=e[r]}}return t},moveModel:async function(e,t){return lt(e,t,!0)},removeModel:async function(e){const t=ut(e);return it.getManager(t.scheme).removeModel(t.path)}});const Mt=Me({reshape_:function(e,t){const n=Ae(e,"x","reshape",null);t=S(t,n.size),m(n.size===w(t),()=>"new shape and old shape must have the same number of elements.");const r={x:n},o={shape:t};return xe.runKernelFunc((e,r)=>(r([n]),e.reshape(n,t)),r,null,"Reshape",o)}});const $t=Me({matMul_:function(e,t,n=!1,r=!1){let o=Ae(e,"a","matMul"),s=Ae(t,"b","matMul");[o,s]=me(o,s),m(o.rank>=2&&s.rank>=2&&o.rank===s.rank,()=>`Error in matMul: inputs must have the same rank of at least 2, got ranks ${o.rank} and ${s.rank}.`);const a=n?o.shape[o.rank-2]:o.shape[o.rank-1],i=r?s.shape[s.rank-1]:s.shape[s.rank-2],u=n?o.shape[o.rank-1]:o.shape[o.rank-2],l=r?s.shape[s.rank-2]:s.shape[s.rank-1],c=o.shape.slice(0,-2),h=s.shape.slice(0,-2),p=w(c),d=w(h);m(k(c,h),()=>`Error in matMul: outer dimensions (${c}) and (${h}) of Tensors with shapes ${o.shape} and `+s.shape+" must match."),m(a===i,()=>`Error in matMul: inner shapes (${a}) and (${i}) of Tensors with shapes ${o.shape} and ${s.shape} and transposeA=${n} and transposeB=${r} must match.`);const f=o.shape.slice(0,-2).concat([u,l]),g=Mt(o,n?[p,a,u]:[p,u,a]),b=Mt(s,r?[d,l,i]:[d,i,l]),y={a:g,b:b},v={transposeA:n,transposeB:r},x=xe.runKernelFunc((e,t)=>(t([g,b]),e.batchMatMul(g,b,n,r)),y,null,"BatchMatMul",v);return Mt(x,f)}});const _t=Me({oneHot_:function(e,t,n=1,r=0){if(t<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+t);const o=Ae(e,"indices","oneHot","int32"),s=[...o.shape,t],a={indices:o},i={depth:t,onValue:n,offValue:r};return xe.runKernelFunc((e,a)=>(a([o]),Mt(e.oneHot(Mt(o,[o.size]),t,n,r),s)),a,null,"OneHot",i)}});const Bt=Me({transpose_:function(e,t){const n=Ae(e,"x","transpose");if(null==t&&(t=n.shape.map((e,t)=>t).reverse()),m(n.rank===t.length,()=>`Error in transpose: rank of input ${n.rank} must match length of perm ${t}.`),t.forEach(e=>{m(e>=0&&e<n.rank,()=>"All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+t)}),n.rank<=1)return n.clone();const r={x:n},o={perm:t};return xe.runKernelFunc(e=>e.transpose(n,t),r,null,"Transpose",o)}});const Ct=Me({confusionMatrix_:function(e,t,n){const r=Ae(e,"labels","confusionMatrix"),o=Ae(t,"predictions","confusionMatrix");m(null==n||n>0&&Number.isInteger(n),()=>"If provided, numClasses must be a positive integer, but got "+n),m(1===r.rank,()=>"Expected the rank of labels to be 1, but got "+r.rank),m(1===o.rank,()=>"Expected the rank of predictions to be 1, but got "+o.rank),m(r.shape[0]===o.shape[0],()=>`Mismatch in the number of examples: ${r.shape[0]} vs. ${o.shape[0]}. Labels and predictions should have the same number of elements.`),m(n>0&&Number.isInteger(n),()=>"numClasses is required to be a positive integer, but got "+n);const s=_t(mt(r,"int32"),n),a=_t(mt(o,"int32"),n),i=Bt(s);return mt($t(i,a),"int32")}});var Rt=Object.freeze({__proto__:null,confusionMatrix:Ct});function Pt(e,t,n){if(b(e),null!=t&&3!==t.length)throw new Error("tensor3d() requires shape to have three numbers");const r=Ie(e,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return _e(e,t,r,n)}let zt;const Lt=Me({fromPixels_:function(e,t=3){if(t>4)throw new Error("Cannot construct Tensor with more than 4 channels from pixels.");if(null==e)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");let n=!1,r=!1,o=!1,s=!1,a=!1;if(e.data instanceof Uint8Array)n=!0;else if("undefined"!=typeof ImageData&&e instanceof ImageData)r=!0;else if("undefined"!=typeof HTMLVideoElement&&e instanceof HTMLVideoElement)o=!0;else if("undefined"!=typeof HTMLImageElement&&e instanceof HTMLImageElement)s=!0;else{if(null==e.getContext)throw new Error("pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was "+e.constructor.name);a=!0}if(o){const t=2;if(o&&e.readyState<t)throw new Error("The video element has not loaded data yet. Please wait for `loadeddata` event on the <video> element.")}if(null!=u("FromPixels",xe.backendName)){const n={pixels:e},r={numChannels:t};return xe.runKernel("FromPixels",n,r)}const[i,l]=o?[e.videoWidth,e.videoHeight]:[e.width,e.height];let c,h;if(a?c=e.getContext("2d").getImageData(0,0,i,l).data:r||n?c=e.data:(s||o)&&(null==zt&&(zt=document.createElement("canvas").getContext("2d")),zt.canvas.width=i,zt.canvas.height=l,zt.drawImage(e,0,0,i,l),c=zt.getImageData(0,0,i,l).data),4===t)h=new Int32Array(c);else{const e=i*l;h=new Int32Array(e*t);for(let n=0;n<e;n++)for(let e=0;e<t;++e)h[n*t+e]=c[4*n+e]}return Pt(h,[l,i,t],"int32")}});var qt=Object.freeze({__proto__:null,toPixels:async function(e,t){let n=Ae(e,"img","toPixels");if(!(e instanceof ae)){const e=n;n=mt(e,"int32"),e.dispose()}if(2!==n.rank&&3!==n.rank)throw new Error(`toPixels only supports rank 2 or 3 tensors, got rank ${n.rank}.`);const[r,o]=n.shape.slice(0,2),s=2===n.rank?1:n.shape[2];if(s>4||2===s)throw new Error("toPixels only supports depth of size 1, 3 or 4 but got "+s);if("float32"!==n.dtype&&"int32"!==n.dtype)throw new Error(`Unsupported type for toPixels: ${n.dtype}. Please use float32 or int32 tensors.`);const a=await n.data(),i="float32"===n.dtype?255:1,u=new Uint8ClampedArray(o*r*4);for(let e=0;e<r*o;++e){const t=[0,0,0,255];for(let r=0;r<s;r++){const o=a[e*s+r];if("float32"===n.dtype){if(o<0||o>1)throw new Error(`Tensor values for a float32 Tensor must be in the range [0 - 1] but encountered ${o}.`)}else if("int32"===n.dtype&&(o<0||o>255))throw new Error(`Tensor values for a int32 Tensor must be in the range [0 - 255] but encountered ${o}.`);1===s?(t[0]=o*i,t[1]=o*i,t[2]=o*i):t[r]=o*i}const r=4*e;u[r+0]=Math.round(t[0]),u[r+1]=Math.round(t[1]),u[r+2]=Math.round(t[2]),u[r+3]=Math.round(t[3])}if(null!=t){t.width=o,t.height=r;const e=t.getContext("2d"),n=new ImageData(u,o,r);e.putImageData(n,0,0)}return n!==e&&n.dispose(),u},fromPixels:Lt});function Ot(e,t){if(e.rank<1)throw new Error(`tf.gatherND() expects the input to be rank 1 or higher, but the rank was ${e.rank}.`);if(t.rank<1)throw new Error(`tf.gatherND() expects the indices to be rank 1 or higher, but the rank was ${t.rank}.`);if("int32"!==t.dtype)throw new Error(`tf.gatherND() expects the indices to be int32 type, but the dtype was ${t.dtype}.`);if(t.shape[t.rank-1]>e.rank)throw new Error(`index innermost dimension length must be <= tensor rank; saw: ${t.shape[t.rank-1]} vs. ${e.rank}`);if(0===e.size)throw new Error(`Requested more than 0 entries, but input is empty. Input shape: ${e.shape}.`);const n=t.shape,r=n[n.length-1];let o=1;for(let e=0;e<n.length-1;++e)o*=n[e];const s=e.shape,a=n.slice();a.pop();let i=1;for(let t=r;t<e.rank;++t)i*=s[t],a.push(s[t]);const u=[...q(e.shape).map(e=>e/i),1].slice(0,r);return[a,o,i,u]}var Wt=Object.freeze({__proto__:null,prepareAndValidate:Ot});function Kt(e,t,n){const r=t.rank>1?t.shape[t.rank-1]:1,o=t.rank>1?t.rank-1:1,s="Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: "+n.shape+`, indices.shape: ${t.shape}, shape: ${e}`+`, sliceDim: ${r}, and batchDim: ${o}.`;if(n.rank<o)throw new Error(s+` update.rank < ${o}. `);if(e.length<r+(n.rank-o))throw new Error(s+" Output shape length < "+(r+(n.rank-o)));if(n.rank!==o+e.length-r)throw new Error(s+" update.rank != "+(o+e.length-r));for(let e=0;e<o;++e)if(n.shape[e]!==t.shape[e])throw new Error(s+` updates.shape[${e}] (${n.shape[e]}) != indices.shape[${e}] (${t.shape[e]}).`);for(let t=0;t<n.rank-o;++t)if(n.shape[t+o]!==e[t+r])throw new Error(s+` updates.shape[${t+o}] (${n.shape[t+o]}) != shape[${t+o}] (${e[t+o]})`)}function Gt(e,t,n){if(t.rank<1)throw new Error(`tf.scatterND() expects the indices to be rank 1 or higher, but the rank was ${t.rank}.`);if(e.rank<1)throw new Error(`tf.scatterND() expects the updates to be rank 1 or higher, but the rank was ${e.rank}.`);if("int32"!==t.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: "+t.dtype);if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: "+n);if(0===n.length){if(0===t.size)throw new Error("Indices specified for empty output. indices shape: "+t.shape);if(0===e.size)throw new Error("Updates specified for empty output. updates shape: "+e.shape)}Kt(n,t,e)}function Ut(e,t,n){const r=t.shape.length,o=r>1?t.shape[r-1]:1,s=n.length;let a=1;for(let e=o;e<s;++e)a*=n[e];const i=o<1?1:o;return{sliceRank:o,numUpdates:w(t.shape)/i,sliceSize:a,strides:[...q(n.slice(0,o)),1],outputSize:w(n)}}var Vt=Object.freeze({__proto__:null,validateUpdateShape:Kt,validateInput:Gt,calculateShapes:Ut});function Ht(e,t,n){m(e.rank===t.length,()=>`Error in slice${e.rank}D: Length of begin ${t} must match the rank of the array (${e.rank}).`),m(e.rank===n.length,()=>`Error in slice${e.rank}D: Length of size ${n} must match the rank of the array (${e.rank}).`);for(let r=0;r<e.rank;++r)m(t[r]+n[r]<=e.shape[r],()=>`Error in slice${e.rank}D: begin[${r}] + size[${r}] (${t[r]+n[r]}) would overflow input.shape[${r}] (${e.shape[r]})`)}function jt(e){const t=[];let n=0;for(;e>0;)1&e&&t.push(n),e/=2,n++;return t}function Jt(e,t,n){const r=[];for(let o=0;o<e.length;o++)r[o]=Math.ceil((t[o]-e[o])/n[o]);return r}function Yt(e,t,n,r){const o=[...e];for(let e=o.length;e<r.length;e++)o.push(1);for(let e=0;e<n;e++)0===e?o[t]=1:(o.splice(t,0,1),o.pop());return o}function Zt(e,t,n){return n<=e?n:n-(t-1)}function Xt(e,t){const n=[];for(let r=0;r<e;r++)n.push(t+r);return n}function Qt(e,t,n,r,o,s,a,i,u){const l=e.length;let c=new Array(l),h=new Array(l),p=new Array(l);if(t.length&&n>0){const u=t[0],l=n+1;c=en(a,u,l,r,e),h=tn(i,u,l,o,e),p=Yt(s,u,l,e)}else for(let t=0;t<l;t++)c[t]=rn(a,r,s,e,t,u),h[t]=on(i,o,s,e,t,u),p[t]=nn(s,t,u);return{begin:c,end:h,strides:p}}function en(e,t,n,r,o){const s=[...o],a=Xt(n,t);for(let o=0;o<s.length;o++)if(a.indexOf(o)>-1)s[o]=0;else{const a=Zt(t,n,o);let i=r[a];e&1<<a&&(i=0),s[o]=i}return s}function tn(e,t,n,r,o){const s=[...o],a=Xt(n,t);for(let o=0;o<s.length;o++)if(a.indexOf(o)>-1)s[o]=Number.MAX_SAFE_INTEGER;else{const a=Zt(t,n,o);let i=r[a];e&1<<a&&(i=Number.MAX_SAFE_INTEGER),s[o]=i}for(let e=0;e<s.length;e++){const t=o[e];s[e]<0&&(s[e]+=t),s[e]=f(0,s[e],o[e])}return s}function nn(e,t,n){let r=e[t];return(n&1<<t||null==r)&&(r=1),r}function rn(e,t,n,r,o,s){let a=t[o];const i=n[o]||1;(e&1<<o||s&1<<o||null==a)&&(a=i>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);const u=r[o];return a<0&&(a+=u),a=f(0,a,u-1),a}function on(e,t,n,r,o,s){let a=t[o];const i=n[o]||1;(e&1<<o||s&1<<o||null==a)&&(a=i>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);const u=r[o];return a<0&&(a+=u),a=i>0?f(0,a,u):f(-1,a,u-1),a}function sn(e,t,n){let r,o;return r="number"==typeof t?[t,...new Array(e.rank-1).fill(0)]:t.length<e.rank?t.concat(new Array(e.rank-t.length).fill(0)):t.slice(),r.forEach(e=>{m(-1!==e,()=>"slice() does not support negative begin indexing.")}),o=null==n?new Array(e.rank).fill(-1):"number"==typeof n?[n,...new Array(e.rank-1).fill(-1)]:n.length<e.rank?n.concat(new Array(e.rank-n.length).fill(-1)):n,o=o.map((t,n)=>t>=0?t:(m(-1===t,()=>`Negative size values should be exactly -1 but got ${t} for the slice() size at index ${n}.`),e.shape[n]-r[n])),[r,o]}var an=Object.freeze({__proto__:null,assertParamsValid:Ht,maskToAxes:jt,computeOutShape:Jt,stridesWithElidedDims:Yt,getNormalizedAxes:Qt,startIndicesWithElidedDims:en,stopIndicesWithElidedDims:tn,stridesForAxis:nn,startForAxis:rn,stopForAxis:on,isSliceContinous:function(e,t,n){let r=n.length;for(let e=0;e<n.length;e++)if(n[e]>1){r=e;break}for(let o=r+1;o<n.length;o++)if(t[o]>0||n[o]!==e[o])return!1;return!0},computeFlatOffset:function(e,t){let n=e.length>0?e[e.length-1]:1;for(let r=0;r<e.length-1;r++)n+=e[r]*t[r];return n},parseSliceParams:sn});class un{getClassName(){return this.constructor.className}static fromConfig(e,t){return new e(t)}}class ln{constructor(){this.classNameMap={}}static getMap(){return null==ln.instance&&(ln.instance=new ln),ln.instance}static register(e){ln.getMap().classNameMap[e.className]=[e,e.fromConfig]}}function cn(e){m(null!=e.className,()=>"Class being registered does not have the static className property defined."),m("string"==typeof e.className,()=>"className is required to be a string, but got type "+typeof e.className),m(e.className.length>0,()=>"Class being registered has an empty-string as its className, which is disallowed."),ln.register(e)}var hn=Object.freeze({__proto__:null,Serializable:un,SerializationMap:ln,registerClass:cn});function pn(){return 32===xe.backend.floatPrecision()?.001:.1}function dn(e,t,n){let r=!0;if((M(e)||M(t))&&(r=!1),M(e)&&M(t)&&(r=!0),r){const n=e.constructor.name,r=t.constructor.name;if(n!==r)throw new Error(`Arrays are of different type. Actual: ${n}. Expected: `+r)}if(Array.isArray(e)&&Array.isArray(t)){const n=Ie(e),r=Ie(t);if(!k(n,r))throw new Error(`Arrays have different shapes. Actual: [${n}]. Expected: [${r}]`)}const o=M(e)?e:y(e),s=M(t)?t:y(t);if(o.length!==s.length)throw new Error(`Arrays have different lengths actual: ${o.length} vs expected: ${s.length}.\nActual:   ${o}.\nExpected: ${s}.`);for(let e=0;e<s.length;++e){const t=o[e],r=s[e];if(!n(t,r))throw new Error(`Arrays differ: actual[${e}] = ${t}, expected[${e}] = ${r}.\nActual:   ${o}.\nExpected: ${s}.`)}}function fn(e,t,n){return!isFinite(e)&&!isFinite(t)||!(isNaN(e)||isNaN(t)||Math.abs(e-t)>n)}var mn=Object.freeze({__proto__:null,TEST_EPSILON_FLOAT16:.1,expectArraysClose:function(e,t,n){return null==n&&(n=pn()),dn(e,t,(e,t)=>fn(e,t,n))},testEpsilon:pn,expectPromiseToFail:function(e,t){e().then(()=>t.fail(),()=>t())},expectArraysEqual:function(e,t){const n="string"==typeof t||"number"==typeof t||"boolean"==typeof t?[t]:t;return B(e)||B(e[0])||B(t)||B(t[0])?dn(e,n,(e,t)=>e==t):dn(e,t,(e,t)=>fn(e,t,0))},expectNumbersClose:function(e,t,n){if(null==n&&(n=pn()),!fn(e,t,n))throw new Error(`Numbers differ: actual === ${e}, expected === ${t}`)},expectValuesInRange:function(e,t,n){for(let r=0;r<e.length;r++)if(e[r]<t||e[r]>n)throw new Error(`Value out of range:${e[r]} low: ${t}, high: ${n}`)},expectArrayBuffersEqual:function(e,t){expect(new Float32Array(e)).toEqual(new Float32Array(t))}});function gn(e){n().getBool("DEPRECATION_WARNINGS_ENABLED")&&console.warn(e+" You can disable deprecation warnings with tf.disableDeprecationWarnings().")}function bn(e,t){return xe.tidy(e,t)}function yn(e){be(e).forEach(e=>e.dispose())}function wn(e){return xe.keep(e)}const kn=Me({add_:function(e,t){let n=Ae(e,"a","add"),r=Ae(t,"b","add");[n,r]=me(n,r);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.add(n,r);return t([n,r]),o},o,null,"Add")}});const vn=Me({floorDiv_:function(e,t){let n=Ae(e,"a","floorDiv"),r=Ae(t,"b","floorDiv");[n,r]=me(n,r);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.floorDiv(n,r);return t([n,r]),o},o,null,"FloorDiv")}});const xn=Me({div_:function(e,t){let n=Ae(e,"a","div"),r=Ae(t,"b","div");if([n,r]=me(n,r),"int32"===n.dtype&&"int32"===r.dtype)return vn(n,r);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.realDivide(n,r);return t([n,r]),o},o,null,"Div",{})}});const Sn=Me({mul_:function(e,t){let n=Ae(e,"a","mul"),r=Ae(t,"b","mul");[n,r]=me(n,r);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.multiply(n,r);return t([n,r]),o},o,null,"Multiply")}});const En=Me({abs_:function(e){const t=Ae(e,"x","abs"),n={x:t};return xe.runKernelFunc((e,n)=>(n([t]),"complex64"===t.dtype?e.complexAbs(t):e.abs(t)),n,null,"Abs")}});const Dn=Me({acos_:function(e){const t=Ae(e,"x","acos"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.acos(t);return n([t]),r},n,null,"Acos")}});const Nn=Me({acosh_:function(e){const t=Ae(e,"x","acosh"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.acosh(t);return n([t]),r},n,null,"Acosh")}});const In=Me({addN_:function(e){m(Array.isArray(e),()=>"The argument passed to tf.addN() must be a list of tensors"),m(e.length>=1,()=>"Must pass at least one tensor to tf.addN(), but got "+e.length);const t=e.map((e,t)=>Ae(e,"tensors"+t,"addN")),n=t[0];t.forEach(e=>{if(e.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")}),t.forEach(e=>{if(!k(e.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")});const r=t;return xe.runKernelFunc((e,n)=>{const r=e.addN(t);return n(t),r},r,null,"AddN")}});function Fn(e,t){for(let n=0;n<e.length;++n)if(e[e.length-n-1]!==t-1-n)return!1;return!0}function An(e,t,n){const r=e.length+t.length,o=[];let s=0,a=0;for(let i=0;i<r;i++)-1===n.indexOf(i)?o.push(e[s++]):o.push(t[a++]);return o}function Tn(e,t){const n=[],r=e.length;for(let o=0;o<r;o++)-1===t.indexOf(o)&&n.push(e[o]);return[n,t.map(t=>e[t])]}function Mn(e,t){return An(e,t.map(e=>1),t)}function $n(e,t){if(Fn(e,t))return null;const n=[];for(let r=0;r<t;++r)-1===e.indexOf(r)&&n.push(r);return e.forEach(e=>n.push(e)),n}function _n(e){return e.map((e,t)=>[t,e]).sort((e,t)=>e[1]-t[1]).map(e=>e[0])}function Bn(e,t){const n=[];for(let r=t-e;r<t;++r)n.push(r);return n}const Cn=Me({all_:function(e,t=null,n=!1){let r=Ae(e,"x","all","bool");const o={x:r},s={axis:t,keepDims:n};return xe.runKernelFunc(e=>{const o=E(t,r.shape);let s=o;const a=$n(s,r.rank);null!=a&&(r=Bt(r,a),s=Bn(s.length,r.rank));const i=e.all(r,s);if(n){const e=Mn(i.shape,o);return Mt(i,e)}return i},o,null,"All",s)}});const Rn=Me({any_:function(e,t=null,n=!1){let r=Ae(e,"x","any","bool");const o={x:r},s={axis:t,keepDims:n};return xe.runKernelFunc(e=>{const o=E(t,r.shape);let s=o;const a=$n(s,r.rank);null!=a&&(r=Bt(r,a),s=Bn(s.length,r.rank));const i=e.any(r,s);if(n){const e=Mn(i.shape,o);return Mt(i,e)}return i},o,null,"Any",s)}});const Pn=Me({argMax_:function(e,t=0){let n=Ae(e,"x","argMax");const r={x:n},o={axis:t};return xe.runKernelFunc((e,r)=>{r([n]);let o=E(t,n.shape);const s=$n(o,n.rank);return null!=s&&(n=Bt(n,s),o=Bn(o.length,n.rank)),e.argMax(n,o[0])},r,null,"ArgMax",o)}});const zn=Me({argMin_:function(e,t=0){let n=Ae(e,"x","argMin");const r={x:n},o={axis:t};return xe.runKernelFunc((e,r)=>{r([n]),null==t&&(t=0);let o=E(t,n.shape);const s=$n(o,n.rank);return null!=s&&(n=Bt(n,s),o=Bn(o.length,n.rank)),e.argMin(n,o[0])},r,null,"ArgMin",o)}});const Ln=Me({asin_:function(e){const t=Ae(e,"x","asin"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.asin(t);return n([t]),r},n,null,"Asin")}});const qn=Me({asinh_:function(e){const t=Ae(e,"x","asinh"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.asinh(t);return n([t]),r},n,null,"Asinh")}});const On=Me({atan_:function(e){const t=Ae(e,"x","atan"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.atan(t);return n([t]),r},n,null,"Atan")}});const Wn=Me({atan2_:function(e,t){let n=Ae(e,"a","atan2"),r=Ae(t,"b","atan2");[n,r]=me(n,r);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.atan2(n,r);return t([n,r]),o},o,null,"Atan2")}});const Kn=Me({atanh_:function(e){const t=Ae(e,"x","atanh"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.atanh(t);return n([t]),r},n,null,"Atanh")}});function Gn(e,t,n,r,o,s,a="channelsLast"){const[i,u]=Jn(t);let l;if("channelsLast"===a)l=[i,u,e[3],e[3]];else{if("channelsFirst"!==a)throw new Error("Unknown dataFormat "+a);l=[i,u,e[1],e[1]]}return Vn(e,l,n,r,o,s,!1,a)}function Un(e,t,n,r,o,s,a="NDHWC"){const[i,u,l]=Yn(t);let c,h;if("NDHWC"===a)h="channelsLast",c=[i,u,l,e[4],e[4]];else{if("NCDHW"!==a)throw new Error("Unknown dataFormat "+a);h="channelsFirst",c=[i,u,l,e[1],e[1]]}return Hn(e,c,n,r,o,!1,h,s)}function Vn(e,t,n,r,o,s,a=!1,i="channelsLast"){let[u,l,c,h]=[-1,-1,-1,-1];if("channelsLast"===i)[u,l,c,h]=e;else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);[u,h,l,c]=e}const[p,d,,f]=t,[g,b]=Jn(n),[y,w]=Jn(r),k=Zn(p,y),x=Zn(d,w),{padInfo:S,outHeight:E,outWidth:D}=function(e,t,n,r,o,s,a,i,u){let l,c,h;if("number"==typeof e){l={top:e,bottom:e,left:e,right:e,type:0===e?"VALID":"NUMBER"};const o=function(e,t,n,r,o){null==r&&(r=jn(e,t,n));const s=e[0],a=e[1],i=Xn((s-t+2*r)/n+1,o);m(v(i),()=>`The output # of rows (${i}) must be an integer. Change the stride and/or zero pad parameters`);const u=Xn((a-t+2*r)/n+1,o);return m(v(u),()=>`The output # of columns (${u}) must be an integer. Change the stride and/or zero pad parameters`),[i,u]}([t,n],s,r,e,i);c=o[0],h=o[1]}else if("same"===e){c=Math.ceil(t/r),h=Math.ceil(n/o);const e=Math.max(0,(c-1)*r+s-t),i=Math.max(0,(h-1)*o+a-n),u=Math.floor(e/2),p=e-u,d=Math.floor(i/2);l={top:u,bottom:p,left:d,right:i-d,type:"SAME"}}else if("valid"===e)l={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((t-s+1)/r),h=Math.ceil((n-a+1)/o);else{if("object"!=typeof e)throw Error("Unknown padding parameter: "+e);{const p="channelsLast"===u?e[1][0]:e[2][0],d="channelsLast"===u?e[1][1]:e[2][1],f="channelsLast"===u?e[2][0]:e[3][0],m="channelsLast"===u?e[2][1]:e[3][1];l={top:p,bottom:d,left:f,right:m,type:0===p&&0===d&&0===f&&0===m?"VALID":"EXPLICIT"},c=Xn((t-s+p+d)/r+1,i),h=Xn((n-a+f+m)/o+1,i)}}return{padInfo:l,outHeight:c,outWidth:h}}(o,l,c,g,b,k,x,s,i),N=a?f*h:f;let I;return"channelsFirst"===i?I=[u,N,E,D]:"channelsLast"===i&&(I=[u,E,D,N]),{batchSize:u,dataFormat:i,inHeight:l,inWidth:c,inChannels:h,outHeight:E,outWidth:D,outChannels:N,padInfo:S,strideHeight:g,strideWidth:b,filterHeight:p,filterWidth:d,effectiveFilterHeight:k,effectiveFilterWidth:x,dilationHeight:y,dilationWidth:w,inShape:e,outShape:I,filterShape:t}}function Hn(e,t,n,r,o,s=!1,a="channelsLast",i){let[u,l,c,h,p]=[-1,-1,-1,-1,-1];if("channelsLast"===a)[u,l,c,h,p]=e;else{if("channelsFirst"!==a)throw new Error("Unknown dataFormat "+a);[u,p,l,c,h]=e}const[d,f,g,,b]=t,[y,w,k]=Yn(n),[x,S,E]=Yn(r),D=Zn(d,x),N=Zn(f,S),I=Zn(g,E),{padInfo:F,outDepth:A,outHeight:T,outWidth:M}=function(e,t,n,r,o,s,a,i,u,l,c){let h,p,d,f;if("number"==typeof e){h={top:e,bottom:e,left:e,right:e,front:e,back:e,type:0===e?"VALID":"NUMBER"};const s=function(e,t,n,r,o,s){null==o&&(o=jn(e,t,r));const a=e[0],i=e[1],u=e[2],l=Xn((a-t+2*o)/r+1,s);m(v(l),()=>`The output # of depths (${l}) must be an integer. Change the stride and/or zero pad parameters`);const c=Xn((i-t+2*o)/r+1,s);m(v(c),()=>`The output # of rows (${c}) must be an integer. Change the stride and/or zero pad parameters`);const h=Xn((u-t+2*o)/r+1,s);return m(v(h),()=>`The output # of columns (${h}) must be an integer. Change the stride and/or zero pad parameters`),[l,c,h,n]}([t,n,r,1],i,1,o,e,c);p=s[0],d=s[1],f=s[2]}else if("same"===e){p=Math.ceil(t/o),d=Math.ceil(n/s),f=Math.ceil(r/a);const e=(p-1)*o+i-t,c=(d-1)*s+u-n,m=(f-1)*a+l-r,g=Math.floor(e/2),b=e-g,y=Math.floor(c/2),w=c-y,k=Math.floor(m/2);h={top:y,bottom:w,left:k,right:m-k,front:g,back:b,type:"SAME"}}else{if("valid"!==e)throw Error("Unknown padding parameter: "+e);h={top:0,bottom:0,left:0,right:0,front:0,back:0,type:"VALID"},p=Math.ceil((t-i+1)/o),d=Math.ceil((n-u+1)/s),f=Math.ceil((r-l+1)/a)}return{padInfo:h,outDepth:p,outHeight:d,outWidth:f}}(o,l,c,h,y,w,k,D,N,I,i),$=s?b*p:b;let _;return"channelsFirst"===a?_=[u,$,A,T,M]:"channelsLast"===a&&(_=[u,A,T,M,$]),{batchSize:u,dataFormat:a,inDepth:l,inHeight:c,inWidth:h,inChannels:p,outDepth:A,outHeight:T,outWidth:M,outChannels:$,padInfo:F,strideDepth:y,strideHeight:w,strideWidth:k,filterDepth:d,filterHeight:f,filterWidth:g,effectiveFilterDepth:D,effectiveFilterHeight:N,effectiveFilterWidth:I,dilationDepth:x,dilationHeight:S,dilationWidth:E,inShape:e,outShape:_,filterShape:t}}function jn(e,t,n,r=1){const o=Zn(t,r);return Math.floor((e[0]*(n-1)-n+o)/2)}function Jn(e){return"number"==typeof e?[e,e,e]:2===e.length?[e[0],e[1],1]:e}function Yn(e){return"number"==typeof e?[e,e,e]:e}function Zn(e,t){return t<=1?e:e+(e-1)*(t-1)}function Xn(e,t){if(!t)return e;switch(t){case"round":return Math.round(e);case"ceil":return Math.ceil(e);case"floor":return Math.floor(e);default:throw new Error("Unknown roundingMode "+t)}}function Qn(e){const[t,n,r]=Jn(e);return 1===t&&1===n&&1===r}function er(e,t){return Qn(e)||Qn(t)}function tr(e){if("NHWC"===e)return"channelsLast";if("NCHW"===e)return"channelsFirst";throw new Error("Unknown dataFormat "+e)}const nr=Me({avgPool_:function(e,t,n,r,o){const s=Ae(e,"x","avgPool","float32");m(er(n,1),()=>`Error in avgPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`);let a=s,i=!1;3===s.rank&&(i=!0,a=Mt(s,[1,s.shape[0],s.shape[1],s.shape[2]])),m(4===a.rank,()=>`Error in avgPool: x must be rank 4 but got rank ${a.rank}.`),null!=o&&m(v(r),()=>`Error in avgPool: pad must be an integer when using, dimRoundingMode ${o} but got pad ${r}.`);const u={x:a},l={filterSize:t,strides:n,pad:r,dimRoundingMode:o};let c=xe.runKernelFunc((e,s)=>{const i=Gn(a.shape,t,n,1,r,o);return s([a]),1===i.filterWidth&&1===i.filterHeight&&k(i.inShape,i.outShape)?a.clone():e.avgPool(a,i)},u,null,"AvgPool",l);return c=mt(c,s.dtype),i?Mt(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const rr=Me({avgPool3d_:function(e,t,n,r,o,s="NDHWC",a){null==a?a=[1,1,1]:gn("dilations is deprecated, this field will be gone in v3.0.0.");const i=Ae(e,"x","avgPool3d","float32");let u=i,l=!1;4===i.rank&&(l=!0,u=Mt(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),m(5===u.rank,()=>`Error in avgPool3d: x must be rank 5 but got rank ${u.rank}.`),m("NDHWC"===s,()=>"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of "+s),m(er(n,a),()=>`Error in avgPool3d: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),null!=o&&m(v(r),()=>`Error in avgPool3d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${r}.`);const c={x:u},h={filterSize:t,strides:n,pad:r,dimRoundingMode:o,dataFormat:s,dilations:a};let p=xe.runKernelFunc((e,i)=>{null==a&&(a=[1,1,1]);const l=Un(u.shape,t,n,a,r,o,s);return i([u]),e.avgPool3d(u,l)},c,null,"AvgPool3D",h);return p=mt(p,u.dtype),l?Mt(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});function or(e,t){const n=e[0].length;e.forEach((e,t)=>{m(e.length===n,()=>`Error in concat${n}D: rank of tensors[${t}] must be the same as the rank of the rest (${n})`)}),m(t>=0&&t<n,()=>`Error in concat${n}D: axis must be between 0 and ${n-1}.`);const r=e[0];e.forEach((e,o)=>{for(let s=0;s<n;s++)m(s===t||e[s]===r[s],()=>`Error in concat${n}D: Shape of tensors[${o}] (${e}) does not match the shape of the rest (${r}) along the non-concatenated axis ${o}.`)})}function sr(e,t){const n=e[0].slice();for(let r=1;r<e.length;r++)n[t]+=e[r][t];return n}const ar=Me({concat_:function(e,t=0){m(e.length>=1,()=>"Pass at least one tensor to concat");let n=Te(e,"tensors","concat");"complex64"===n[0].dtype&&n.forEach(e=>{if("complex64"!==e.dtype)throw new Error(`Cannot concatenate complex64 tensors with a tensor\n          with dtype ${e.dtype}. `)});const r=E(t,n[0].shape)[0],o=sr(n.map(e=>e.shape),r);if(0===w(o))return Be([],o);if(n=n.filter(e=>e.size>0),1===n.length)return n[0];or(n.map(e=>e.shape),r);const s=n,a={axis:t};return xe.runKernelFunc((e,t)=>{const o=e.concat(n,r);return t(n),o},s,null,"Concat",a)}});const ir=Me({sigmoid_:function(e){const t=Ae(e,"x","sigmoid"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.sigmoid(t);return n([r]),r},n,null,"Sigmoid")}});const ur=Me({slice_:function(e,t,n){const r=Ae(e,"x","slice");if(0===r.rank)throw new Error("Slicing scalar is not possible");const[o,s]=sn(r,t,n);Ht(r,o,s);const a={x:r},i={begin:t,size:n};return xe.runKernelFunc((e,t)=>(t([r]),e.slice(r,o,s)),a,null,"Slice",i)}});const lr=Me({tanh_:function(e){const t=Ae(e,"x","tanh"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.tanh(t);return n([r]),r},n,null,"Tanh")}});const cr=Me({basicLSTMCell_:function(e,t,n,r,o,s){const a=Ae(e,"forgetBias","basicLSTMCell"),i=Ae(t,"lstmKernel","basicLSTMCell"),u=Ae(n,"lstmBias","basicLSTMCell"),l=Ae(r,"data","basicLSTMCell"),c=Ae(o,"c","basicLSTMCell"),h=Ae(s,"h","basicLSTMCell"),p=ar([l,h],1),d=$t(p,i),f=kn(d,u),m=f.shape[0],g=f.shape[1]/4,b=[m,g],y=ur(f,[0,0],b),w=ur(f,[0,g],b),k=ur(f,[0,2*g],b),v=ur(f,[0,3*g],b),x=kn(Sn(ir(y),lr(w)),Sn(c,ir(kn(a,k))));return[x,Sn(lr(x),ir(v))]}});const hr=Me({batchToSpaceND_:function(e,t,n){const r=Ae(e,"x","batchToSpaceND"),o=t.reduce((e,t)=>e*t);m(r.rank>=1+t.length,()=>`input rank is ${r.rank} but should be > than blockShape.length ${t.length}`),m(n.length===t.length,()=>`crops.length is ${n.length} but should be equal to blockShape.length  ${t.length}`),m(r.shape[0]%o==0,()=>`input tensor batch is ${r.shape[0]} but is not divisible by the product of the elements of blockShape ${t.join(" * ")} === ${o}`);const s={x:r},a={blockShape:t,crops:n};return xe.runKernelFunc(e=>e.batchToSpaceND(r,t,n),s,null,"BatchToSpaceND",a)}});function pr(e){return null==e?null:0===e.rank?Mt(e,[e.size]):1===e.rank?e:2===e.rank?Mt(e,[1,1,e.shape[0],e.shape[1]]):3===e.rank?Mt(e,[1,e.shape[0],e.shape[1],e.shape[2]]):e}const dr=Me({batchNorm_:function(e,t,n,r,o,s){null==s&&(s=.001);const a=Ae(e,"x","batchNorm"),i=Ae(t,"mean","batchNorm"),u=Ae(n,"variance","batchNorm");let l,c;null!=o&&(l=Ae(o,"scale","batchNorm")),null!=r&&(c=Ae(r,"offset","batchNorm")),m(i.rank===u.rank,()=>"Batch normalization gradient requires mean and variance to have equal ranks."),m(null==c||i.rank===c.rank,()=>"Batch normalization gradient requires mean and offset to have equal ranks."),m(null==l||i.rank===l.rank,()=>"Batch normalization gradient requires mean and scale to have equal ranks.");const h=function(e){let t;return t=0===e.rank||1===e.rank?Mt(e,[1,1,1,e.size]):2===e.rank?Mt(e,[1,1,e.shape[0],e.shape[1]]):3===e.rank?Mt(e,[1,e.shape[0],e.shape[1],e.shape[2]]):e,t}(a),p={x:h,scale:l,offset:c,mean:i,variance:u},d={varianceEpsilon:s},f=xe.runKernelFunc((e,t)=>(t([h,i,u,l]),e.batchNorm(h,pr(i),pr(u),pr(c),pr(l),s)),p,null,"FusedBatchNorm",d);return Mt(f,a.shape)}});const fr=Me({batchNorm2d_:function(e,t,n,r,o,s){const a=Ae(e,"x","batchNorm"),i=Ae(t,"mean","batchNorm"),u=Ae(n,"variance","batchNorm");let l,c;return null!=o&&(l=Ae(o,"scale","batchNorm")),null!=r&&(c=Ae(r,"offset","batchNorm")),m(2===a.rank,()=>"Error in batchNorm2D: x must be rank 2 but got rank "+a.rank+"."),m(2===i.rank||1===i.rank,()=>`Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank ${i.rank}.`),m(2===u.rank||1===u.rank,()=>`Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank ${u.rank}.`),null!=l&&m(2===l.rank||1===l.rank,()=>`Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank ${l.rank}.`),null!=c&&m(2===c.rank||1===c.rank,()=>`Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank ${c.rank}.`),dr(a,i,u,c,l,s)}});const mr=Me({batchNorm3d_:function(e,t,n,r,o,s){const a=Ae(e,"x","batchNorm"),i=Ae(t,"mean","batchNorm"),u=Ae(n,"variance","batchNorm");let l,c;return null!=o&&(l=Ae(o,"scale","batchNorm")),null!=r&&(c=Ae(r,"offset","batchNorm")),m(3===a.rank,()=>"Error in batchNorm3D: x must be rank 3 but got rank "+a.rank+"."),m(3===i.rank||1===i.rank,()=>`Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank ${i.rank}.`),m(3===u.rank||1===u.rank,()=>`Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank ${u.rank}.`),null!=l&&m(3===l.rank||1===l.rank,()=>`Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank ${l.rank}.`),null!=c&&m(3===c.rank||1===c.rank,()=>`Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank ${c.rank}.`),dr(a,i,u,c,l,s)}});const gr=Me({batchNorm4d_:function(e,t,n,r,o,s){const a=Ae(e,"x","batchNorm"),i=Ae(t,"mean","batchNorm"),u=Ae(n,"variance","batchNorm");let l,c;return null!=o&&(l=Ae(o,"scale","batchNorm")),null!=r&&(c=Ae(r,"offset","batchNorm")),m(4===a.rank,()=>"Error in batchNorm4D: x must be rank 4 but got rank "+a.rank+"."),m(4===i.rank||1===i.rank,()=>`Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank ${i.rank}.`),m(4===u.rank||1===u.rank,()=>`Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank ${u.rank}.`),null!=l&&m(4===l.rank||1===l.rank,()=>`Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank ${l.rank}.`),null!=c&&m(4===c.rank||1===c.rank,()=>`Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank ${c.rank}.`),dr(a,i,u,c,l,s)}});const br=Me({broadcastTo_:function(e,t){let n=Ae(e,"broadcastTo","x");const r=n.shape;if(t.some(e=>!(e>0)||e%1!=0))throw new Error(`broadcastTo(): Invalid broadcast shape [${t}].`);if(t.length<n.rank)throw new Error(`broadcastTo(): shape.length=${t.length} < input.rank=${n.rank}.`);if(t.length>n.rank){const e=n.shape.slice();for(;e.length<t.length;)e.unshift(1);n=Mt(n,e)}const o=n.shape,s=Array.from(t);for(let e=t.length-1;e>=0;e--)if(o[e]===t[e])s[e]=1;else if(1!==n.shape[e])throw new Error(`broadcastTo(): [${r}] cannot be broadcast to [${t}].`);if(0===s.map((e,t)=>e>1?t:-1).filter(e=>e>=0).length)return gt(n);const a={x:n},i={shape:t,inputShape:o};return xe.runKernelFunc(e=>e.tile(n,s),a,null,"BroadcastTo",i)}});const yr=Me({ceil_:function(e){const t=Ae(e,"x","ceil"),n={x:t};return xe.runKernelFunc(e=>e.ceil(t),n,null,"Ceil")}});const wr=Me({clipByValue_:function(e,t,n){const r=Ae(e,"x","clipByValue");m(t<=n,()=>`Error in clip: min (${t}) must be less than or equal to max (${n}).`);const o={x:r},s={clipValueMin:t,clipValueMax:n};return xe.runKernelFunc((e,o)=>{const s=e.clip(r,t,n);return o([r]),s},o,null,"ClipByValue",s)}});const kr=Me({concat1d_:function(e){return ar(e,0)}});const vr=Me({concat2d_:function(e,t){return ar(e,t)}});const xr=Me({concat3d_:function(e,t){return ar(e,t)}});const Sr=Me({concat4d_:function(e,t){return ar(e,t)}});const Er=Me({conv2d_:function(e,t,n,r,o="NHWC",s=[1,1],a){const i=Ae(e,"x","conv2d"),u=Ae(t,"filter","conv2d");let l=i,c=!1;3===i.rank&&(c=!0,l=Mt(i,[1,i.shape[0],i.shape[1],i.shape[2]])),m(4===l.rank,()=>`Error in conv2d: input must be rank 4, but got rank ${l.rank}.`),m(4===u.rank,()=>"Error in conv2d: filter must be rank 4, but got rank "+u.rank+"."),null!=a&&m(v(r),()=>`Error in conv2d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${r}.`);const h="NHWC"===o?l.shape[3]:l.shape[1];m(h===u.shape[2],()=>`Error in conv2d: depth of input (${h}) must match input depth for filter ${u.shape[2]}.`),m(er(n,s),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${s}'`);const p={x:l,filter:u},d={strides:n,pad:r,dataFormat:o,dilations:s,dimRoundingMode:a},f=xe.runKernelFunc((e,t)=>{const i=tr(o),c=Vn(l.shape,u.shape,n,s,r,a,!1,i),h=e.conv2d(l,u,c);return t([l,u]),h},p,null,"Conv2D",d);return c?Mt(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});const Dr=Me({conv1d_:function(e,t,n,r,o="NWC",s=1,a){const i=Ae(e,"x","conv1d"),u=Ae(t,"filter","conv1d");let l=i,c=!1;2===i.rank&&(c=!0,l=Mt(i,[1,i.shape[0],i.shape[1]])),m(3===l.rank,()=>`Error in conv1d: input must be rank 3, but got rank ${l.rank}.`),m(3===u.rank,()=>"Error in conv1d: filter must be rank 3, but got rank "+u.rank+"."),null!=a&&m(v(r),()=>`Error in conv1d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${r}.`),m(l.shape[2]===u.shape[1],()=>`Error in conv1d: depth of input (${l.shape[2]}) must match input depth for filter ${u.shape[1]}.`),m(er(n,s),()=>`Error in conv1D: Either stride or dilation must be 1. Got stride ${n} and dilation '${s}'`),m("NWC"===o,()=>`Error in conv1d: got dataFormat of ${o} but only NWC is currently supported.`);const h=Mt(u,[1,u.shape[0],u.shape[1],u.shape[2]]),p=Mt(l,[l.shape[0],1,l.shape[1],l.shape[2]]),d=Er(p,h,[1,n],r,"NHWC",[1,s],a);return Mt(d,c?[d.shape[2],d.shape[3]]:[d.shape[0],d.shape[2],d.shape[3]])}});const Nr=Me({conv2DBackpropInput_:function(e,t,n,r,o,s="NHWC",a){m(e.length===t.rank,()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`);let i=e,u=t,l=!1;3===t.rank&&(l=!0,u=Mt(t,[1,t.shape[0],t.shape[1],t.shape[2]]),i=[1,e[0],e[1],e[2]]),m(4===i.length,()=>"Error in conv2dDerInput: inShape must be length 4, but got length "+i.length+"."),m(4===u.rank,()=>"Error in conv2dDerInput: dy must be rank 4, but got rank "+u.rank),m(4===n.rank,()=>"Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank);const c="NHWC"===s?i[3]:i[1],h="NHWC"===s?u.shape[3]:u.shape[1];m(c===n.shape[2],()=>`Error in conv2dDerInput: depth of input (${c}) must match input depth for filter ${n.shape[2]}.`),m(h===n.shape[3],()=>`Error in conv2dDerInput: depth of output (${h}) must match output depth for filter ${n.shape[3]}.`),null!=a&&m(v(o),()=>`Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode ${a} but got pad ${o}.`);const p={dy:u,filter:n},d={strides:r,pad:o,dataFormat:s,dimRoundingMode:a,inputShape:i},f=xe.runKernelFunc((e,t)=>{const l=tr(s),c=Vn(i,n.shape,r,1,o,a,!1,l),h=e.conv2dDerInput(u,n,c);return t([u,n]),h},p,null,"Conv2DBackpropInput",d);return l?Mt(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});const Ir=Me({conv2dTranspose_:function(e,t,n,r,o,s){const a=Ae(e,"x","conv2dTranspose"),i=Ae(t,"filter","conv2dTranspose");return Nr(n,a,i,r,o,"NHWC",s)}});const Fr=Me({conv3d_:function(e,t,n,r,o="NDHWC",s=[1,1,1]){const a=Ae(e,"x","conv3d"),i=Ae(t,"filter","conv3d");let u=a,l=!1;4===a.rank&&(l=!0,u=Mt(a,[1,a.shape[0],a.shape[1],a.shape[2],a.shape[3]])),m(5===u.rank,()=>`Error in conv3d: input must be rank 5, but got rank ${u.rank}.`),m(5===i.rank,()=>"Error in conv3d: filter must be rank 5, but got rank "+i.rank+"."),m(u.shape[4]===i.shape[3],()=>`Error in conv3d: depth of input (${u.shape[4]}) must match input depth for filter ${i.shape[3]}.`),m(er(n,s),()=>`Error in conv3D: Either strides or dilations must be 1. Got strides ${n} and dilations '${s}'`),m("NDHWC"===o,()=>`Error in conv3d: got dataFormat of ${o} but only NDHWC is currently supported.`);const c={x:u,filter:i},h={strides:n,pad:r,dataFormat:o,dilations:s},p=xe.runKernelFunc((e,t)=>{const o=Hn(u.shape,i.shape,n,s,r),a=e.conv3d(u,i,o);return t([u,i]),a},c,null,"Conv3D",h);return l?Mt(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const Ar=Me({conv3DBackpropInput_:function(e,t,n,r,o){m(e.length===t.rank,()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`);let s=e,a=t,i=!1;4===t.rank&&(i=!0,a=Mt(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]),s=[1,e[0],e[1],e[2],e[3]]);const u=s[4],l=a.shape[4];m(5===s.length,()=>"Error in conv3dDerInput: inShape must be length 5, but got length "+s.length+"."),m(5===a.rank,()=>"Error in conv3dDerInput: dy must be rank 5, but got rank "+a.rank),m(5===n.rank,()=>"Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank),m(u===n.shape[3],()=>`Error in conv3dDerInput: depth of input (${u}) must match input depth for filter ${n.shape[3]}.`),m(l===n.shape[4],()=>`Error in conv3dDerInput: depth of output (${l}) must match output depth for filter ${n.shape[4]}.`);const c={dy:a},h={pad:o},p=xe.runKernelFunc(e=>{const t=Hn(s,n.shape,r,1,o);return e.conv3dDerInput(a,n,t)},c,null,"Conv3DBackpropInputV2",h);return i?Mt(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const Tr=Me({conv3dTranspose_:function(e,t,n,r,o){const s=Ae(e,"x","conv3dTranspose"),a=Ae(t,"filter","conv3dTranspose");return Ar(n,s,a,r,o)}});const Mr=Me({cos_:function(e){const t=Ae(e,"x","cos"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.cos(t);return n([t]),r},n,null,"Cos")}});const $r=Me({cosh_:function(e){const t=Ae(e,"x","cosh"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.cosh(t);return n([t]),r},n,null,"Cosh")}});const _r=Me({cumsum_:function(e,t=0,n=!1,r=!1){const o=Ae(e,"x","cumsum"),s={x:o},a={axis:t,exclusive:n,reverse:r};return xe.runKernelFunc((e,s)=>{const a=$n([t],o.rank);let i=o;null!=a&&(i=Bt(o,a));const u=Bn(1,o.rank)[0];let l=e.cumsum(i,u,n,r);if(s([o]),null!=a){const e=_n(a);l=Bt(l,e)}return l},s,null,"Cumsum",a)}});const Br=Me({depthToSpace_:function(e,t,n="NHWC"){const r=Ae(e,"x","depthToSpace"),o="NHWC"===n?r.shape[1]:r.shape[2],s="NHWC"===n?r.shape[2]:r.shape[3],a="NHWC"===n?r.shape[3]:r.shape[1];m(o*t>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${o} and ${t}  for depthToSpace with input shape\n    ${r.shape}`),m(s*t>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${s} and ${t} for depthToSpace with input shape\n        ${r.shape}`),m(a%(t*t)==0,()=>`Dimension size must be evenly divisible by ${t*t} but is ${a} for depthToSpace with input shape ${r.shape}`);const i={x:r},u={blockSize:t,dataFormat:n};return xe.runKernelFunc(e=>e.depthToSpace(r,t,n),i,null,"DepthToSpace",u)}});const Cr=Me({depthwiseConv2d_:function(e,t,n,r,o="NHWC",s=[1,1],a){const i=Ae(e,"x","depthwiseConv2d"),u=Ae(t,"filter","depthwiseConv2d");let l=i,c=!1;3===i.rank&&(c=!0,l=Mt(i,[1,i.shape[0],i.shape[1],i.shape[2]])),m(4===l.rank,()=>`Error in depthwiseConv2d: input must be rank 4, but got rank ${l.rank}.`),m(4===u.rank,()=>"Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+"."),m(l.shape[3]===u.shape[2],()=>`Error in depthwiseConv2d: number of input channels (${l.shape[3]}) must match the inChannels dimension in filter ${u.shape[2]}.`),null!=a&&m(v(r),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${r}.`);const h={x:l,filter:u},p={strides:n,pad:r,dataFormat:o,dilations:s,dimRoundingMode:a},d=xe.runKernelFunc((e,t)=>{null==s&&(s=[1,1]),m(er(n,s),()=>`Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides ${n} and dilations '${s}'`);const o=Vn(l.shape,u.shape,n,s,r,a,!0),i=e.depthwiseConv2D(l,u,o);return t([l,u]),i},h,null,"DepthwiseConv2dNative",p);return c?Mt(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});const Rr=Me({diag_:function(e){const t=Ae(e,"x","diag"),n={x:t};return xe.runKernelFunc(n=>{const r=Mt(t,[t.size]),o=n.diag(r),s=[...e.shape,...e.shape];return Mt(o,s)},n,null,"Diag")}});const Pr=Me({dilation2d_:function(e,t,n,r,o=[1,1],s="NHWC"){const a=Ae(e,"x","dilation2d"),i=Ae(t,"filter","dilation2d");m(3===a.rank||4===a.rank,()=>"Error in dilation2d: input must be rank 3 or 4, but got rank "+a.rank+"."),m(3===i.rank,()=>"Error in dilation2d: filter must be rank 3, but got rank "+i.rank+"."),m("NHWC"===s,()=>"Error in dilation2d: Only NHWC is currently supported, but got dataFormat of "+s);let u=a,l=!1;3===a.rank&&(u=Mt(a,[1,a.shape[0],a.shape[1],a.shape[2]]),l=!0);const c={x:u,filter:i},h={strides:n,pad:r,dilations:o},p=xe.runKernel("Dilation2D",c,h);return l?Mt(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});function zr(e,t){const n=[];for(let r=0;r<t.length;r++){const o=e[e.length-r-1],s=t.length-r-1,a=t[s];(null==o||1===o&&a>1)&&n.unshift(s)}return n}function Lr(e,t){const n=[],r=Math.max(e.length,t.length);for(let o=0;o<r;o++){let r=e[e.length-o-1];null==r&&(r=1);let s=t[t.length-o-1];if(null==s&&(s=1),1===r)n.unshift(s);else if(1===s)n.unshift(r);else{if(r!==s){throw Error(`Operands could not be broadcast together with shapes ${e} and ${t}.`)}n.unshift(r)}}return n}const qr=Me({equal_:function(e,t){let n=Ae(e,"a","equal"),r=Ae(t,"b","equal");[n,r]=me(n,r),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc(e=>e.equal(n,r),o,null,"Equal")}});const Or=Me({where_:function(e,t,n){const r=Ae(t,"a","where"),o=Ae(n,"b","where"),s=Ae(e,"condition","where","bool"),a=Lr(r.shape,o.shape),i=br(r,a),u=br(o,a);1===s.rank&&m(s.shape[0]===r.shape[0],()=>"The first dimension of `a` must match the size of `condition`."),1!==s.rank&&g(s.shape,u.shape,"Error in where: ");const l={condition:s,t:i,e:u};return xe.runKernelFunc((e,t)=>{const n=e.select(s,i,u);return t([s]),n},l,null,"SelectV2")}});const Wr=Me({zerosLike_:function(e){const t=Ae(e,"x","zerosLike"),n={x:t};return xe.runKernelFunc(e=>e.zerosLike(t),n,null,"ZerosLike")}});const Kr=Me({divNoNan_:function(e,t){let n=Ae(e,"a","div"),r=Ae(t,"b","div");[n,r]=me(n,r);const o=xn(n,r),s=Wr(o),a=qr(r,s);return Or(a,s,o)}});const Gr=Me({dot_:function(e,t){const n=Ae(e,"t1","dot"),r=Ae(t,"t2","dot");m(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),()=>`Error in dot: inputs must all be rank 1 or 2, but got ranks ${n.rank} and ${r.rank}.`);const o=1===n.rank?n.size:n.shape[1],s=1===r.rank?r.size:r.shape[0];if(m(o===s,()=>`Error in dot: inner dimensions of inputs must match, but got ${o} and ${s}.`),1===n.rank&&1===r.rank){const e=Mt(n,[1,-1]),t=Mt(r,[-1,1]),o=$t(e,t);return Mt(o,[])}if(1===n.rank&&2===r.rank){const e=Mt(n,[1,-1]),t=Mt(r,[r.shape[0],r.shape[1]]),o=$t(e,t);return Mt(o,[o.size])}if(2===n.rank&&1===r.rank){const e=Mt(r,[-1,1]),t=$t(n,e);return Mt(t,[t.size])}{const e=Mt(r,[r.shape[0],r.shape[1]]);return $t(n,e)}}});const Ur=Me({elu_:function(e){const t=Ae(e,"x","elu"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.elu(t);return n([r]),r},n,null,"Elu")}});const Vr=Me({erf_:function(e){let t=Ae(e,"x","erf");m("int32"===t.dtype||"float32"===t.dtype,()=>"Input dtype must be `int32` or `float32`."),"int32"===t.dtype&&(t=mt(t,"float32"));const n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.erf(t);return n([t]),r},n,null,"Erf")}});const Hr=Me({exp_:function(e){const t=Ae(e,"x","exp"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.exp(t);return n([r]),r},n,null,"Exp")}});const jr=Me({expandDims_:function(e,t=0){const n=Ae(e,"x","expandDims",null);m(t<=n.rank,()=>"Axis must be <= rank of the tensor");const r=n.shape.slice();return t<0&&(m(-(n.rank+1)<=t,()=>`Axis must be in the interval [${-(n.rank+1)}, ${n.rank}]`),t=n.rank+t+1),r.splice(t,0,1),Mt(n,r)}});const Jr=Me({expm1_:function(e){const t=Ae(e,"x","expm1"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.expm1(t);return n([t]),r},n,null,"Expm1")}});const Yr=Me({tile_:function(e,t){const n=Ae(e,"x","tile",null);m(n.rank===t.length,()=>`Error in transpose: rank of input ${n.rank} must match length of reps ${t}.`);const r=[n],o={x:n},s={reps:t};return xe.runKernelFunc((e,r)=>{const o=e.tile(n,t);return r([n]),o},o,null,"Tile",s,r)}});const Zr=Me({eye_:function(e,t,n,r="float32"){null==t&&(t=e);const o=ft([e,t],r),s=e<=t?e:t;for(let e=0;e<s;++e)o.set(1,e,e);const a=Mt(o.toTensor(),[e,t]);if(null==n)return a;if(1===n.length)return Yr(jr(a,0),[n[0],1,1]);if(2===n.length)return Yr(jr(jr(a,0),0),[n[0],n[1],1,1]);if(3===n.length)return Yr(jr(jr(jr(a,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(`eye() currently supports only 1D and 2D batchShapes, but received ${n.length}D.`)}});function Xr(e,t,n){const r={shape:e,value:t,dtype:n};return xe.runKernelFunc(r=>r.fill(e,t,n),{},null,"Fill",r)}const Qr=Me({floor_:function(e){const t=Ae(e,"x","floor"),n={x:t};return xe.runKernelFunc(e=>e.floor(t),n,null,"Floor")}});function eo(e,t,n){const r=e.shape[n],o=[];let s=1,a=1;for(let t=0;t<n;t++)o.push(e.shape[t]),s*=e.shape[t];for(let e=0;e<t.rank;e++)o.push(t.shape[e]);for(let t=n+1;t<e.rank;t++)o.push(e.shape[t]),a*=e.shape[t];return{batchSize:s,sliceSize:a,dimSize:r,outputShape:o}}var to=Object.freeze({__proto__:null,segOpComputeOptimalWindowSize:function(e,t){let n,r=!1;for(e<=30?(n=e,r=!0):n=L(e,Math.floor(Math.sqrt(e)));!r;)n>t||n===e?r=!0:n=L(e,n+1);return n},computeOutShape:function(e,t,n){const r=[],o=e.length;for(let s=0;s<o;s++)s!==t?r.push(e[s]):r.push(n);return r},collectGatherOpShapeInfo:eo});const no=Me({gather_:function(e,t,n=0){const r=Ae(e,"x","gather"),o=Ae(t,"indices","gather","int32"),s={x:r,indices:o},a={axis:n};return xe.runKernelFunc((e,t)=>{const s=E(n,r.shape)[0],a=eo(r,o,s),i=e.gather(r,Mt(o,[o.size]),s);return t([r,o]),Mt(i,a.outputShape)},s,null,"GatherV2",a)}});const ro=Me({greater_:function(e,t){let n=Ae(e,"a","greater"),r=Ae(t,"b","greater");[n,r]=me(n,r),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc(e=>e.greater(n,r),o,null,"Greater")}});const oo=Me({greaterEqual_:function(e,t){let n=Ae(e,"a","greaterEqual"),r=Ae(t,"b","greaterEqual");[n,r]=me(n,r),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.greaterEqual(n,r);return t([n,r]),o},o,null,"GreaterEqual")}});const so=Me({imag_:function(e){const t=Ae(e,"input","imag"),n={input:t};return xe.runKernelFunc(e=>e.imag(t),n,null,"Imag")}});const ao=Me({isFinite_:function(e){const t=Ae(e,"x","isFinite"),n={x:t};return xe.runKernelFunc(e=>e.isFinite(t),n,null,"IsFinite")}});const io=Me({isInf_:function(e){const t=Ae(e,"x","isInf"),n={x:t};return xe.runKernelFunc(e=>e.isInf(t),n,null,"IsInf")}});const uo=Me({isNaN_:function(e){const t=Ae(e,"x","isNaN"),n={x:t};return xe.runKernelFunc(e=>e.isNaN(t),n,null,"IsNan")}});const lo=Me({maximum_:function(e,t){let n=Ae(e,"a","maximum"),r=Ae(t,"b","maximum");[n,r]=me(n,r),"bool"===n.dtype&&(n=mt(n,"int32"),r=mt(r,"int32")),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.maximum(n,r);return t([n,r]),o},o,null,"Maximum")}});function co(e,t){if((M(e)&&"string"!==t||Array.isArray(e))&&"complex64"!==t)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===t&&M(e)&&!(e instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return _e(e,[],[],t)}const ho=Me({leakyRelu_:function(e,t=.2){const n=Ae(e,"x","leakyRelu");return lo(Sn(co(t),n),n)}});const po=Me({less_:function(e,t){let n=Ae(e,"a","less"),r=Ae(t,"b","less");[n,r]=me(n,r),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc(e=>e.less(n,r),o,null,"Less")}});const fo=Me({lessEqual_:function(e,t){let n=Ae(e,"a","lessEqual"),r=Ae(t,"b","lessEqual");[n,r]=me(n,r),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.lessEqual(n,r);return t([n,r]),o},o,null,"LessEqual")}});const mo=Me({localResponseNormalization_:function(e,t=5,n=1,r=1,o=.5){const s=Ae(e,"x","localResponseNormalization");m(4===s.rank||3===s.rank,()=>`Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ${s.rank}.`),m(v(t),()=>`Error in localResponseNormalization: depthRadius must be an integer but got depthRadius ${t}.`);let a=s,i=!1;3===s.rank&&(i=!0,a=Mt(s,[1,s.shape[0],s.shape[1],s.shape[2]]));const u={x:a},l={depthRadius:t,bias:n,alpha:r,beta:o},c=xe.runKernelFunc((e,s)=>{const i=e.localResponseNormalization4D(a,t,n,r,o);return s([a,i]),i},u,null,"LRN",l);return i?Mt(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const go=Me({log_:function(e){const t=Ae(e,"x","log"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.log(t);return n([t]),r},n,null,"Log")}});const bo=Me({log1p_:function(e){const t=Ae(e,"x","log1p"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.log1p(t);return n([t]),r},n,null,"Log1p")}});function yo(e,t){m(z(e),()=>"The f passed in variableGrads(f) must be a function"),m(null==t||Array.isArray(t)&&t.every(e=>e instanceof ie),()=>"The varList passed in variableGrads(f, varList) must be an array of variables");const n=null!=t;if(!n){t=[];for(const e in xe.registeredVariables)t.push(xe.registeredVariables[e])}const r=n?t.filter(e=>!e.trainable):null,o=t.length;m((t=t.filter(e=>e.trainable)).length>0,()=>`variableGrads() expects at least one of the input variables to be trainable, but none of the ${o} variables is trainable.`);const{value:s,grads:a}=xe.gradients(e,t,null,!0);m(a.some(e=>null!=e),()=>"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize()."),m(0===s.rank,()=>`The f passed in variableGrads(f) must return a scalar, but it returned a rank-${s.rank} tensor`);const i={};return t.forEach((e,t)=>{null!=a[t]&&(i[e.name]=a[t])}),null!=r&&r.forEach(e=>i[e.name]=null),{value:s,grads:i}}function wo(e){return xe.customGrad(e)}function ko(e){if(e.filter(e=>null==e).length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that\n    the f you passed encloses all operations that lead from x to y.")}const vo=Me({neg_:function(e){const t=Ae(e,"x","neg"),n={x:t};return xe.runKernelFunc(e=>e.neg(t),n,null,"Negate")}});const xo=Me({softplus_:function(e){const t=Ae(e,"x","softplus"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.softplus(t);return n([t]),r},n,null,"Softplus")}});const So=Me({logSigmoid_:function(e){const t=Ae(e,"x","logSigmoid");return wo(e=>({value:vo(xo(vo(e))),gradFunc:t=>Sn(t,ir(vo(e)))}))(t)}});const Eo=Me({max_:function(e,t=null,n=!1){const r=Ae(e,"x","max"),o={x:r},s={reductionIndices:t,keepDims:n};return xe.runKernelFunc((e,o)=>{let s=E(t,r.shape);const a=$n(s,r.rank);let i=r;null!=a&&(i=Bt(r,a),s=Bn(s.length,i.rank));const u=e.max(i,s);null!=a&&i.dispose();let l=u;if(n){const e=Mn(l.shape,E(t,r.shape));l=Mt(l,e),u.dispose()}return o([r,l]),l},o,null,"Max",s)}});const Do=Me({sub_:function(e,t){let n=Ae(e,"a","sub"),r=Ae(t,"b","sub");[n,r]=me(n,r);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.subtract(n,r);return t([n,r]),o},o,null,"Sub")}});const No=Me({sum_:function(e,t=null,n=!1){let r=Ae(e,"x","sum");"bool"===r.dtype&&(r=mt(r,"int32"));const o={x:r},s={axis:t,keepDims:n};return xe.runKernelFunc((e,o)=>{o([r]);const s=E(t,r.shape),a=$n(s,r.rank);let i=s,u=r;null!=a&&(u=Bt(r,a),i=Bn(i.length,r.rank));let l=e.sum(u,i);if(n){const e=Mn(l.shape,s);l=Mt(l,e)}return l},o,null,"Sum",s)}});const Io=Me({logSoftmax_:function(e,t=-1){const n=Ae(e,"logits","logSoftmax");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Log Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and axis was ${t}`);const r={logits:n},o={axis:t};return xe.runKernelFunc((n,r)=>{const o=Eo(e,t,!0),s=Do(e,o),a=Do(mt(s,"float32"),go(No(Hr(s),t,!0)));return r([a]),a},r,null,"LogSoftmax",o)}});const Fo=Me({logSumExp_:function(e,t=null,n=!1){const r=Ae(e,"x","logSumExp"),o=E(t,r.shape),s=Eo(r,o,!0),a=Do(r,s),i=Hr(a),u=No(i,o),l=go(u),c=kn(Mt(s,l.shape),l);if(n){const e=Mn(c.shape,o);return Mt(c,e)}return c}});const Ao=Me({logicalAnd_:function(e,t){const n=Ae(e,"a","logicalAnd","bool"),r=Ae(t,"b","logicalAnd","bool");Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc(e=>e.logicalAnd(n,r),o,null,"LogicalAnd")}});const To=Me({logicalNot_:function(e){const t=Ae(e,"x","logicalNot","bool"),n={x:t};return xe.runKernelFunc(e=>e.logicalNot(t),n,null,"LogicalNot")}});const Mo=Me({logicalOr_:function(e,t){const n=Ae(e,"a","logicalOr","bool"),r=Ae(t,"b","logicalOr","bool");Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc(e=>e.logicalOr(n,r),o,null,"LogicalOr")}});const $o=Me({logicalXor_:function(e,t){const n=Ae(e,"a","logicalXor","bool"),r=Ae(t,"b","logicalXor","bool");return Lr(n.shape,r.shape),Ao(Mo(e,t),To(Ao(e,t)))}});const _o=Me({maxPool_:function(e,t,n,r,o){const s=Ae(e,"x","maxPool");let a=s,i=!1;3===s.rank&&(i=!0,a=Mt(s,[1,s.shape[0],s.shape[1],s.shape[2]])),m(4===a.rank,()=>`Error in maxPool: input must be rank 4 but got rank ${a.rank}.`),m(er(n,1),()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`),null!=o&&m(v(r),()=>`Error in maxPool: pad must be an integer when using, dimRoundingMode ${o} but got pad ${r}.`);const u={x:a},l={filterSize:t,strides:n,pad:r,dimRoundingMode:o},c=xe.runKernelFunc((e,s)=>{const i=Gn(a.shape,t,n,1,r,o);let u;return u=1===i.filterWidth&&1===i.filterHeight&&k(i.inShape,i.outShape)?a.clone():e.maxPool(a,i),s([a,u]),u},u,null,"MaxPool",l);return i?Mt(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const Bo=Me({maxPool3d_:function(e,t=[1,1,1],n,r,o,s="NDHWC",a){null==a?a=[1,1,1]:gn("dilations is deprecated, this field will be gone in v3.0.0.");const i=Ae(e,"x","maxPool3d");let u=i,l=!1;4===i.rank&&(l=!0,u=Mt(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),m(5===u.rank,()=>`Error in maxPool3d: x must be rank 5 but got rank ${u.rank}.`),m("NDHWC"===s,()=>"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of "+s),m(er(n,a),()=>`Error in maxPool3d: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),null!=o&&m(v(r),()=>`Error in maxPool3d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${r}.`);const c={x:u},h={filterSize:t,strides:n,pad:r,dimRoundingMode:o,dataFormat:s,dilations:a},p=xe.runKernelFunc((e,i)=>{null==a&&(a=[1,1,1]);const l=Un(u.shape,t,n,a,r,o,s),c=e.maxPool3d(u,l);return i([u,c]),c},c,null,"MaxPool3D",h);return l?Mt(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const Co=Me({maxPoolWithArgmax_:function(e,t,n,r,o=!1){const s={x:Ae(e,"x","maxPoolWithArgmax")},a={filterSize:t,strides:n,pad:r,includeBatchInIndex:o},i=xe.runKernel("MaxPoolWithArgmax",s,a);return{result:i[0],indexes:i[1]}}});function Ro(e,t="float32"){if("complex64"===t){const t=Ro(e,"float32"),n=Ro(e,"float32");return $e(t,n)}const n=G(w(e),t);return xe.makeTensor(n,e,t)}function Po(e,t="float32"){if("complex64"===t){const t=Po(e,"float32"),n=Ro(e,"float32");return $e(t,n)}const n=K(w(e),t);return xe.makeTensor(n,e,t)}const zo=Me({mean_:function(e,t=null,n=!1){const r=Ae(e,"x","mean"),o=E(t,r.shape),s=w(Tn(r.shape,o)[1]);return wo(e=>{const r=co(s),a=r.dtype===e.dtype?e:mt(e,r.dtype),i=xn(a,r);return{value:No(i,t,n),gradFunc:t=>{const n=e.shape.slice();o.forEach(e=>{n[e]=1});const r=Mt(t,n);return xn(Sn(r,Po(e.shape,"float32")),s)}}})(r)}});const Lo=Me({min_:function(e,t=null,n=!1){const r=Ae(e,"x","min"),o={x:r},s={axis:t,keepDims:n};return xe.runKernelFunc((e,o)=>{const s=E(t,r.shape);let a=s;const i=$n(a,r.rank);let u=r;null!=i&&(u=Bt(r,i),a=Bn(a.length,r.rank));const l=e.min(u,a);null!=i&&u.dispose();let c=l;if(n){const e=Mn(c.shape,s);c=Mt(l,e),l.dispose()}return o([r,c]),c},o,null,"Min",s)}});const qo=Me({minimum_:function(e,t){let n=Ae(e,"a","minimum"),r=Ae(t,"b","minimum");[n,r]=me(n,r),"bool"===n.dtype&&(n=mt(n,"int32"),r=mt(r,"int32")),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.minimum(n,r);return t([n,r]),o},o,null,"Minimum")}});const Oo=Me({mod_:function(e,t){let n=Ae(e,"a","mod"),r=Ae(t,"b","mod");[n,r]=me(n,r);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.mod(n,r);return t([n,r]),o},o,null,"Mod")}});const Wo=Me({square_:function(e){const t=Ae(e,"x","square"),n=[t];return xe.runKernelFunc((e,n)=>(n([t]),e.square(t)),{x:t},null,"Square",{},n,[])}});const Ko=Me({moments_:function(e,t=null,n=!1){const r=E(t,(e=Ae(e,"x","moments")).shape),o=zo(e,r,n);let s=o.shape;n||(s=Mn(o.shape,r));const a=Wo(Do(mt(e,"float32"),Mt(o,s)));return{mean:o,variance:zo(a,r,n)}}});const Go=Me({multiRNNCell_:function(e,t,n,r){const o=Ae(t,"data","multiRNNCell"),s=Te(n,"c","multiRNNCell"),a=Te(r,"h","multiRNNCell");let i=o;const u=[];for(let t=0;t<e.length;t++){const n=e[t](i,s[t],a[t]);u.push(n[0]),u.push(n[1]),i=n[1]}const l=[],c=[];for(let e=0;e<u.length;e+=2)l.push(u[e]),c.push(u[e+1]);return[l,c]}});const Uo=Me({multinomial_:function(e,t,n,r=!1){const o=Ae(e,"logits","multinomial"),s=o.size,a=o.rank;if(s<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+s+".");if(a>2)throw new Error("Rank of probabilities must be 1 or 2, but is "+a);n=n||Math.random();const i=1===a?Mt(o,[1,-1]):o,u=xe.runKernelFunc(e=>e.multinomial(i,r,t,n),{logits2D:i});return 1===a?Mt(u,[u.size]):u}});const Vo=Me({notEqual_:function(e,t){let n=Ae(e,"a","notEqual"),r=Ae(t,"b","notEqual");[n,r]=me(n,r),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc(e=>e.notEqual(n,r),o,null,"NotEqual")}});const Ho=Me({real_:function(e){const t=Ae(e,"input","real"),n={input:t};return xe.runKernelFunc(e=>e.real(t),n,null,"Real")}});const jo=Me({onesLike_:function(e){const t=Ae(e,"x","onesLike"),n={x:t};return xe.runKernelFunc((e,n)=>{if("complex64"===t.dtype){const e=jo(Ho(t)),n=Wr(so(t));return $e(e,n)}return e.onesLike(t)},n,null,"OnesLike")}});const Jo=Me({outerProduct_:function(e,t){const n=Ae(e,"v1","outerProduct"),r=Ae(t,"v2","outerProduct");m(1===n.rank&&1===r.rank,()=>`Error in outerProduct: inputs must be rank 1, but got ranks ${n.rank} and ${r.rank}.`);const o=Mt(n,[-1,1]),s=Mt(r,[1,-1]);return $t(o,s)}});const Yo=Me({pad_:function(e,t,n=0){const r=Ae(e,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");const o={paddings:t,constantValue:n},s={x:r};return xe.runKernelFunc((e,o)=>(o([r]),e.pad(r,t,n)),s,null,"PadV2",o)}});const Zo=Me({pad1d_:function(e,t,n=0){return m(2===t.length,()=>"Invalid number of paddings. Must be length of 2."),Yo(e,[t],n)}});const Xo=Me({pad2d_:function(e,t,n=0){return m(2===t.length&&2===t[0].length&&2===t[1].length,()=>"Invalid number of paddings. Must be length of 2 each."),Yo(e,t,n)}});const Qo=Me({pad3d_:function(e,t,n=0){return m(3===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length,()=>"Invalid number of paddings. Must be length of 2 each."),Yo(e,t,n)}});const es=Me({pad4d_:function(e,t,n=0){return m(4===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length&&2===t[3].length,()=>"Invalid number of paddings. Must be length of 2 each."),Yo(e,t,n)}});const ts=Me({spaceToBatchND_:function(e,t,n){const r=Ae(e,"x","spaceToBatchND");m(r.rank>=1+t.length,()=>`input rank ${r.rank} should be > than [blockShape] ${t.length}`),m(n.length===t.length,()=>`paddings.shape[0] ${n.length} must be equal to [blockShape] ${t.length}`),m(r.shape.reduce((e,r,o)=>o>0&&o<=t.length?e&&(r+n[o-1][0]+n[o-1][1])%t[o-1]==0:e,!0),()=>`input spatial dimensions ${r.shape.slice(1)} with paddings ${n.toString()} must be divisible by blockShapes ${t.toString()}`);const o={x:r},s={blockShape:t,paddings:n};return xe.runKernelFunc(e=>e.spaceToBatchND(r,t,n),o,null,"SpaceToBatchND",s)}});const ns=Me({pool_:function(e,t,n,r,o,s){null==o&&(o=[1,1]),null==s&&(s=1),0===r&&(r="valid");const a=Ae(e,"x","maxPool");let i=a,u=!1;3===a.rank&&(u=!0,i=Mt(a,[1,a.shape[0],a.shape[1],a.shape[2]])),m(er(s,o),()=>`Error in pool: Either strides or dilations must be 1. Got strides ${s} and dilations '${o}'`);const l=Gn(i.shape,t,s,o,r),c=[l.dilationHeight,l.dilationWidth];let h;h="same"===r?function(e,t){const n=e.map((e,n)=>e+(e-1)*(t[n]-1)).map(e=>e-1),r=n.map(e=>Math.floor(e/2)),o=n.map((e,t)=>e-r[t]);return n.map((e,t)=>[r[t],o[t]])}([l.filterHeight,l.filterWidth],c):[[0,0],[0,0]];const p=1===c[0]&&1===c[1],[d,f]=function(e,t,n){const r=n.map(e=>e[0]),o=n.map(e=>e[1]),s=e.concat(r,o),a=t.map((e,t)=>(e-s[t]%e)%e),i=o.map((e,t)=>e+a[t]),u=t.map((e,t)=>[r[t],i[t]]),l=t.map((e,t)=>[0,a[t]]);return[u,l]}([l.inHeight,l.inWidth],c,h),g=p?r:"valid",b=p?i:ts(i,c,d),y=("avg"===n?()=>nr(b,t,s,g):()=>_o(b,t,s,g))(),w=p?y:hr(y,c,f);return u?Mt(w,[w.shape[1],w.shape[2],w.shape[3]]):w}});const rs=Me({pow_:function(e,t){let n=Ae(e,"base","pow"),r=Ae(t,"exp","pow");[n,r]=me(n,r);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.pow(n,r);return t([n,r,o]),o},o,null,"Pow")}});const os=Me({prelu_:function(e,t){const n=Ae(e,"x","prelu"),r=Ae(t,"alpha","prelu"),o={x:n,alpha:r};return xe.runKernelFunc((e,t)=>{const o=e.prelu(n,r);return t([n,r]),o},o,null,"Prelu")}});const ss=Me({prod_:function(e,t=null,n=!1){let r=Ae(e,"x","prod");const o={x:r},s={axis:t,keepDims:n};return xe.runKernelFunc(e=>{"bool"===r.dtype&&(r=mt(r,"int32"));const o=E(t,r.shape),s=$n(o,r.rank);let a=o,i=r;null!=s&&(i=Bt(r,s),a=Bn(a.length,r.rank));let u=e.prod(i,a);if(n){const e=Mn(u.shape,o);u=Mt(u,e)}return u},o,null,"Prod",s)}});const as=Me({rand_:function(e,t,n){const r=w(e);let o=null;if(null==n||"float32"===n)o=new Float32Array(r);else if("int32"===n)o=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type "+n);o=new Uint8Array(r)}for(let e=0;e<r;e++)o[e]=t();return xe.makeTensor(o,e,n)}});"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function is(e,t){return e(t={exports:{}},t.exports),t.exports}var us=is((function(e){!function(e,t,n){function r(e){var t,n=this,r=(t=4022871197,function(e){e=e.toString();for(var n=0;n<e.length;n++){var r=.02519603282416938*(t+=e.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)});n.next=function(){var e=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=e-(n.c=0|e)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(e),n.s0<0&&(n.s0+=1),n.s1-=r(e),n.s1<0&&(n.s1+=1),n.s2-=r(e),n.s2<0&&(n.s2+=1),r=null}function o(e,t){return t.c=e.c,t.s0=e.s0,t.s1=e.s1,t.s2=e.s2,t}function s(e,t){var n=new r(e),s=t&&t.state,a=n.next;return a.int32=function(){return 4294967296*n.next()|0},a.double=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.quick=a,s&&("object"==typeof s&&o(s,n),a.state=function(){return o(n,{})}),a}t&&t.exports?t.exports=s:n&&n.amd?n((function(){return s})):this.alea=s}(0,e,!1)})),ls=is((function(e){!function(e,t,n){function r(e){var t=this,n="";t.x=0,t.y=0,t.z=0,t.w=0,t.next=function(){var e=t.x^t.x<<11;return t.x=t.y,t.y=t.z,t.z=t.w,t.w^=t.w>>>19^e^e>>>8},e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),t.next()}function o(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t}function s(e,t){var n=new r(e),s=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,s&&("object"==typeof s&&o(s,n),a.state=function(){return o(n,{})}),a}t&&t.exports?t.exports=s:n&&n.amd?n((function(){return s})):this.xor128=s}(0,e,!1)})),cs=is((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.x^t.x>>>2;return t.x=t.y,t.y=t.z,t.z=t.w,t.w=t.v,(t.d=t.d+362437|0)+(t.v=t.v^t.v<<4^e^e<<1)|0},t.x=0,t.y=0,t.z=0,t.w=0,t.v=0,e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),r==n.length&&(t.d=t.x<<10^t.x>>>4),t.next()}function o(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t.v=e.v,t.d=e.d,t}function s(e,t){var n=new r(e),s=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,s&&("object"==typeof s&&o(s,n),a.state=function(){return o(n,{})}),a}t&&t.exports?t.exports=s:n&&n.amd?n((function(){return s})):this.xorwow=s}(0,e,!1)})),hs=is((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.x,o=t.i;return e=r[o],n=(e^=e>>>7)^e<<24,n^=(e=r[o+1&7])^e>>>10,n^=(e=r[o+3&7])^e>>>3,n^=(e=r[o+4&7])^e<<7,e=r[o+7&7],n^=(e^=e<<13)^e<<9,r[o]=n,t.i=o+1&7,n},function(e,t){var n,r=[];if(t===(0|t))r[0]=t;else for(t=""+t,n=0;n<t.length;++n)r[7&n]=r[7&n]<<15^t.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n?r[7]=-1:r[n],e.x=r,e.i=0,n=256;n>0;--n)e.next()}(t,e)}function o(e,t){return t.x=e.x.slice(),t.i=e.i,t}function s(e,t){null==e&&(e=+new Date);var n=new r(e),s=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,s&&(s.x&&o(s,n),a.state=function(){return o(n,{})}),a}t&&t.exports?t.exports=s:n&&n.amd?n((function(){return s})):this.xorshift7=s}(0,e,!1)})),ps=is((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.w,o=t.X,s=t.i;return t.w=r=r+1640531527|0,n=o[s+34&127],e=o[s=s+1&127],n^=n<<13,e^=e<<17,n^=n>>>15,e^=e>>>12,n=o[s]=n^e,t.i=s,n+(r^r>>>16)|0},function(e,t){var n,r,o,s,a,i=[],u=128;for(t===(0|t)?(r=t,t=null):(t+="\0",r=0,u=Math.max(u,t.length)),o=0,s=-32;s<u;++s)t&&(r^=t.charCodeAt((s+32)%t.length)),0===s&&(a=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,s>=0&&(a=a+1640531527|0,o=0==(n=i[127&s]^=r+a)?o+1:0);for(o>=128&&(i[127&(t&&t.length||0)]=-1),o=127,s=512;s>0;--s)r=i[o+34&127],n=i[o=o+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,i[o]=r^n;e.w=a,e.X=i,e.i=o}(t,e)}function o(e,t){return t.i=e.i,t.w=e.w,t.X=e.X.slice(),t}function s(e,t){null==e&&(e=+new Date);var n=new r(e),s=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,s&&(s.X&&o(s,n),a.state=function(){return o(n,{})}),a}t&&t.exports?t.exports=s:n&&n.amd?n((function(){return s})):this.xor4096=s}(0,e,!1)})),ds=is((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.b,n=t.c,r=t.d,o=t.a;return e=e<<25^e>>>7^n,n=n-r|0,r=r<<24^r>>>8^o,o=o-e|0,t.b=e=e<<20^e>>>12^n,t.c=n=n-r|0,t.d=r<<16^n>>>16^o,t.a=o-e|0},t.a=0,t.b=0,t.c=-1640531527,t.d=1367130551,e===Math.floor(e)?(t.a=e/4294967296|0,t.b=0|e):n+=e;for(var r=0;r<n.length+20;r++)t.b^=0|n.charCodeAt(r),t.next()}function o(e,t){return t.a=e.a,t.b=e.b,t.c=e.c,t.d=e.d,t}function s(e,t){var n=new r(e),s=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,s&&("object"==typeof s&&o(s,n),a.state=function(){return o(n,{})}),a}t&&t.exports?t.exports=s:n&&n.amd?n((function(){return s})):this.tychei=s}(0,e,!1)})),fs=is((function(e){!function(t,n){var r,o=this,s=n.pow(256,6),a=n.pow(2,52),i=2*a;function u(e,u,d){var f=[],m=h(function e(t,n){var r,o=[],s=typeof t;if(n&&"object"==s)for(r in t)try{o.push(e(t[r],n-1))}catch(e){}return o.length?o:"string"==s?t:t+"\0"}((u=1==u?{entropy:!0}:u||{}).entropy?[e,p(t)]:null==e?function(){try{var e;return r&&(e=r.randomBytes)?e=e(256):(e=new Uint8Array(256),(o.crypto||o.msCrypto).getRandomValues(e)),p(e)}catch(e){var n=o.navigator,s=n&&n.plugins;return[+new Date,o,s,o.screen,p(t)]}}():e,3),f),g=new l(f),b=function(){for(var e=g.g(6),t=s,n=0;e<a;)e=256*(e+n),t*=256,n=g.g(1);for(;e>=i;)e/=2,t/=2,n>>>=1;return(e+n)/t};return b.int32=function(){return 0|g.g(4)},b.quick=function(){return g.g(4)/4294967296},b.double=b,h(p(g.S),t),(u.pass||d||function(e,t,r,o){return o&&(o.S&&c(o,g),e.state=function(){return c(g,{})}),r?(n.random=e,t):e})(b,m,"global"in u?u.global:this==n,u.state)}function l(e){var t,n=e.length,r=this,o=0,s=r.i=r.j=0,a=r.S=[];for(n||(e=[n++]);o<256;)a[o]=o++;for(o=0;o<256;o++)a[o]=a[s=255&s+e[o%n]+(t=a[o])],a[s]=t;(r.g=function(e){for(var t,n=0,o=r.i,s=r.j,a=r.S;e--;)t=a[o=255&o+1],n=256*n+a[255&(a[o]=a[s=255&s+t])+(a[s]=t)];return r.i=o,r.j=s,n})(256)}function c(e,t){return t.i=e.i,t.j=e.j,t.S=e.S.slice(),t}function h(e,t){for(var n,r=e+"",o=0;o<r.length;)t[255&o]=255&(n^=19*t[255&o])+r.charCodeAt(o++);return p(t)}function p(e){return String.fromCharCode.apply(0,e)}if(n.seedrandom=u,h(n.random(),t),e.exports){e.exports=u;try{r=require("crypto")}catch(e){}}}([],Math)}));fs.alea=us,fs.xor128=ls,fs.xorwow=cs,fs.xorshift7=hs,fs.xor4096=ps,fs.tychei=ds;var ms=fs.alea;class gs{constructor(e,t,n,r,o){this.mean=e,this.stdDev=t,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);const s=o||Math.random();this.random=ms(s.toString())}nextValue(){if(!isNaN(this.nextVal)){const e=this.nextVal;return this.nextVal=NaN,e}let e,t,n=!1;for(;!n;){let r,o,s;do{r=2*this.random()-1,o=2*this.random()-1,s=r*r+o*o}while(s>=1||0===s);const a=Math.sqrt(-2*Math.log(s)/s);e=this.mean+this.stdDev*r*a,t=this.mean+this.stdDev*o*a,this.truncated&&!this.isValidTruncated(e)||(n=!0)}return this.truncated&&!this.isValidTruncated(t)||(this.nextVal=this.convertValue(t)),this.convertValue(e)}convertValue(e){return null==this.dtype||"float32"===this.dtype?e:Math.round(e)}isValidTruncated(e){return e<=this.upper&&e>=this.lower}}class bs{constructor(e,t,n,r){this.alpha=e,this.beta=1/t,this.dtype=n;const o=r||Math.random();this.randu=ms(o.toString()),this.randn=new gs(0,1,n,!1,this.randu()),this.d=e<1?e+2/3:e-1/3,this.c=1/Math.sqrt(9*this.d)}nextValue(){let e,t,n,r,o,s;for(;;){do{r=this.randn.nextValue(),s=1+this.c*r}while(s<=0);if(s*=s*s,e=r*r,t=1-.331*e*e,n=.5*e+this.d*(1-s+Math.log(s)),o=this.randu(),o<t||Math.log(o)<n)break}return s=1/this.beta*this.d*s,this.alpha<1&&(s*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(s)}convertValue(e){return"float32"===this.dtype?e:Math.round(e)}}class ys{constructor(e=0,t=1,n,r){if(this.canReturnFloat=()=>null==this.dtype||"float32"===this.dtype,this.min=e,this.range=t-e,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(`The difference between ${e} - ${t} <= 1 and dtype is not float`);this.random=ms(r)}convertValue(e){return this.canReturnFloat()?e:Math.round(e)}nextValue(){return this.convertValue(this.min+this.range*this.random())}}const ws=Me({randomGamma_:function(e,t,n=1,r="float32",o){if(null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error("Unsupported data type "+r);const s=new bs(t,n,r,o),a=ft(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=s.nextValue();return a.toTensor()}});const ks=Me({randomNormal_:function(e,t=0,n=1,r,o){if(null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);const s=new gs(t,n,r,!1,o),a=ft(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=s.nextValue();return a.toTensor()}});const vs=Me({randomUniform_:function(e,t=0,n=1,r="float32",o){const s=ft(e,r),a=new ys(t,n,null,o);for(let e=0;e<s.values.length;e++)s.values[e]=a.nextValue();return s.toTensor()}});function xs(e,t){b(e);const n=Ie(e,t);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return _e(e,null,n,t)}function Ss(e,t,n=1,r="float32"){if(0===n)throw new Error("Cannot have a step of zero");const o={start:e,stop:t,step:n,dtype:r};return xe.runKernelFunc(()=>{if(e===t||e<t&&n<0||t<e&&n>1)return Ro([0],r);const o=G(Math.abs(Math.ceil((t-e)/n)),r);t<e&&1===n&&(n=-1),o[0]=e;for(let e=1;e<o.length;e++)o[e]=o[e-1]+n;return xs(o,r)},{},null,"Range",o)}const Es=Me({reciprocal_:function(e){const t=Ae(e,"x","reciprocal"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.reciprocal(t);return n([t]),r},n,null,"Reciprocal")}});const Ds=Me({relu_:function(e){const t=Ae(e,"x","relu"),n={x:t};return xe.runKernelFunc((e,n)=>(n([t]),"bool"===t.dtype?mt(t,"int32"):e.relu(t)),n,null,"Relu")}});const Ns=Me({relu6_:function(e){const t=Ae(e,"x","relu6"),n={x:t};return xe.runKernelFunc((e,n)=>(n([t]),"bool"===t.dtype?mt(t,"int32"):e.relu6(t)),n,null,"Relu6")}});const Is=Me({reverse_:function(e,t){const n=Ae(e,"x","reverse"),r={x:n},o={dims:t};return xe.runKernelFunc(e=>{const r=E(t,n.shape);if(0===n.rank)return gt(n);const o=e.reverse(n,r);return Mt(o,n.shape)},r,null,"Reverse",o)}});const Fs=Me({reverse1d_:function(e){const t=Ae(e,"x","reverse");return m(1===t.rank,()=>`Error in reverse1D: x must be rank 1 but got rank ${t.rank}.`),Is(t,0)}});const As=Me({reverse2d_:function(e,t){const n=Ae(e,"x","reverse");return m(2===n.rank,()=>`Error in reverse2D: x must be rank 2 but got rank ${n.rank}.`),Is(n,t)}});const Ts=Me({reverse3d_:function(e,t){const n=Ae(e,"x","reverse");return m(3===n.rank,()=>`Error in reverse3D: x must be rank 3 but got rank ${n.rank}.`),Is(n,t)}});const Ms=Me({reverse4d_:function(e,t){const n=Ae(e,"x","reverse");return m(4===n.rank,()=>`Error in reverse4D: x must be rank 4 but got rank ${n.rank}.`),Is(n,t)}});const $s=Me({round_:function(e){const t=Ae(e,"x","round"),n={x:t};return xe.runKernelFunc(e=>e.round(t),n,null,"Round")}});const _s=Me({rsqrt_:function(e){const t=Ae(e,"x","rsqrt"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.rsqrt(t);return n([t]),r},n,null,"Rsqrt")}});const Bs=Me({selu_:function(e){const t=Ae(e,"x","selu"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.selu(t);return n([t]),r},n,null,"Selu")}});const Cs=Me({separableConv2d_:function(e,t,n,r,o,s=[1,1],a="NHWC"){const i=Ae(e,"x","separableConv2d"),u=Ae(t,"depthwiseFilter","separableConv2d"),l=Ae(n,"pointwiseFilter","separableConv2d");let c=i,h=!1;if(3===i.rank&&(h=!0,c=Mt(i,[1,i.shape[0],i.shape[1],i.shape[2]])),"NCHW"===a)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");m(4===c.rank,()=>`Error in separableConv2d: input must be rank 4, but got rank ${c.rank}.`),m(4===u.rank,()=>`Error in separableConv2d: depthwise filter must be rank 4, but got rank ${u.rank}.`),m(4===l.rank,()=>`Error in separableConv2d: pointwise filter must be rank 4, but got rank ${u.rank}.`),m(1===l.shape[0],()=>`Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got ${l.shape[0]}.`),m(1===l.shape[1],()=>`Error in separableConv2d: the second dimension of pointwise filter must be 1, but got ${l.shape[1]}.`);const p=u.shape[2],d=u.shape[3];m(l.shape[2]===p*d,()=>`Error in separableConv2d: the third dimension of pointwise filter must be ${p*d}, but got ${l.shape[2]}.`);const f=Cr(c,u,r,o,a,s),g=Er(f,l,1,"valid",a);return h?Mt(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const Rs=async function(e,t){const n=Ae(e,"x","setdiff1d"),r=Ae(t,"y","setdiff1d");m(n.dtype===r.dtype,()=>`x and y should have the same dtype, but got x (${n.dtype}) and y (${r.dtype}).`),m(1===n.rank,()=>`x should be 1D tensor, but got x (${n.shape}).`),m(1===r.rank,()=>`y should be 1D tensor, but got y (${r.shape}).`);const o=await n.data(),s=await r.data(),a=new Set(s);let i=0;for(let e=0;e<o.length;e++)a.has(o[e])||i++;const u=new re([i],n.dtype),l=new re([i],"int32");for(let e=0,t=0;e<o.length;e++)a.has(o[e])||(u.values[t]=o[e],l.values[t]=e,t++);return[u.toTensor(),l.toTensor()]};const Ps=Me({sign_:function(e){const t=Ae(e,"x","sign"),n={x:t};return xe.runKernelFunc(e=>e.sign(t),n,null,"Sign")}});const zs=Me({sin_:function(e){const t=Ae(e,"x","sin"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.sin(t);return n([t]),r},n,null,"Sin")}});const Ls=Me({sinh_:function(e){const t=Ae(e,"x","sinh"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.sinh(t);return n([t]),r},n,null,"Sinh")}});const qs=Me({slice1d_:function(e,t,n){const r=Ae(e,"x","slice1d");return m(1===r.rank,()=>`slice1d expects a rank-1 tensor, but got a rank-${r.rank} tensor`),ur(r,[t],[n])}});const Os=Me({slice2d_:function(e,t,n){const r=Ae(e,"x","slice2d");return m(2===r.rank,()=>`slice2d expects a rank-2 tensor, but got a rank-${r.rank} tensor`),ur(r,t,n)}});const Ws=Me({slice3d_:function(e,t,n){const r=Ae(e,"x","slice3d");return m(3===r.rank,()=>`slice3d expects a rank-3 tensor, but got a rank-${r.rank} tensor`),ur(r,t,n)}});const Ks=Me({slice4d_:function(e,t,n){const r=Ae(e,"x","slice4d");return m(4===r.rank,()=>`slice4d expects a rank-4 tensor, but got a rank-${r.rank} tensor`),ur(r,t,n)}});const Gs=Me({softmax_:function(e,t=-1){const n=Ae(e,"logits","softmax","float32");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and dim was ${t}`);const r={logits:n},o={dim:t};return xe.runKernelFunc((e,r)=>{const o=e.softmax(n,t);return r([o]),o},r,null,"Softmax",o)}});const Us=Me({fft_:function(e){m("complex64"===e.dtype,()=>`The dtype for tf.spectral.fft() must be complex64 but got ${e.dtype}.`);const t={input:e};return xe.runKernelFunc(t=>{const n=e.shape[e.shape.length-1],r=e.size/n,o=e.as2D(r,n);return t.fft(o).reshape(e.shape)},t,null,"FFT")}});const Vs=Me({ifft_:function(e){m("complex64"===e.dtype,()=>`The dtype for tf.spectral.ifft() must be complex64 but got ${e.dtype}.`);const t={input:e};return xe.runKernelFunc(t=>{const n=e.shape[e.shape.length-1],r=e.size/n,o=Mt(e,[r,n]),s=t.ifft(o);return Mt(s,e.shape)},t,null,"IFFT")}});const Hs=Me({irfft_:function(e){const t=e.shape[e.shape.length-1],n=e.size/t;let r;if(t<=2){const o=Mt(e,[n,t]);r=Vs(o)}else{const o=[n,2*(t-1)],s=Mt(Ho(e),[n,t]),a=Mt(so(e),[n,t]),i=Is(ur(s,[0,1],[n,t-2]),1),u=Sn(Is(ur(a,[0,1],[n,t-2]),1),co(-1)),l=ar([s,i],1),c=ar([a,u],1),h=Mt($e(l,c),[o[0],o[1]]);r=Vs(h)}if(r=Ho(r),3===e.rank&&0!==e.shape[0]){const t=r,n=e.shape[0];r=Mt(r,[n,r.shape[0]/n,r.shape[1]]),t.dispose()}return r}});function js(e,t,n=0){let r=[];if("number"==typeof t)m(e.shape[n]%t==0,()=>"Number of splits must evenly divide the axis."),r=new Array(t).fill(e.shape[n]/t);else{m(t.reduce((e,t)=>(-1===t&&(e+=1),e),0)<=1,()=>"There should be only one negative value in split array.");const o=t.indexOf(-1);if(-1!==o){const r=t.reduce((e,t)=>t>0?e+t:e);t[o]=e.shape[n]-r}m(e.shape[n]===t.reduce((e,t)=>e+t),()=>"The sum of sizes must match the size of the axis dimension."),r=t}return r}const Js=Me({split_:function(e,t,n=0){const r=Ae(e,"x","split"),o={x:r},s={numOrSizeSplits:t,axis:n};return xe.runKernelFunc((e,o)=>{const s=E(n,r.shape)[0],a=js(r,t,s);return e.split(r,a,s)},o,null,"SplitV",s)}});const Ys=Me({rfft_:function(e,t){m("float32"===e.dtype,()=>"The dtype for rfft() must be real value but got "+e.dtype);let n=e.shape[e.shape.length-1];const r=e.size/n;let o;if(null!=t&&t<n){const r=e.shape.map(e=>0),s=e.shape.map(e=>e);s[e.shape.length-1]=t,o=ur(e,r,s),n=t}else if(null!=t&&t>n){const r=e.shape.map(e=>e);r[e.shape.length-1]=t-n,o=ar([e,Ro(r)],e.shape.length-1),n=t}else o=e;const s=Wr(o),a=Mt($e(o,s),[r,n]),i=Us(a),u=Math.floor(n/2)+1,l=Ho(i),c=so(i),h=Js(l,[u,n-u],l.shape.length-1),p=Js(c,[u,n-u],c.shape.length-1),d=o.shape.slice();return d[o.shape.length-1]=u,Mt($e(h[0],p[0]),d)}});const Zs=Me({sqrt_:function(e){const t=Ae(e,"x","sqrt"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.sqrt(t);return n([t]),r},n,null,"Sqrt")}});const Xs=Me({squaredDifference_:function(e,t){let n=Ae(e,"a","squaredDifference"),r=Ae(t,"b","squaredDifference");[n,r]=me(n,r),Lr(n.shape,r.shape);const o={a:n,b:r};return xe.runKernelFunc((e,t)=>{const o=e.squaredDifference(n,r);return t([n,r]),o},o,null,"SquaredDifference",{})}});const Qs=Me({squeeze_:function(e,t){const n=Ae(e,"x","squeeze");return Mt(n,D(n.shape,t).newShape)}});const ea=Me({stack_:function(e,t=0){const n=Te(e,"tensors","stack");if(m(n.length>=1,()=>"Pass at least one tensor to tf.stack"),1===n.length)return jr(n[0],t);const r=n[0].rank,o=n[0].shape,s=n[0].dtype;m(t<=r,()=>"Axis must be <= rank of the tensor"),n.forEach(e=>{g(o,e.shape,"All tensors passed to stack must have matching shapes"),m(s===e.dtype,()=>"All tensors passed to stack must have matching dtypes")});const a=n.map(e=>jr(e,t));return ar(a,t)}});const ta=Me({step_:function(e,t=0){const n=Ae(e,"x","step"),r={x:n},o={alpha:t};return xe.runKernelFunc(e=>e.step(n,t),r,null,"Step",o)}});const na=Me({stridedSlice_:function(e,t,n,r,o=0,s=0,a=0,i=0,u=0){let l=Ae(e,"x","stridedSlice");const c={x:l},h={begin:t,end:n,strides:r,beginMask:o,endMask:s,ellipsisMask:a,newAxisMask:i,shrinkAxisMask:u};return xe.runKernelFunc(e=>{null==r&&(r=new Array(t.length));const c=jt(a);if(c.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==a&&0!==i)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==a&&0!==u)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");const h=l.rank-t.length,p=jt(i),d=l.shape.slice();p.forEach(e=>{t[e]=0,n[e]=1,d.splice(e,0,1)}),l=Mt(l,d);const{begin:f,end:m,strides:g}=Qt(l.shape,c,h,t,n,r,o,s,a);t=f,n=m,r=g;const b=jt(u);b.forEach(e=>{n[e]=t[e]+1,r[e]=1});const y=Jt(t,n,r),w=y.filter((e,t)=>-1===b.indexOf(t));if(r.every(e=>1===e))return Mt(ur(l,t,y),w);const k=e.stridedSlice(l,t,n,r);return Mt(k,w)},c,null,"StridedSlice",h)}});const ra=Me({tan_:function(e){const t=Ae(e,"x","tan"),n={x:t};return xe.runKernelFunc((e,n)=>{const r=e.tan(t);return n([t]),r},n,null,"Tan")}});function oa(e,t,n){if(b(e),null!=t&&2!==t.length)throw new Error("tensor2d() requires shape to have two numbers");const r=Ie(e,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return _e(e,t,r,n)}const sa=Me({topk_:function(e,t=1,n=!0){const r=Ae(e,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");const o=r.shape[r.shape.length-1];if(t>o)throw new Error(`'k' passed to topk() must be <= the last dimension (${o}) but got `+t);const s={x:r},a={k:t,sorted:n},[i,u]=xe.runKernelFunc(e=>e.topk(r,t,n),s,null,"TopK",a);return{values:i,indices:u}}});const aa=Me({truncatedNormal_:function(e,t=0,n=1,r,o){if(null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");const s=new gs(t,n,r,!0,o),a=ft(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=s.nextValue();return a.toTensor()}});const ia=Me({unsortedSegmentSum_:function(e,t,n){const r=Ae(e,"x","unsortedSegmentSum"),o=Ae(t,"segmentIds","unsortedSegmentSum","int32");m(v(n),()=>"numSegments must be of dtype int");const s={x:r,segmentIds:o},a={numSegments:n};return xe.runKernelFunc((e,t)=>{const s=e.unsortedSegmentSum(r,o,n);return t([o]),s},s,null,"UnsortedSegmentSum",a)}});const ua=Me({unstack_:function(e,t=0){const n=Ae(e,"x","unstack");m(t>=-n.shape.length&&t<n.shape.length,()=>`Axis = ${t} is not in [-${n.shape.length}, ${n.shape.length})`),t<0&&(t+=n.shape.length);const r={value:n},o={axis:t};return xe.runKernelFunc(e=>e.unstack(n,t),r,null,"Unpack",o)}});function la(e,t){const n=[];for(let e=0;e<t.length;e++)t[e]&&n.push(e);const r=ft(e,"int32"),o=ft([n.length,e.length],"int32");for(let t=0;t<n.length;t++){const s=r.indexToLoc(n[t]),a=t*e.length;o.values.set(s,a)}return o.toTensor()}const ca=async function(e){const t=Ae(e,"condition","whereAsync","bool"),n=await t.data(),r=la(t.shape,n);return e!==t&&t.dispose(),r};const ha=async function(e,t,n){const r=Ae(e,"tensor","boolMask"),o=Ae(t,"mask","boolMask","bool"),s=null==n?0:n,a=o.rank,i=r.shape;m(a>0,()=>"mask cannot be scalar"),g(i.slice(s,s+a),o.shape,"mask's shape must match the first K dimensions of tensor's shape,");let u=1;for(let e=s;e<s+a;e++)u*=i[e];const l=i.slice(0,s).concat([u],i.slice(s+a)),c=Mt(r,l),h=Mt(o,[-1]),p=await ca(h),d=Qs(p,[1]),f=no(c,d,s);return e!==r&&r.dispose(),t!==o&&o.dispose(),d.dispose(),c.dispose(),h.dispose(),p.dispose(),f};const pa=Me({equalStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","equalStrict"),r=Ae(t,"b","equalStrict");return g(n.shape,r.shape,"Error in equalStrict: "),qr(n,r)}}),da=Me({greaterEqualStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","greaterEqualStrict"),r=Ae(t,"b","greaterEqualStrict");return g(n.shape,r.shape,"Error in greaterEqualStrict: "),oo(n,r)}}),fa=Me({greaterStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","greaterStrict"),r=Ae(t,"b","greaterStrict");return g(n.shape,r.shape,"Error in greaterStrict: "),ro(n,r)}}),ma=Me({lessEqualStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","lessEqualStrict"),r=Ae(t,"b","lessEqualStrict");return g(n.shape,r.shape,"Error in lessEqualStrict: "),fo(n,r)}}),ga=Me({lessStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","lessStrict"),r=Ae(t,"b","lessStrict");return g(n.shape,r.shape,"Error in lessStrict: "),po(n,r)}}),ba=Me({notEqualStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","notEqualStrict"),r=Ae(t,"b","notEqualStrict");return g(n.shape,r.shape,"Error in notEqualStrict: "),Vo(n,r)}});const ya=Me({addStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","addStrict"),r=Ae(t,"b","addStrict");return g(n.shape,r.shape,"Error in addStrict: "),kn(n,r)}}),wa=Me({divStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","div"),r=Ae(t,"b","div");return g(n.shape,r.shape,"Error in divideStrict: "),xn(n,r)}}),ka=Me({maximumStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","maximumStrict"),r=Ae(t,"b","maximumStrict");return g(n.shape,r.shape,"Error in maximumStrict: "),lo(n,r)}}),va=Me({minimumStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","minimumStrict"),r=Ae(t,"b","minimumStrict");return g(n.shape,r.shape,"Error in minimumStrict: "),qo(n,r)}}),xa=Me({modStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","modStrict"),r=Ae(t,"b","modStrict");return g(n.shape,r.shape,"Error in modStrict: "),Oo(n,r)}}),Sa=Me({mulStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","mul"),r=Ae(t,"b","mul");return g(n.shape,r.shape,"Error in multiplyStrict: "),Sn(n,r)}}),Ea=Me({powStrict_:function(e,t){return gn("strict variants of ops have been deprecated and will be removed in future"),g(e.shape,t.shape,"Error in powStrict: "),rs(e,t)}}),Da=Me({squaredDifferenceStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","squaredDifferenceStrict"),r=Ae(t,"b","squaredDifferenceStrict");return g(n.shape,r.shape,"Error in squaredDifferenceStrict: "),Xs(n,r)}}),Na=Me({subStrict_:function(e,t){gn("strict variants of ops have been deprecated and will be removed in future");const n=Ae(e,"a","subStrict"),r=Ae(t,"b","subStrict");return g(n.shape,r.shape,"Error in subStrict: "),Do(n,r)}});const Ia=Me({norm_:function(e,t="euclidean",n=null,r=!1){const o=function e(t,n,r=null){if(0===t.rank)return En(t);if(1!==t.rank&&null===r)return e(Mt(t,[-1]),n,r);if(1===t.rank||"number"==typeof r||Array.isArray(r)&&1===r.length){if(1===n)return No(En(t),r);if(n===1/0)return Eo(En(t),r);if(n===-1/0)return Lo(En(t),r);if("euclidean"===n||2===n)return Zs(No(rs(En(t),co(2,"int32")),r));throw new Error("Error in norm: invalid ord value: "+n)}if(Array.isArray(r)&&2===r.length){if(1===n)return Eo(No(En(t),r[0]),r[1]-1);if(n===1/0)return Eo(No(En(t),r[1]),r[0]);if(n===-1/0)return Lo(No(En(t),r[1]),r[0]);if("fro"===n||"euclidean"===n)return Zs(No(Wo(t),r));throw new Error("Error in norm: invalid ord value: "+n)}throw new Error("Error in norm: invalid axis: "+r)}(e=Ae(e,"x","norm"),t,n);let s=o.shape;if(r){const t=E(n,e.shape);s=Mn(o.shape,t)}return Mt(o,s)}});const Fa=Me({movingAverage_:function(e,t,n,r,o=!0){const s=Ae(e,"v","movingAverage"),a=Ae(t,"x","movingAverage"),i=Ae(n,"decay","movingAverage");ge(s,a),m(k(s.shape,a.shape),()=>"Shape mismatch in v and x");const u=co(1),l=Do(u,i);let c=Sn(Do(a,s),l);if(o){m(null!=r,()=>"When using zeroDebias: true, step is required.");const e=Ae(r,"step","movingAverage");c=xn(c,Do(u,rs(i,e)))}return kn(s,c)}});const Aa=Me({scatterND_:function(e,t,n){const r=Ae(e,"indices","scatterND","int32"),o=Ae(t,"updates","scatterND");Gt(o,r,n);const s={indices:r,updates:o},a={shape:n};return xe.runKernelFunc(e=>e.scatterND(r,o,n),s,null,"ScatterNd",a)}});const Ta=Me({sparseToDense_:function(e,t,n,r=0){const o=Ae(e,"sparseIndices","sparseToDense","int32"),s=Ae(t,"sparseValues","sparseToDense"),a=Ae(r,"defaultValue","sparseToDense",s.dtype);!function(e,t,n,r){if("int32"!==e.dtype)throw new Error(`tf.sparseToDense() expects the indices to be int32 type, but the dtype was ${e.dtype}.`);if(e.rank>2)throw new Error(`sparseIndices should be a scalar, vector, or matrix, but got shape ${e.shape}.`);const o=e.rank>0?e.shape[0]:1,s=e.rank>1?e.shape[1]:1;if(n.length!==s)throw new Error(`outputShape has incorrect number of elements:, ${n.length}, should be: ${s}.`);const a=t.size;if(0!==t.rank&&(1!==t.rank||a!==o))throw new Error(`sparseValues has incorrect shape ${t.shape}, should be [] or [${o}]`);if(t.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(o,s,n,a);const i={sparseIndices:o,sparseValues:s,defaultValue:a},u={outputShape:n};return xe.runKernelFunc(e=>e.sparseToDense(o,s,n,a),i,null,"SparseToDense",u)}});const Ma=Me({gatherND_:function(e,t){const n=Ae(t,"indices","gatherND","int32"),r=Ae(e,"x","gatherND"),o={params:r,indices:n};return xe.runKernelFunc(e=>e.gatherND(r,n),o,null,"GatherNd")}});const $a=Me({dropout_:function(e,t,n,r){const o=Ae(e,"x","dropout");if(m("float32"===o.dtype,()=>`x has to be a floating point tensor since it's going to be scaled, but got a ${o.dtype} tensor instead.`),m(t>=0&&t<1,()=>`rate must be a float in the range [0, 1), but got ${t}.`),0===t)return e instanceof ae?o.clone():o;const s=function(e,t){if(null==t)return e.shape.slice();if(k(e.shape,t))return t;if(e.shape.length===t.length){const n=[];for(let r=0;r<e.shape.length;r++)null==t[r]&&null!=e.shape[r]?n.push(e.shape[r]):n.push(t[r]);return n}return t}(o,n),a=1-t,i=xn(Qr(kn(vs(s,0,1,"float32",r),a)),a);return Sn(o,i)}});function _a(e){return Math.floor(Math.pow(2,Math.ceil(Math.log(e)/Math.log(2))))}function Ba(e,t,n){const r=1-e%2,o=new Float32Array(e);for(let s=0;s<e;++s){const a=2*Math.PI*s/(e+r-1);o[s]=t-n*Math.cos(a)}return xs(o,"float32")}const Ca=async function(e,t,n=1){const r=Ae(e,"predictions","inTopK"),o=Ae(t,"targets","inTopK");m(r.rank>1,()=>"inTopK() expects the predictions to be of rank 2 or higher, but got "+r.rank),m(r.rank-1===o.rank,()=>`predictions rank should be 1 larger than targets rank, but got predictions rank ${r.rank} and targets rank ${o.rank}`),g(r.shape.slice(0,r.shape.length-1),o.shape,"predictions's shape should be align with the targets' shape, except the last dimension.");const s=r.shape[r.shape.length-1];m(n>0&&n<=s,()=>`'k' passed to inTopK() must be > 0 && <= the predictions last dimension (${s}), but got ${n}`);const a=await r.data(),i=await o.data(),[u,l]=[a.length/s,s],c=N("bool",u);for(let e=0;e<u;e++){const t=e*l,r=a.subarray(t,t+l),o=[];for(let e=0;e<r.length;e++)o.push({value:r[e],index:e});o.sort((e,t)=>t.value-e.value),c[e]=0;for(let t=0;t<n;t++)if(o[t].index===i[e]){c[e]=1;break}}return e!==r&&r.dispose(),t!==o&&o.dispose(),Be(c,o.shape,"bool")};const Ra=Me({conv2DBackpropFilter_:function(e,t,n,r,o,s="NHWC",a){let i=e;3===e.rank&&(i=Mt(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let u=t;3===u.rank&&(u=Mt(t,[1,t.shape[0],t.shape[1],t.shape[2]])),m(4===i.rank,()=>"Error in conv2dDerFilter: input must be rank 4, but got shape "+i.shape+"."),m(4===u.rank,()=>"Error in conv2dDerFilter: dy must be rank 4, but got shape "+u.shape+"."),m(4===n.length,()=>"Error in conv2dDerFilter: filterShape must be length 4, but got "+n+".");const l="NHWC"===s?i.shape[3]:i.shape[1],c="NHWC"===s?u.shape[3]:u.shape[1];m(l===n[2],()=>`Error in conv2dDerFilter: depth of input ${l}) must match input depth in filter (${n[2]}.`),m(c===n[3],()=>`Error in conv2dDerFilter: depth of dy (${c}) must match output depth for filter (${n[3]}).`),null!=a&&m(v(o),()=>`Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode ${a} but got pad ${o}.`);const h={x:i,dy:u},p={strides:r,pad:o,dataFormat:s,dimRoundingMode:a};return xe.runKernelFunc(e=>{const t=tr(s),l=Vn(i.shape,n,r,1,o,a,!1,t);return e.conv2dDerFilter(i,u,l)},h,null,"Conv2DBackpropFilter",p)}});function Pa(e,t,n){if(null==n||"linear"===n)return e;if("relu"===n)return Sn(e,ta(t));throw new Error(`Cannot compute gradient for fused activation ${n}.`)}function za(e,t){let n=t;const r=zr(e.shape,t.shape);return r.length>0&&(n=No(n,r)),Mt(n,e.shape)}function La(e,t,n){if("linear"===t)return e;if("relu"===t)return Ds(e);if("elu"===t)return Ur(e);if("relu6"===t)return Ns(e);if("prelu"===t)return os(e,n);throw new Error(`Unknown fused activation ${t}.`)}const qa=(e,t)=>!(e>0)||"linear"===t;const Oa=Me({fusedConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:o="NHWC",dilations:s=[1,1],dimRoundingMode:a,bias:i,activation:u="linear",preluActivationWeights:l}){if(u=u||"linear",!1===qa(xe.state.gradientDepth,u)){let c=Er(e,t,n,r,o,s,a);return null!=i&&(c=kn(c,i)),La(c,u,l)}const c=Ae(e,"x","conv2d"),h=Ae(t,"filter","conv2d");let p=c,d=!1;3===c.rank&&(d=!0,p=Mt(c,[1,c.shape[0],c.shape[1],c.shape[2]])),m(4===p.rank,()=>"Error in fused conv2d: input must be rank 4, but got rank "+p.rank+"."),m(4===h.rank,()=>"Error in fused conv2d: filter must be rank 4, but got rank "+h.rank+"."),null!=a&&m(v(r),()=>`Error in fused conv2d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${r}.`),m(p.shape[3]===h.shape[2],()=>`Error in conv2d: depth of input (${p.shape[3]}) must match input depth for filter ${h.shape[2]}.`),m(er(n,s),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${s}'`),m("NHWC"===o,()=>`Error in conv2d: got dataFormat of ${o} but only NHWC is currently supported.`);const f=Vn(p.shape,h.shape,n,s,r,a);let g,b;null!=i&&(g=Ae(i,"bias","fused conv2d"),[g]=me(g,c),Lr(f.outShape,g.shape)),null!=l&&(b=Ae(l,"prelu weights","fused conv2d"));const y=(e,t)=>{const[o,a,i,l]=t,c=Pa(e,i,u);m(Qn(s),()=>`Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${s}'`);const h=[Nr(a.shape,c,o,n,r),Ra(a,c,o.shape,n,r)];if(null!=l){const e=za(l,c);h.push(e)}return h},w=e=>e.fusedConv2d({input:p,filter:h,convInfo:f,bias:g,activation:u,preluActivationWeights:b}),k={x:p,filter:h,bias:g,preluActivationWeights:b},x={strides:n,pad:r,dataFormat:o,dilations:s,dimRoundingMode:a,activation:u};if(null==i){return wo((e,t,n)=>{let r=xe.runKernelFunc(w,k,null,"FusedConv2D",x);return n([t,e,r]),d&&(r=Mt(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:y}})(p,h)}return wo((e,t,n,r)=>{let o=xe.runKernelFunc(w,k,null,"FusedConv2D",x);return r([t,e,o,n]),d&&(o=Mt(o,[o.shape[1],o.shape[2],o.shape[3]])),{value:o,gradFunc:y}})(p,h,g)}});const Wa=Me({depthwiseConv2dNativeBackpropFilter_:function(e,t,n,r){let o=e;3===e.rank&&(o=Mt(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let s=t;3===s.rank&&(s=Mt(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const a={x:o,dy:s};return xe.runKernelFunc(e=>e.depthwiseConv2DDerFilter(o,s,r),a,null,"DepthwiseConv2dNativeBackpropFilter")}});const Ka=Me({depthwiseConv2dNativeBackpropInput_:function(e,t,n,r){let o=t,s=!1;3===t.rank&&(s=!0,o=Mt(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const a={dy:o},i=xe.runKernelFunc(e=>e.depthwiseConv2DDerInput(o,n,r),a,null,"DepthwiseConv2dNativeBackpropInput");return s?Mt(i,[i.shape[1],i.shape[2],i.shape[3]]):i}});const Ga=Me({fusedDepthwiseConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:o="NHWC",dilations:s=[1,1],dimRoundingMode:a,bias:i,activation:u="linear",preluActivationWeights:l}){if(!1===qa(xe.state.gradientDepth,u)){let c=Cr(e,t,n,r,o,s,a);return null!=i&&(c=kn(c,i)),La(c,u,l)}const c=Ae(e,"x","depthwiseConv2d"),h=Ae(t,"filter","depthwiseConv2d");let p=c,d=!1;3===c.rank&&(d=!0,p=Mt(c,[1,c.shape[0],c.shape[1],c.shape[2]])),m(4===p.rank,()=>`Error in fused depthwiseConv2d: input must be rank 4, but got rank ${p.rank}.`),m(4===h.rank,()=>`Error in fused depthwiseConv2d: filter must be rank 4, but got rank ${h.rank}.`),m(p.shape[3]===h.shape[2],()=>`Error in fused depthwiseConv2d: number of input channels (${p.shape[3]}) must match the inChannels dimension in filter ${h.shape[2]}.`),null==s&&(s=[1,1]),m(er(n,s),()=>`Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides ${n} and dilations '${s}'`),null!=a&&m(v(r),()=>`Error in fused depthwiseConv2d: pad must be an integer when using dimRoundingMode ${a} but got pad ${r}.`);const f=Vn(p.shape,h.shape,n,s,r,a,!0);let g,b;null!=i&&(g=Ae(i,"bias","fused conv2d"),[g]=me(g,c),Lr(f.outShape,g.shape)),null!=l&&(b=Ae(l,"prelu weights","fused depthwiseConv2d"));const y=(e,t)=>{m(Qn(s),()=>`Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '${s}'`);const[n,r,o,a]=t,i=Pa(e,o,u),l=Ka(r.shape,i,n,f),c=Wa(r,i,n.shape,f);if(null!=a){return[l,c,za(g,i)]}return[l,c]},w=e=>e.fusedDepthwiseConv2D({input:p,filter:h,convInfo:f,bias:g,activation:u,preluActivationWeights:b}),k={x:p,filter:h,bias:g,preluActivationWeights:b},x={strides:n,pad:r,dataFormat:o,dilations:s,dimRoundingMode:a,activation:u};if(null==i){return wo((e,t,n)=>{let r=xe.runKernelFunc(w,k,null,"FusedDepthwiseConv2D",x);return n([t,e,r]),d&&(r=Mt(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:y}})(p,h)}return wo((e,t,n,r)=>{let o=xe.runKernelFunc(w,k,null,"FusedDepthwiseConv2D",x);return r([t,e,o,n]),d&&(o=Mt(o,[o.shape[1],o.shape[2],o.shape[3]])),{value:o,gradFunc:y}})(p,h,g)}});const Ua=Me({fusedMatMul_:function({a:e,b:t,transposeA:n=!1,transposeB:r=!1,bias:o,activation:s="linear",preluActivationWeights:a}){if(!1===qa(xe.state.gradientDepth,s)){let i=$t(e,t,n,r);return null!=o&&(i=kn(i,o)),La(i,s,a)}let i=Ae(e,"a","fused matMul"),u=Ae(t,"b","fused matMul");[i,u]=me(i,u);const l=n?i.shape[i.rank-2]:i.shape[i.rank-1],c=r?u.shape[u.rank-1]:u.shape[u.rank-2],h=n?i.shape[i.rank-1]:i.shape[i.rank-2],p=r?u.shape[u.rank-2]:u.shape[u.rank-1],d=i.shape.slice(0,-2),f=u.shape.slice(0,-2),g=w(d),b=w(f);m(i.rank>=2&&u.rank>=2&&i.rank===u.rank,()=>`Error in fused matMul: inputs must have the same rank of at least 2, got ranks ${i.rank} and ${u.rank}.`),m(k(d,f),()=>`Error in fused matMul: outer dimensions (${d}) and (${f}) of Tensors with shapes ${i.shape} and `+u.shape+" must match."),m(l===c,()=>`Error in fused matMul: inner shapes (${l}) and (${c}) of Tensors with shapes ${i.shape} and ${u.shape} and transposeA=${n} and transposeB=${r} must match.`);const y=i.shape.slice(0,-2).concat([h,p]),v=Mt(i,n?[g,l,h]:[g,h,l]),x=Mt(u,r?[b,p,c]:[b,c,p]);let S,E;null!=o&&(S=Ae(o,"bias","fused matMul"),[S]=me(S,i),Lr(y,S.shape)),null!=a&&(E=Ae(a,"prelu weights","fused matMul"));const D=(e,t)=>{const[a,i,u,l]=t,c=Pa(Mt(e,u.shape),u,s);let h,p;if(n||r?!n&&r?(h=$t(c,i,!1,!1),p=$t(c,a,!0,!1)):n&&!r?(h=$t(i,c,!1,!0),p=$t(a,c,!1,!1)):(h=$t(i,c,!0,!0),p=$t(c,a,!0,!0)):(h=$t(c,i,!1,!0),p=$t(a,c,!0,!1)),null!=o){return[h,p,za(l,c)]}return[h,p]},N=e=>e.fusedBatchMatMul({a:v,b:x,transposeA:n,transposeB:r,bias:S,activation:s,preluActivationWeights:E}),I={a:v,b:x,bias:S,preluActivationWeights:E},F={transposeA:n,transposeB:r,activation:s};if(null==o){return wo((e,t,n)=>{const r=xe.runKernelFunc(N,I,null,"_FusedMatMul",F);return n([e,t,r]),{value:Mt(r,y),gradFunc:D}})(v,x)}return wo((e,t,n,r)=>{const o=xe.runKernelFunc(N,I,null,"_FusedMatMul",F);return r([e,t,o,n]),{value:Mt(o,y),gradFunc:D}})(v,x,S)}});var Va=Object.freeze({__proto__:null,conv2d:Oa,depthwiseConv2d:Ga,matMul:Ua});const Ha=Me({hammingWindow_:function(e){return Ba(e,.54,.46)}});const ja=Me({hannWindow_:function(e){return Ba(e,.5,.5)}});const Ja=Me({frame_:function(e,t,n,r=!1,o=0){let s=0;const a=[];for(;s+t<=e.size;)a.push(ur(e,s,t)),s+=n;if(r)for(;s<e.size;){const r=s+t-e.size,i=ar([ur(e,s,t-r),Xr([r],o)]);a.push(i),s+=n}return 0===a.length?oa([],[0,t]):Mt(ar(a),[a.length,t])}});const Ya=Me({stft_:function(e,t,n,r,o=ja){null==r&&(r=_a(t));const s=Ja(e,t,n),a=Sn(s,o(t)),i=[];for(let e=0;e<s.shape[0];e++)i.push(Ys(ur(a,[e,0],[1,t]),r));return ar(i)}});const Za=Me({cropAndResize_:function(e,t,n,r,o,s){const a=Ae(e,"image","cropAndResize"),i=Ae(t,"boxes","cropAndResize","float32"),u=Ae(n,"boxInd","cropAndResize","int32");o=o||"bilinear",s=s||0;const l=i.shape[0];m(4===a.rank,()=>`Error in cropAndResize: image must be rank 4,but got rank ${a.rank}.`),m(2===i.rank&&4===i.shape[1],()=>`Error in cropAndResize: boxes must be have size [${l},4] but had shape ${i.shape}.`),m(1===u.rank&&u.shape[0]===l,()=>`Error in cropAndResize: boxInd must be have size [${l}] but had shape ${i.shape}.`),m(2===r.length,()=>`Error in cropAndResize: cropSize must be of length 2, but got length ${r.length}.`),m(r[0]>=1&&r[1]>=1,()=>"cropSize must be atleast [1,1], but was "+r),m("bilinear"===o||"nearest"===o,()=>"method must be bilinear or nearest, but was "+o);const c={image:a,boxes:i,boxInd:u},h={method:o,extrapolationValue:s,cropSize:r};return xe.runKernelFunc(e=>e.cropAndResize(a,i,u,r,o,s),c,null,"CropAndResize",h)}});const Xa=Me({flipLeftRight_:function(e){const t=Ae(e,"image","flipLeftRight","float32");m(4===t.rank,()=>`Error in flipLeftRight: image must be rank 4,but got rank ${t.rank}.`);const n={image:t};return xe.runKernel("FlipLeftRight",n,{})}});const Qa=Me({rotateWithOffset_:function(e,t,n=0,r=.5){const o=Ae(e,"image","rotateWithOffset","float32");m(4===o.rank,()=>`Error in rotateWithOffset: image must be rank 4,but got rank ${o.rank}.`);const s={image:o},a={radians:t,fillValue:n,center:r};return xe.runKernel("RotateWithOffset",s,a)}});function ei(e,t,n,r,o,s){null==r&&(r=.5),null==o&&(o=Number.NEGATIVE_INFINITY),null==s&&(s=0);const a=e.shape[0];return n=Math.min(n,a),m(0<=r&&r<=1,()=>`iouThreshold must be in [0, 1], but was '${r}'`),m(2===e.rank,()=>`boxes must be a 2D tensor, but was of rank '${e.rank}'`),m(4===e.shape[1],()=>"boxes must have 4 columns, but 2nd dimension was "+e.shape[1]),m(1===t.rank,()=>"scores must be a 1D tensor"),m(t.shape[0]===a,()=>`scores has incompatible shape with boxes. Expected ${a}, but was `+t.shape[0]),m(0<=s&&s<=1,()=>`softNmsSigma must be in [0, 1], but was '${s}'`),{maxOutputSize:n,iouThreshold:r,scoreThreshold:o,softNmsSigma:s}}const ti=Me({nonMaxSuppression_:function(e,t,n,r=.5,o=Number.NEGATIVE_INFINITY){const s=Ae(e,"boxes","nonMaxSuppression"),a=Ae(t,"scores","nonMaxSuppression"),i=ei(s,a,n,r,o);n=i.maxOutputSize,r=i.iouThreshold,o=i.scoreThreshold;const u={maxOutputSize:n,iouThreshold:r,scoreThreshold:o};return xe.runKernelFunc(e=>e.nonMaxSuppression(s,a,n,r,o),{boxes:s,scores:a},null,"NonMaxSuppressionV3",u)}});function ni(e,t,n){const r=function(e,t,n){return function(e,t,n){let r=0,o=e.length,s=0,a=!1;for(;r<o;){s=r+(o-r>>>1);const i=n(t,e[s]);i>0?r=s+1:(o=s,a=!i)}return a?r:-r-1}(e,t,n||ri)}(e,t,n),o=r<0?-(r+1):r;e.splice(o,0,t)}function ri(e,t){return e>t?1:e<t?-1:0}function oi(e,t,n,r,o){return ii(e,t,n,r,o,0).selectedIndices}function si(e,t,n,r,o,s){return ii(e,t,n,r,o,0,!1,s,!0)}function ai(e,t,n,r,o,s){return ii(e,t,n,r,o,s,!0)}function ii(e,t,n,r,o,s,a=!1,i=!1,u=!1){const l=[];for(let e=0;e<t.length;e++)t[e]>o&&l.push({score:t[e],boxIndex:e,suppressBeginIndex:0});l.sort(ci);const c=s>0?-.5/s:0,h=[],p=[];for(;h.length<n&&l.length>0;){const t=l.pop(),{score:n,boxIndex:s,suppressBeginIndex:a}=t;if(n<o)break;let i=!1;for(let n=h.length-1;n>=a;--n){const a=ui(e,s,h[n]);if(a>=r){i=!0;break}if(t.score=t.score*li(r,c,a),t.score<=o)break}t.suppressBeginIndex=h.length,i||(t.score===n?(h.push(s),p.push(t.score)):t.score>o&&ni(l,t,ci))}const d=h.length,f=n-d;i&&f>0&&(h.push(...new Array(f).fill(0)),p.push(...new Array(f).fill(0)));const m={selectedIndices:xs(h,"int32")};return a&&(m.selectedScores=xs(p,"float32")),u&&(m.validOutputs=co(d,"int32")),m}function ui(e,t,n){const r=e.subarray(4*t,4*t+4),o=e.subarray(4*n,4*n+4),s=Math.min(r[0],r[2]),a=Math.min(r[1],r[3]),i=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),l=Math.min(o[0],o[2]),c=Math.min(o[1],o[3]),h=Math.max(o[0],o[2]),p=Math.max(o[1],o[3]),d=(i-s)*(u-a),f=(h-l)*(p-c);if(d<=0||f<=0)return 0;const m=Math.max(s,l),g=Math.max(a,c),b=Math.min(i,h),y=Math.min(u,p),w=Math.max(b-m,0)*Math.max(y-g,0);return w/(d+f-w)}function li(e,t,n){const r=Math.exp(t*n*n);return n<=e?r:0}function ci(e,t){return e.score-t.score||e.score===t.score&&t.boxIndex-e.boxIndex}const hi=async function(e,t,n,r=.5,o=Number.NEGATIVE_INFINITY){const s=Ae(e,"boxes","nonMaxSuppressionAsync"),a=Ae(t,"scores","nonMaxSuppressionAsync"),i=ei(s,a,n,r,o);n=i.maxOutputSize,r=i.iouThreshold,o=i.scoreThreshold;const u=await Promise.all([s.data(),a.data()]),l=oi(u[0],u[1],n,r,o);return s!==e&&s.dispose(),a!==t&&a.dispose(),l};const pi=Me({nonMaxSuppressionWithScore_:function(e,t,n,r=.5,o=Number.NEGATIVE_INFINITY,s=0){const a=Ae(e,"boxes","nonMaxSuppression"),i=Ae(t,"scores","nonMaxSuppression"),u=ei(a,i,n,r,o,s),l={boxes:a,scores:i},c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:o=u.scoreThreshold,softNmsSigma:s=u.softNmsSigma},h=xe.runKernel("NonMaxSuppressionV5",l,c);return{selectedIndices:h[0],selectedScores:h[1]}}});const di=async function(e,t,n,r=.5,o=Number.NEGATIVE_INFINITY,s=0){const a=Ae(e,"boxes","nonMaxSuppressionAsync"),i=Ae(t,"scores","nonMaxSuppressionAsync"),u=ei(a,i,n,r,o,s);n=u.maxOutputSize,r=u.iouThreshold,o=u.scoreThreshold,s=u.softNmsSigma;const l=await Promise.all([a.data(),i.data()]),c=ai(l[0],l[1],n,r,o,s);return a!==e&&a.dispose(),i!==t&&i.dispose(),c};const fi=Me({nonMaxSuppressionPadded_:function(e,t,n,r=.5,o=Number.NEGATIVE_INFINITY,s=!1){const a=Ae(e,"boxes","nonMaxSuppression"),i=Ae(t,"scores","nonMaxSuppression"),u=ei(a,i,n,r,o,null),l={boxes:a,scores:i},c={maxOutputSize:u.maxOutputSize,iouThreshold:u.iouThreshold,scoreThreshold:u.scoreThreshold,padToMaxOutputSize:s},h=xe.runKernel("NonMaxSuppressionV4",l,c);return{selectedIndices:h[0],validOutputs:h[1]}}});const mi=async function(e,t,n,r=.5,o=Number.NEGATIVE_INFINITY,s=!1){const a=Ae(e,"boxes","nonMaxSuppressionAsync"),i=Ae(t,"scores","nonMaxSuppressionAsync"),u=ei(a,i,n,r,o,null),l=u.maxOutputSize,c=u.iouThreshold,h=u.scoreThreshold,[p,d]=await Promise.all([a.data(),i.data()]),f=si(p,d,l,c,h,s);return a!==e&&a.dispose(),i!==t&&i.dispose(),f};const gi=Me({resizeBilinear_:function(e,t,n=!1){const r=Ae(e,"images","resizeBilinear");m(3===r.rank||4===r.rank,()=>`Error in resizeBilinear: x must be rank 3 or 4, but got rank ${r.rank}.`),m(2===t.length,()=>"Error in resizeBilinear: new shape must 2D, but got shape "+t+".");let o=r,s=!1;3===r.rank&&(s=!0,o=Mt(r,[1,r.shape[0],r.shape[1],r.shape[2]]));const[a,i]=t,u={images:o},l={alignCorners:n,size:t},c=xe.runKernelFunc((e,t)=>(t([o]),e.resizeBilinear(o,a,i,n)),u,null,"ResizeBilinear",l);return s?Mt(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const bi=Me({resizeNearestNeighbor_:function(e,t,n=!1){const r=Ae(e,"images","resizeNearestNeighbor");m(3===r.rank||4===r.rank,()=>`Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank ${r.rank}.`),m(2===t.length,()=>"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+t+"."),m("float32"===r.dtype||"int32"===r.dtype,()=>"`images` must have `int32` or `float32` as dtype");let o=r,s=!1;3===r.rank&&(s=!0,o=Mt(r,[1,r.shape[0],r.shape[1],r.shape[2]]));const[a,i]=t,u={images:o},l={alignCorners:n,size:t},c=xe.runKernelFunc((e,t)=>(t([o]),e.resizeNearestNeighbor(o,a,i,n)),u,null,"ResizeNearestNeighbor",l);return s?Mt(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const yi=Me({bandPart_:function(e,t,n){m(t%1==0,()=>`bandPart(): numLower must be an integer, got ${t}.`),m(n%1==0,()=>`bandPart(): numUpper must be an integer, got ${n}.`);const r=Ae(e,"a","bandPart");m(r.rank>=2,()=>`bandPart(): Rank must be at least 2, got ${r.rank}.`);const o=r.shape,[s,a]=r.shape.slice(-2);if(!(t<=s))throw new Error(`bandPart(): numLower (${t}) must not be greater than the number of rows (${s}).`);if(!(n<=a))throw new Error(`bandPart(): numUpper (${n}) must not be greater than the number of columns (${a}).`);t<0&&(t=s),n<0&&(n=a);const i=Mt(Ss(0,s,1,"int32"),[-1,1]),u=Ss(0,a,1,"int32"),l=Do(i,u),c=Ao(fo(l,co(+t,"int32")),oo(l,co(-n,"int32"))),h=Ro([s,a],r.dtype);return Mt(ea(ua(Mt(r,[-1,s,a])).map(e=>Or(c,e,h))),o)}});const wi=Me({gramSchmidt_:function(e){let t;if(Array.isArray(e)){t=!1,m(null!=e&&e.length>0,()=>"Gram-Schmidt process: input must not be null, undefined, or empty");const n=e[0].shape[0];for(let t=1;t<e.length;++t)m(e[t].shape[0]===n,()=>`Gram-Schmidt: Non-unique lengths found in the input vectors: (${e[t].shape[0]} vs. ${n})`)}else t=!0,e=Js(e,e.shape[0],0).map(e=>Qs(e,[0]));m(e.length<=e[0].shape[0],()=>`Gram-Schmidt: Number of vectors (${e.length}) exceeds number of dimensions (${e[0].shape[0]}).`);const n=[],r=e;for(let t=0;t<e.length;++t)n.push(xe.tidy(()=>{let e=r[t];if(t>0)for(let r=0;r<t;++r){const t=Sn(No(Sn(n[r],e)),n[r]);e=Do(e,t)}return xn(e,Ia(e,"euclidean"))}));return t?ea(n,0):n}});function ki(e,t=!1){return xe.tidy(()=>{m(2===e.shape.length,()=>`qr2d() requires a 2D Tensor, but got a ${e.shape.length}D Tensor.`);const n=e.shape[0],r=e.shape[1];let o=Zr(n),s=gt(e);const a=oa([[1]],[1,1]);let i=gt(a);const u=n>=r?r:n;for(let e=0;e<u;++e){const t=s,u=i,l=o;[i,s,o]=xe.tidy(()=>{const t=ur(s,[e,e],[n-e,1]),u=Ia(t),l=ur(s,[e,e],[1,1]),c=Or(ro(l,0),oa([[-1]]),oa([[1]])),h=Do(l,Sn(c,u)),p=xn(t,h);i=1===p.shape[0]?gt(a):ar([a,ur(p,[1,0],[p.shape[0]-1,p.shape[1]])],0);const d=vo(xn($t(c,h),u)),f=ur(s,[e,0],[n-e,r]),m=Sn(d,i),g=Bt(i);if(0===e)s=Do(f,$t(m,$t(g,f)));else{const t=Do(f,$t(m,$t(g,f)));s=ar([ur(s,[0,0],[e,r]),t],0)}const b=Bt(m),y=ur(o,[0,e],[n,o.shape[1]-e]);if(0===e)o=Do(y,$t($t(y,i),b));else{const t=Do(y,$t($t(y,i),b));o=ar([ur(o,[0,0],[n,e]),t],1)}return[i,s,o]}),yn([t,u,l])}return!t&&n>r&&(o=ur(o,[0,0],[n,r]),s=ur(s,[0,0],[r,r])),[o,s]})}const vi=Me({qr_:function(e,t=!1){if(m(e.rank>=2,()=>"qr() requires input tensor to have a rank >= 2, but got rank "+e.rank),2===e.rank)return ki(e,t);{const n=e.shape.slice(0,e.shape.length-2).reduce((e,t)=>e*t),r=ua(Mt(e,[n,e.shape[e.shape.length-2],e.shape[e.shape.length-1]]),0),o=[],s=[];return r.forEach(e=>{const[n,r]=ki(e,t);o.push(n),s.push(r)}),[Mt(ea(o,0),e.shape),Mt(ea(s,0),e.shape)]}}});var xi;(xi=e.Reduction||(e.Reduction={}))[xi.NONE=0]="NONE",xi[xi.MEAN=1]="MEAN",xi[xi.SUM=2]="SUM",xi[xi.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS";const Si=Me({computeWeightedLoss_:function(t,n,r=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const o=Ae(t,"losses","computeWeightedLoss");let s=null;null!=n&&(s=Ae(n,"weights","computeWeightedLoss"));const a=null==s?o:Sn(o,s);if(r===e.Reduction.NONE)return a;if(r===e.Reduction.SUM)return No(a);if(r===e.Reduction.MEAN){if(null==s)return zo(a);{const e=o.size/s.size,t=xn(No(a),No(s));return e>1?xn(t,co(e)):t}}if(r===e.Reduction.SUM_BY_NONZERO_WEIGHTS){if(null==s)return xn(No(a),co(o.size));{const e=Sn(s,Po(o.shape)),t=mt(No(Vo(e,co(0))),"float32");return xn(No(a),t)}}throw Error("Unknown reduction: "+r)}});const Ei=Me({absoluteDifference_:function(t,n,r,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const s=Ae(t,"labels","absoluteDifference"),a=Ae(n,"predictions","absoluteDifference");let i=null;null!=r&&(i=Ae(r,"weights","absoluteDifference")),g(s.shape,a.shape,"Error in absoluteDifference: ");const u=En(Do(s,a));return Si(u,i,o)}});const Di=Me({cosineDistance_:function(t,n,r,o,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=Ae(t,"labels","cosineDistance"),i=Ae(n,"predictions","cosineDistance");let u=null;null!=o&&(u=Ae(o,"weights","cosineDistance")),g(a.shape,i.shape,"Error in cosineDistance: ");const l=co(1),c=Do(l,No(Sn(a,i),r,!0));return Si(c,u,s)}});const Ni=Me({hingeLoss_:function(t,n,r,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let s=Ae(t,"labels","hingeLoss");const a=Ae(n,"predictions","hingeLoss");let i=null;null!=r&&(i=Ae(r,"weights","hingeLoss")),g(s.shape,a.shape,"Error in hingeLoss: ");const u=co(1);s=Do(Sn(co(2),s),u);const l=Ds(Do(u,Sn(s,a)));return Si(l,i,o)}});const Ii=Me({huberLoss_:function(t,n,r,o=1,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=Ae(t,"labels","huberLoss"),i=Ae(n,"predictions","huberLoss");let u=null;null!=r&&(u=Ae(r,"weights","huberLoss")),g(a.shape,i.shape,"Error in huberLoss: ");const l=co(o),c=En(Do(i,a)),h=qo(c,l),p=Do(c,h),d=kn(Sn(co(.5),Wo(h)),Sn(l,p));return Si(d,u,s)}});const Fi=Me({logLoss_:function(t,n,r,o=1e-7,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=Ae(t,"labels","logLoss"),i=Ae(n,"predictions","logLoss");let u=null;null!=r&&(u=Ae(r,"weights","logLoss")),g(a.shape,i.shape,"Error in logLoss: ");const l=co(1),c=co(o),h=vo(Sn(a,go(kn(i,c)))),p=Sn(Do(l,a),go(kn(Do(l,i),c))),d=Do(h,p);return Si(d,u,s)}});const Ai=Me({meanSquaredError_:function(t,n,r,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const s=Ae(t,"labels","meanSquaredError"),a=Ae(n,"predictions","meanSquaredError");let i=null;null!=r&&(i=Ae(r,"weights","meanSquaredError")),g(s.shape,a.shape,"Error in meanSquaredError: ");const u=Xs(s,a);return Si(u,i,o)}});const Ti=Me({sigmoidCrossEntropy_:function(t,n,r,o=0,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let a=Ae(t,"multiClassLabels","sigmoidCrossEntropy");const i=Ae(n,"logits","sigmoidCrossEntropy");let u=null;if(null!=r&&(u=Ae(r,"weights","sigmoidCrossEntropy")),g(a.shape,i.shape,"Error in sigmoidCrossEntropy: "),o>0){const e=co(o),t=co(1),n=co(.5);a=kn(Sn(a,Do(t,e)),Sn(n,e))}const l=function(e,t){const n=Ae(e,"labels","sigmoidCrossEntropyWithLogits"),r=Ae(t,"logits","sigmoidCrossEntropyWithLogits");g(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");const o=Ds(r),s=Sn(r,n),a=bo(Hr(vo(En(r))));return kn(Do(o,s),a)}(a,i);return Si(l,u,s)}});const Mi=Me({softmaxCrossEntropy_:function(t,n,r,o=0,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let a=Ae(t,"onehotLabels","softmaxCrossEntropy");const i=Ae(n,"logits","softmaxCrossEntropy");let u=null;if(null!=r&&(u=Ae(r,"weights","softmaxCrossEntropy")),g(a.shape,i.shape,"Error in softmaxCrossEntropy: "),o>0){const e=co(o),t=co(1),n=co(a.shape[1]);a=kn(Sn(a,Do(t,e)),xn(e,n))}const l=function(e,t,n=-1){if(-1===n&&(n=t.rank-1),n!==t.rank-1)throw Error(`Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank ${t.rank} and dim was `+n);return wo((e,t,r)=>{const o=Fo(t,[n],!0),s=Do(mt(t,"float32"),o);r([e,s]);const a=vo(Sn(s,e));return{value:No(a,[n]),gradFunc:(e,t)=>{const[r,o]=t,s=Mn(e.shape,[n]);return[Sn(Mt(e,s),Do(mt(r,"float32"),Hr(o))),Sn(Mt(e,s),Do(Hr(o),mt(r,"float32")))]}}})(e,t)}(a,i);return Si(l,u,s)}}),$i={fft:Us,ifft:Vs,rfft:Ys,irfft:Hs},_i={hammingWindow:Ha,hannWindow:ja,frame:Ja,stft:Ya},Bi={flipLeftRight:Xa,resizeNearestNeighbor:bi,resizeBilinear:gi,rotateWithOffset:Qa,cropAndResize:Za,nonMaxSuppression:ti,nonMaxSuppressionAsync:hi,nonMaxSuppressionWithScore:pi,nonMaxSuppressionWithScoreAsync:di,nonMaxSuppressionPadded:fi,nonMaxSuppressionPaddedAsync:mi},Ci={bandPart:yi,gramSchmidt:wi,qr:vi},Ri={absoluteDifference:Ei,computeWeightedLoss:Si,cosineDistance:Di,hingeLoss:Ni,huberLoss:Ii,logLoss:Fi,meanSquaredError:Ai,sigmoidCrossEntropy:Ti,softmaxCrossEntropy:Mi};class Pi extends un{minimize(e,t=!1,n){const{value:r,grads:o}=this.computeGradients(e,n);if(null!=n){const e=n.map(e=>({name:e.name,tensor:o[e.name]}));this.applyGradients(e)}else this.applyGradients(o);return yn(o),t?r:(r.dispose(),null)}get iterations(){return null==this.iterations_&&(this.iterations_=0),this.iterations_}incrementIterations(){this.iterations_=this.iterations+1}computeGradients(e,t){return yo(e,t)}dispose(){null!=this.iterations_&&yn(this.iterations_)}async saveIterations(){return null==this.iterations_&&(this.iterations_=0),{name:"iter",tensor:co(this.iterations_,"int32")}}async getWeights(){throw new Error("getWeights() is not implemented for this optimizer yet.")}async setWeights(e){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName())}async extractIterations(e){return this.iterations_=(await e[0].tensor.data())[0],e.slice(1)}}Object.defineProperty(Pi,Symbol.hasInstance,{value:e=>null!=e.minimize&&null!=e.computeGradients&&null!=e.applyGradients});class zi extends Pi{constructor(e,t,n=null){super(),this.learningRate=e,this.rho=t,this.epsilon=n,this.accumulatedGrads=[],this.accumulatedUpdates=[],null==n&&(this.epsilon=xe.backend.epsilon())}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=xe.registeredVariables[t];null==this.accumulatedGrads[n]&&(this.accumulatedGrads[n]={originalName:t+"/accum_grad",variable:bn(()=>Wr(r).variable(!1))}),null==this.accumulatedUpdates[n]&&(this.accumulatedUpdates[n]={originalName:t+"/accum_var",variable:bn(()=>Wr(r).variable(!1))});const o=Array.isArray(e)?e[n].tensor:e[t];if(null==o)return;const s=this.accumulatedGrads[n].variable,a=this.accumulatedUpdates[n].variable;bn(()=>{const e=kn(Sn(s,this.rho),Sn(Wo(o),1-this.rho)),t=Sn(xn(Zs(kn(a,this.epsilon)),Zs(kn(s,this.epsilon))),o),n=kn(Sn(a,this.rho),Sn(Wo(t),1-this.rho));s.assign(e),a.assign(n);const i=kn(Sn(t,-this.learningRate),r);r.assign(i)})}),this.incrementIterations()}dispose(){null!=this.accumulatedUpdates&&(yn(this.accumulatedGrads.map(e=>e.variable)),yn(this.accumulatedUpdates.map(e=>e.variable)))}async getWeights(){const e=[...this.accumulatedGrads,...this.accumulatedUpdates];return[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){const t=(e=await this.extractIterations(e)).length/2;this.accumulatedGrads=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedUpdates=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}}static fromConfig(e,t){return new e(t.learningRate,t.rho,t.epsilon)}}zi.className="Adadelta",cn(zi);class Li extends Pi{constructor(e,t=.1){super(),this.learningRate=e,this.initialAccumulatorValue=t,this.accumulatedGrads=[]}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=xe.registeredVariables[t];if(null==this.accumulatedGrads[n]){const e=!1;this.accumulatedGrads[n]={originalName:t+"/accumulator",variable:bn(()=>Xr(r.shape,this.initialAccumulatorValue).variable(e))}}const o=Array.isArray(e)?e[n].tensor:e[t];if(null==o)return;const s=this.accumulatedGrads[n].variable;bn(()=>{const e=kn(s,Wo(o));s.assign(e);const t=kn(Sn(xn(o,Zs(kn(e,xe.backend.epsilon()))),-this.learningRate),r);r.assign(t)})}),this.incrementIterations()}dispose(){null!=this.accumulatedGrads&&yn(this.accumulatedGrads.map(e=>e.variable))}async getWeights(){return[await this.saveIterations()].concat(this.accumulatedGrads.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);this.accumulatedGrads=e.map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}}static fromConfig(e,t){return new e(t.learningRate,t.initialAccumulatorValue)}}Li.className="Adagrad",cn(Li);class qi extends Pi{constructor(e,t,n,r=null){super(),this.learningRate=e,this.beta1=t,this.beta2=n,this.epsilon=r,this.accumulatedFirstMoment=[],this.accumulatedSecondMoment=[],bn(()=>{this.accBeta1=co(t).variable(),this.accBeta2=co(n).variable()}),null==r&&(this.epsilon=xe.backend.epsilon())}applyGradients(e){const t=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);bn(()=>{const n=Do(1,this.accBeta1),r=Do(1,this.accBeta2);t.forEach((t,o)=>{const s=xe.registeredVariables[t];null==this.accumulatedFirstMoment[o]&&(this.accumulatedFirstMoment[o]={originalName:t+"/m",variable:bn(()=>Wr(s).variable(!1))}),null==this.accumulatedSecondMoment[o]&&(this.accumulatedSecondMoment[o]={originalName:t+"/v",variable:bn(()=>Wr(s).variable(!1))});const a=Array.isArray(e)?e[o].tensor:e[t];if(null==a)return;const i=this.accumulatedFirstMoment[o].variable,u=this.accumulatedSecondMoment[o].variable,l=kn(Sn(i,this.beta1),Sn(a,1-this.beta1)),c=kn(Sn(u,this.beta2),Sn(Wo(a),1-this.beta2)),h=xn(l,n),p=xn(c,r);i.assign(l),u.assign(c);const d=kn(Sn(xn(h,kn(Zs(p),this.epsilon)),-this.learningRate),s);s.assign(d)}),this.accBeta1.assign(Sn(this.accBeta1,this.beta1)),this.accBeta2.assign(Sn(this.accBeta2,this.beta2))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&yn(this.accumulatedFirstMoment.map(e=>e.variable)),null!=this.accumulatedSecondMoment&&yn(this.accumulatedSecondMoment.map(e=>e.variable))}async getWeights(){const e=[...this.accumulatedFirstMoment,...this.accumulatedSecondMoment];return[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e),bn(()=>{this.accBeta1.assign(rs(this.beta1,this.iterations_+1)),this.accBeta2.assign(rs(this.beta2,this.iterations_+1))});const t=e.length/2;this.accumulatedFirstMoment=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedSecondMoment=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}}static fromConfig(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon)}}qi.className="Adam",cn(qi);class Oi extends Pi{constructor(e,t,n,r=null,o=0){super(),this.learningRate=e,this.beta1=t,this.beta2=n,this.epsilon=r,this.decay=o,this.accumulatedFirstMoment=[],this.accumulatedWeightedInfNorm=[],bn(()=>{this.iteration=co(0).variable(),this.accBeta1=co(t).variable()}),null==r&&(this.epsilon=xe.backend.epsilon())}applyGradients(e){const t=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);bn(()=>{const n=Do(1,this.accBeta1),r=xn(-this.learningRate,kn(Sn(this.iteration,this.decay),1));t.forEach((t,o)=>{const s=xe.registeredVariables[t];null==this.accumulatedFirstMoment[o]&&(this.accumulatedFirstMoment[o]={originalName:t+"/m",variable:Wr(s).variable(!1)}),null==this.accumulatedWeightedInfNorm[o]&&(this.accumulatedWeightedInfNorm[o]={originalName:t+"/v",variable:Wr(s).variable(!1)});const a=Array.isArray(e)?e[o].tensor:e[t];if(null==a)return;const i=this.accumulatedFirstMoment[o].variable,u=this.accumulatedWeightedInfNorm[o].variable,l=kn(Sn(i,this.beta1),Sn(a,1-this.beta1)),c=Sn(u,this.beta2),h=En(a),p=lo(c,h);i.assign(l),u.assign(p);const d=kn(Sn(xn(r,n),xn(l,kn(p,this.epsilon))),s);s.assign(d)}),this.iteration.assign(kn(this.iteration,1)),this.accBeta1.assign(Sn(this.accBeta1,this.beta1))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&yn(this.accumulatedFirstMoment.map(e=>e.variable)),null!=this.accumulatedWeightedInfNorm&&yn(this.accumulatedWeightedInfNorm.map(e=>e.variable))}async getWeights(){throw new Error("getWeights() is not implemented for Adamax yet.")}async setWeights(e){throw new Error("setWeights() is not implemented for Adamax yet.")}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}}static fromConfig(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon,t.decay)}}Oi.className="Adamax",cn(Oi);class Wi extends Pi{constructor(e){super(),this.learningRate=e,this.setLearningRate(e)}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=Array.isArray(e)?e[n].tensor:e[t];if(null==r)return;const o=xe.registeredVariables[t];bn(()=>{const e=kn(Sn(this.c,r),o);o.assign(e)})}),this.incrementIterations()}setLearningRate(e){this.learningRate=e,null!=this.c&&this.c.dispose(),this.c=wn(co(-e))}dispose(){this.c.dispose()}async getWeights(){return[await this.saveIterations()]}async setWeights(e){if(0!==(e=await this.extractIterations(e)).length)throw new Error("SGD optimizer does not have settable weights.")}getConfig(){return{learningRate:this.learningRate}}static fromConfig(e,t){return new e(t.learningRate)}}Wi.className="SGD",cn(Wi);class Ki extends Wi{constructor(e,t,n=!1){super(e),this.learningRate=e,this.momentum=t,this.useNesterov=n,this.accumulations=[],this.m=co(this.momentum)}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=xe.registeredVariables[t];if(null==this.accumulations[n]){const e=!1;this.accumulations[n]={originalName:t+"/momentum",variable:bn(()=>Wr(r).variable(e))}}const o=this.accumulations[n].variable,s=Array.isArray(e)?e[n].tensor:e[t];null!=s&&bn(()=>{let e;const t=kn(Sn(this.m,o),s);e=this.useNesterov?kn(Sn(this.c,kn(s,Sn(t,this.m))),r):kn(Sn(this.c,t),r),o.assign(t),r.assign(e)})}),this.incrementIterations()}dispose(){this.m.dispose(),null!=this.accumulations&&yn(this.accumulations.map(e=>e.variable))}setMomentum(e){this.momentum=e}async getWeights(){return[await this.saveIterations()].concat(this.accumulations.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);this.accumulations=e.map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}}static fromConfig(e,t){return new e(t.learningRate,t.momentum,t.useNesterov)}}Ki.className="Momentum",cn(Ki);class Gi extends Pi{constructor(e,t=.9,n=0,r=null,o=!1){if(super(),this.learningRate=e,this.decay=t,this.momentum=n,this.epsilon=r,this.accumulatedMeanSquares=[],this.accumulatedMoments=[],this.accumulatedMeanGrads=[],this.centered=o,null==r&&(this.epsilon=xe.backend.epsilon()),null==e)throw new Error("learningRate for RMSPropOptimizer must be defined.")}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=xe.registeredVariables[t];null==this.accumulatedMeanSquares[n]&&(this.accumulatedMeanSquares[n]={originalName:t+"/rms",variable:bn(()=>Wr(r).variable(!1))}),null==this.accumulatedMoments[n]&&(this.accumulatedMoments[n]={originalName:t+"/momentum",variable:bn(()=>Wr(r).variable(!1))}),null==this.accumulatedMeanGrads[n]&&this.centered&&(this.accumulatedMeanGrads[n]={originalName:t+"/mg",variable:bn(()=>Wr(r).variable(!1))});const o=Array.isArray(e)?e[n].tensor:e[t];if(null==o)return;const s=this.accumulatedMeanSquares[n].variable,a=this.accumulatedMoments[n].variable;bn(()=>{const e=kn(Sn(s,this.decay),Sn(Wo(o),1-this.decay));if(this.centered){const t=this.accumulatedMeanGrads[n].variable,i=kn(Sn(t,this.decay),Sn(o,1-this.decay)),u=xn(Sn(o,this.learningRate),Zs(Do(e,kn(Wo(i),this.epsilon)))),l=kn(Sn(a,this.momentum),u);s.assign(e),t.assign(i),a.assign(l);const c=Do(r,l);r.assign(c)}else{const e=kn(Sn(s,this.decay),Sn(Wo(o),1-this.decay)),t=kn(Sn(a,this.momentum),xn(Sn(o,this.learningRate),Zs(kn(e,this.epsilon))));s.assign(e),a.assign(t);const n=Do(r,t);r.assign(n)}})}),this.incrementIterations()}dispose(){null!=this.accumulatedMeanSquares&&yn(this.accumulatedMeanSquares.map(e=>e.variable)),null!=this.accumulatedMeanGrads&&this.centered&&yn(this.accumulatedMeanGrads.map(e=>e.variable)),null!=this.accumulatedMoments&&yn(this.accumulatedMoments.map(e=>e.variable))}async getWeights(){const e=[...this.accumulatedMeanSquares,...this.accumulatedMoments];return this.centered&&e.push(...this.accumulatedMeanGrads),[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);const t=this.centered?e.length/3:e.length/2;this.accumulatedMeanSquares=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedMoments=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.centered&&(this.accumulatedMeanGrads=e.slice(2*t,3*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})))}getConfig(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}}static fromConfig(e,t){return new e(t.learningRate,t.decay,t.momentum,t.epsilon,t.centered)}}Gi.className="RMSProp",cn(Gi);class Ui{static sgd(e){return new Wi(e)}static momentum(e,t,n=!1){return new Ki(e,t,n)}static rmsprop(e,t=.9,n=0,r=null,o=!1){return new Gi(e,t,n,r,o)}static adam(e=.001,t=.9,n=.999,r=null){return new qi(e,t,n,r)}static adadelta(e=.001,t=.95,n=null){return new zi(e,t,n)}static adamax(e=.002,t=.9,n=.999,r=null,o=0){return new Oi(e,t,n,r,o)}static adagrad(e,t=.1){return new Li(e,t)}}const Vi={sgd:Ui.sgd,momentum:Ui.momentum,adadelta:Ui.adadelta,adagrad:Ui.adagrad,rmsprop:Ui.rmsprop,adamax:Ui.adamax,adam:Ui.adam},Hi="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:e=>e();var ji=Object.freeze({__proto__:null,slice_util:an,segment_util:to,castTensor:function(e,t,n){if("complex64"===t){if("complex64"===e.dtype)return e.clone();const t=Ro(e.shape),r=mt(e,"float32"),o=n.complex(r,t);return t.dispose(),r.dispose(),o}if(!T(e.dtype,t))return xe.makeTensorFromDataId(e.dataId,e.shape,t);if("complex64"===e.dtype){const r=n.real(e),o=mt(r,t);return r.dispose(),o}if("int32"===t)return n.int(e);if("bool"===t){const t=co(0,e.dtype),r=n.notEqual(e,t);return t.dispose(),r}throw new Error(`Error in Cast: failed to cast ${e.dtype} to ${t}`)},reshapeTensor:function(e,t){return xe.makeTensorFromDataId(e.dataId,t,e.dtype)},linspaceImpl:function(e,t,n){const r=(t-e)/(n-1),o=G(n,"float32");o[0]=e;for(let e=1;e<o.length;e++)o[e]=o[e-1]+r;return xs(o,"float32")},upcastType:fe,axesAreInnerMostDims:Fn,combineLocations:An,computeOutAndReduceShapes:Tn,expandShapeToKeepDim:Mn,assertAxesAreInnerMostDims:function(e,t,n){m(Fn(t,n),()=>e+" supports only inner-most axes for now. "+`Got axes ${t} and rank-${n} input.`)},getAxesPermutation:$n,getUndoAxesPermutation:_n,getInnerMostAxes:Bn,getBroadcastDims:function(e,t){const n=e.length,r=[];for(let o=0;o<n;o++){const s=n-1-o,a=e[s]||1;(t[t.length-1-o]||1)>1&&1===a&&r.unshift(s)}return r},getReductionAxes:zr,assertAndGetBroadcastShape:Lr,assertParamsConsistent:or,computeOutShape:sr,computeDilation2DInfo:function(e,t,n,r,o="NHWC",s){return Vn(e,[...t,e[3]],n,s,r,null,null,tr(o))},computePool2DInfo:Gn,computePool3DInfo:Un,computeConv2DInfo:Vn,computeConv3DInfo:Hn,computeDefaultPad:jn,tupleValuesAreOne:Qn,eitherStridesOrDilationsAreOne:er,convertConv2DDataFormat:tr,getFusedDyActivation:Pa,getFusedBiasGradient:za,applyActivation:La,shouldFuse:qa,PARALLELIZE_THRESHOLD:30,computeOptimalWindowSize:function(e){return e<=30?e:L(e,Math.floor(Math.sqrt(e)))},getImageCenter:function(e,t,n){return[n*("number"==typeof e?e:e[0]),t*("number"==typeof e?e:e[1])]},getReshaped:function(e,t,n,r=!0){let o=[];if(r)o=o.concat(t.slice(0)),o.push(e[0]/n),o=o.concat(e.slice(1));else{o=o.concat(e[0]);const n=t.length;for(let r=0;r<n;++r)o=o.concat([e[r+1]/t[r],t[r]]);o=o.concat(e.slice(n+1))}return o},getPermuted:function(e,t,n=!0){const r=[];if(n){r.push(t);for(let n=t+1;n<e;++n)n<=2*t?(r.push(n),r.push(n-(t+1))):r.push(n)}else{const n=[],o=[];for(let r=1;r<e;++r)r>=2*t+1||r%2==1?o.push(r):n.push(r);r.push(...n),r.push(0),r.push(...o)}return r},getReshapedPermuted:function(e,t,n,r=!0){const o=[];r?o.push(e[0]/n):o.push(e[0]*n);for(let n=1;n<e.length;++n)n<=t.length?r?o.push(t[n-1]*e[n]):o.push(e[n]/t[n-1]):o.push(e[n]);return o},getSliceBeginCoords:function(e,t){const n=[0];for(let r=0;r<t;++r)n.push(e[r][0]);return n},getSliceSize:function(e,t,n){const r=e.slice(0,1);for(let o=0;o<n;++o)r.push(e[o+1]-t[o][0]-t[o][1]);return r},prepareAndValidate:Ot,validateUpdateShape:Kt,validateInput:Gt,calculateShapes:Ut,SELU_SCALEALPHA:1.7580993408473768,SELU_SCALE:1.0507009873554805,ERF_P:.3275911,ERF_A1:.254829592,ERF_A2:-.284496736,ERF_A3:1.421413741,ERF_A4:-1.453152027,ERF_A5:1.061405429,warn:function(...e){n().getBool("IS_TEST")||console.warn(...e)},log:function(...e){n().getBool("IS_TEST")||console.log(...e)},mergeRealAndImagArrays:function(e,t){if(e.length!==t.length)throw new Error(`Cannot merge real and imag arrays of different lengths. real:${e.length}, imag: ${t.length}.`);const n=new Float32Array(2*e.length);for(let r=0;r<n.length;r+=2)n[r]=e[r/2],n[r+1]=t[r/2];return n},splitRealAndImagArrays:function(e){const t=new Float32Array(e.length/2),n=new Float32Array(e.length/2);for(let r=0;r<e.length;r+=2)t[r/2]=e[r],n[r/2]=e[r+1];return{real:t,imag:n}},complexWithEvenIndex:function(e){const t=Math.ceil(e.length/4),n=new Float32Array(t),r=new Float32Array(t);for(let t=0;t<e.length;t+=4)n[Math.floor(t/4)]=e[t],r[Math.floor(t/4)]=e[t+1];return{real:n,imag:r}},complexWithOddIndex:function(e){const t=Math.floor(e.length/4),n=new Float32Array(t),r=new Float32Array(t);for(let t=2;t<e.length;t+=4)n[Math.floor(t/4)]=e[t],r[Math.floor(t/4)]=e[t+1];return{real:n,imag:r}},getComplexWithIndex:function(e,t){return{real:e[2*t],imag:e[2*t+1]}},assignToTypedArray:function(e,t,n,r){e[2*r]=t,e[2*r+1]=n},exponents:function(e,t){const n=new Float32Array(e/2),r=new Float32Array(e/2);for(let o=0;o<Math.ceil(e/2);o++){const s=(t?2:-2)*Math.PI*(o/e);n[o]=Math.cos(s),r[o]=Math.sin(s)}return{real:n,imag:r}},exponent:function(e,t,n){const r=(n?2:-2)*Math.PI*(e/t);return{real:Math.cos(r),imag:Math.sin(r)}},prepareSplitSize:js});var Ji=Object.freeze({__proto__:null,nonMaxSuppressionV3Impl:oi,nonMaxSuppressionV4Impl:si,nonMaxSuppressionV5Impl:ai,split:function(e,t,n){const r=new Array(e.rank).fill(0),o=e.shape.slice();return t.map(t=>{const s=[...o];s[n]=t;const a=ur(e,r,s);return r[n]+=t,a})},tile:function(e,t){const n=new Array(e.rank);for(let r=0;r<n.length;r++)n[r]=e.shape[r]*t[r];const r=ft(n,e.dtype);for(let t=0;t<r.values.length;++t){const n=r.indexToLoc(t),o=new Array(e.rank);for(let t=0;t<o.length;t++)o[t]=n[t]%e.shape[t];const s=e.locToIndex(o);r.values[t]=e.values[s]}return r.toTensor()},topkImpl:function(e,t,n,r,o){const s=t[t.length-1],[a,i]=[e.length/s,s],u=N(n,a*r),l=N("int32",a*r);for(let t=0;t<a;t++){const n=t*i,o=e.subarray(n,n+i),s=[];for(let e=0;e<o.length;e++)s.push({value:o[e],index:e});s.sort((e,t)=>t.value-e.value);const a=t*r,c=u.subarray(a,a+r),h=l.subarray(a,a+r);for(let e=0;e<r;e++)c[e]=s[e].value,h[e]=s[e].index}const c=t.slice();return c[c.length-1]=r,[Be(u,c,n),Be(l,c,"int32")]},whereImpl:la});function Yi(e){throw new Error(`'${e}' not yet implemented or not found in the registry. Did you forget to import the kernel?`)}const Zi={kernelName:"Abs",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(e,ta(mt(n,"float32"),-1))}}},Xi={kernelName:"Acos",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>{const t=Wo(mt(n,"float32")),r=Zs(Do(co(1),t));return vo(xn(e,r))}}}},Qi={kernelName:"Acosh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>{const t=Zs(Do(Wo(mt(n,"float32")),1));return xn(e,t)}}}},eu={kernelName:"Add",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,o=Lr(n.shape,r.shape);return{a:()=>{let t=e;const r=zr(n.shape,o);return r.length>0&&(t=No(t,r)),Mt(t,n.shape)},b:()=>{let t=e;const n=zr(r.shape,o);return n.length>0&&(t=No(t,n)),Mt(t,r.shape)}}}},tu={kernelName:"AddN",saveAllInputs:!0,gradFunc:(e,t)=>{const n={};return t.forEach((t,r)=>{n[r]=()=>e.clone()}),n}},nu={kernelName:"ArgMax",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Wr(n)}}},ru={kernelName:"ArgMin",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Wr(n)}}},ou={kernelName:"Asin",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>xn(e,Zs(Do(co(1),Wo(mt(n,"float32")))))}}},su={kernelName:"Asinh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>{const t=Zs(kn(co(1),Wo(mt(n,"float32"))));return xn(e,t)}}}},au={kernelName:"Atan2",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,o=Lr(n.shape,r.shape);return{a:()=>{const t=kn(Wo(n),Wo(r));let s=Sn(e,xn(r,t));const a=zr(n.shape,o);return a.length>0&&(s=No(s,a)),Mt(s,n.shape)},b:()=>{const t=kn(Wo(n),Wo(r));let s=vo(Sn(e,xn(n,t)));const a=zr(r.shape,o);return a.length>0&&(s=No(s,a)),Mt(s,r.shape)}}}},iu={kernelName:"Atan",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>xn(e,kn(Wo(mt(n,"float32")),1))}}},uu={kernelName:"Atanh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>xn(e,Do(co(1),Wo(mt(n,"float32"))))}}};const lu=Me({avgPool3dBackprop_:function(e,t,n,r,o=[1,1,1],s,a){const i=Ae(e,"dy","avgPool3dBackprop"),u=Ae(t,"input","avgPool3dBackprop");let l=i,c=u,h=!1;4===u.rank&&(h=!0,l=Mt(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]]),c=Mt(u,[1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]])),m(5===l.rank,()=>"Error in avgPool3dBackprop: dy must be rank 5 but got rank "+l.rank+"."),m(5===c.rank,()=>"Error in avgPool3dBackprop: input must be rank 5 but got rank "+c.rank+"."),m(er(r,o),()=>`Error in avgPool3dBackprop: Either strides or dilations must be 1. Got strides ${r} and dilations '${o}'`),null!=a&&m(v(s),()=>`Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode ${a} but got pad ${s}.`);const p={dy:l,input:c},d={filterSize:n,strides:r,dilations:o,pad:s,dimRoundingMode:a},f=xe.runKernelFunc(e=>{const t=Un(c.shape,n,r,o,s,a);return e.avgPool3dBackprop(l,c,t)},p,null,"AvgPool3DBackprop",d);return h?Mt(f,[f.shape[1],f.shape[2],f.shape[3],f.shape[4]]):f}}),cu={kernelName:"AvgPool3D",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{filterSize:o,strides:s,dilations:a,pad:i,dimRoundingMode:u}=n,l=null==a?[1,1,1]:a;return{x:()=>lu(e,r,o,s,l,i,u)}}};const hu=Me({avgPoolBackprop_:function(e,t,n,r,o){const s=Ae(e,"dy","avgPoolBackprop"),a=Ae(t,"input","avgPoolBackprop");m(a.rank===s.rank,()=>`Rank of input (${a.rank}) does not match rank of dy (${s.rank})`);let i=a,u=s,l=!1;3===a.rank&&(l=!0,i=Mt(a,[1,a.shape[0],a.shape[1],a.shape[2]]),u=Mt(s,[1,s.shape[0],s.shape[1],s.shape[2]])),m(4===u.rank,()=>"Error in avgPoolBackprop: dy must be rank 4 but got rank "+u.rank+"."),m(4===i.rank,()=>"Error in avgPoolBackprop: input must be rank 4 but got rank "+i.rank+".");const c={dy:u,input:i},h={filterSize:n,strides:r,pad:o},p=xe.runKernelFunc(e=>{const t=Gn(i.shape,n,r,1,o);return e.avgPoolBackprop(u,i,t)},c,null,"AvgPoolBackprop",h);return l?Mt(p,[p.shape[1],p.shape[2],p.shape[3]]):p}}),pu={kernelName:"AvgPool",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{filterSize:o,strides:s,pad:a}=n;return{x:()=>hu(e,r,o,s,a)}}},du={kernelName:"BatchMatMul",inputsToSave:["a","b"],gradFunc:(e,t,n)=>{const[r,o]=t,{transposeA:s,transposeB:a}=n;return s||a?!s&&a?{a:()=>$t(e,o,!1,!1),b:()=>$t(e,r,!0,!1)}:s&&!a?{a:()=>$t(o,e,!1,!0),b:()=>$t(r,e,!1,!1)}:{a:()=>$t(o,e,!0,!0),b:()=>$t(e,r,!0,!0)}:{a:()=>$t(e,o,!1,!0),b:()=>$t(r,e,!0,!1)}}},fu={kernelName:"BatchToSpaceND",gradFunc:(e,t,n)=>{const{blockShape:r,crops:o}=n;return{x:()=>ts(e,r,o)}}},mu={kernelName:"BroadcastTo",gradFunc:(e,t,n)=>{const r=n,o=r.inputShape,s=r.shape,a=Array.from(s);for(let e=o.length-1;e>=0;e--)if(o[e]===s[e])a[e]=1;else if(1!==o[e])throw new Error(`broadcastTo(): [${o}] cannot be broadcast to [${s}].`);const i=[];for(let e=0;e<a.length;e++)a[e]>1&&i.push(e);return{x:()=>No(e,i,!0)}}},gu={kernelName:"Cast",gradFunc:e=>({x:()=>e.clone()})},bu={kernelName:"Ceil",gradFunc:e=>({x:()=>Wr(e)})},yu={kernelName:"ClipByValue",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{clipValueMin:o,clipValueMax:s}=n;return{x:()=>Or(Ao(oo(r,o),fo(r,s)),e,Wr(e))}}},wu={kernelName:"Concat",saveAllInputs:!0,gradFunc:(e,t,n)=>{const r=t.map(e=>e.shape),{axis:o}=n,s=E(o,t[0].shape)[0],a=r.map(e=>e[s]);return Js(e,a,s).map(e=>()=>e)}},ku={kernelName:"Conv2D",inputsToSave:["x","filter"],gradFunc:(e,t,n)=>{const[r,o]=t,{dilations:s,strides:a,pad:i,dataFormat:u}=n;return m(Qn(s),()=>`Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${s}'`),{x:()=>Nr(r.shape,e,o,a,i,u),filter:()=>Ra(r,e,o.shape,a,i,u)}}},vu={kernelName:"Conv2DBackpropInput",inputsToSave:["dy","filter"],gradFunc:(e,t,n)=>{const[r,o]=t,{strides:s,pad:a,dataFormat:i,dimRoundingMode:u}=n;return{dy:()=>Er(e,o,s,a,i,1,u),filter:()=>Ra(e,r,o.shape,s,a,i,u)}}};const xu=Me({conv3DBackpropFilter_:function(e,t,n,r,o){let s=e;4===e.rank&&(s=Mt(e,[1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]]));let a=t;4===a.rank&&(a=Mt(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]])),m(5===s.rank,()=>"Error in conv3dDerFilter: input must be rank 5, but got shape "+s.shape+"."),m(5===a.rank,()=>"Error in conv3dDerFilter: dy must be rank 5, but got shape "+a.shape+"."),m(5===n.length,()=>"Error in conv3dDerFilter: filterShape must be length 5, but got "+n+"."),m(s.shape[4]===n[3],()=>`Error in conv3dDerFilter: depth of input ${s.shape[4]}) must match input depth in filter (${n[3]}.`),m(a.shape[4]===n[4],()=>`Error in conv3dDerFilter: depth of dy (${a.shape[4]}) must match output depth for filter (${n[4]}).`);const i={x:s,y:a},u={strides:r,pad:o};return xe.runKernelFunc(e=>{const t=Hn(s.shape,n,r,1,o);return e.conv3dDerFilter(s,a,t)},i,null,"Conv3DBackpropFilterV2",u)}}),Su={kernelName:"Conv3D",inputsToSave:["x","filter"],gradFunc:(e,t,n)=>{const{dilations:r,strides:o,pad:s}=n;m(Qn(r),()=>`Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${r}'`);const[a,i]=t;return{x:()=>Ar(a.shape,e,i,o,s),filter:()=>xu(a,e,i.shape,o,s)}}},Eu={kernelName:"Cos",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(vo(zs(mt(n,"float32"))),e)}}},Du={kernelName:"Cosh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(Ls(mt(n,"float32")),e)}}},Nu={kernelName:"Cumsum",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{axis:o,exclusive:s,reverse:a}=n;return{x:()=>{const t=$n([o],r.rank);let n=_r(e,o,s,!a);return null!=t&&(n=Bt(n,t)),n}}}},Iu={kernelName:"DepthwiseConv2dNative",inputsToSave:["x","filter"],gradFunc:(e,t,n)=>{const{dilations:r,strides:o,pad:s,dimRoundingMode:a}=n,i=null==r?[1,1]:r;m(Qn(i),()=>`Error in gradient of depthwiseConv2dNative: dilation rates greater than 1 are not yet supported. Got dilations '${i}'`);const[u,l]=t;m(4===u.rank,()=>`Error in gradient of depthwiseConv2dNative: input must be rank 4, but got rank ${u.rank}.`),m(4===l.rank,()=>`Error in gradient of depthwiseConv2dNative: filter must be rank 4, but got rank ${l.rank}.`),m(u.shape[3]===l.shape[2],()=>`Error in gradient of depthwiseConv2d: number of input channels (${u.shape[3]}) must match the inChannels dimension in filter ${l.shape[2]}.`),m(er(o,i),()=>`Error in gradient of depthwiseConv2d: Either strides or dilations must be  1. Got strides ${o} and dilations '${i}'.`),null!=a&&m(v(s),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${s}.`);const c=Vn(u.shape,l.shape,o,i,s,a,!0);return{x:()=>Ka(u.shape,e,l,c),filter:()=>Wa(u,e,l.shape,c)}}},Fu={kernelName:"Dilation2D",inputsToSave:["x","filter"],gradFunc:(e,t,n)=>{const[r,o]=t,s={x:r,filter:o,dy:e},a={x:r,filter:o,dy:e};return{x:()=>xe.runKernel("Dilation2DBackpropInput",s,n),filter:()=>xe.runKernel("Dilation2DBackpropFilter",a,n)}}},Au={kernelName:"Div",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,o=Lr(n.shape,r.shape);return{a:()=>{const t=xn(e,mt(r,"float32")),s=zr(n.shape,o);return s.length>0?Mt(No(t,s),n.shape):t},b:()=>{let t=Sn(e,mt(n,"float32"));const s=zr(r.shape,o);s.length>0&&(t=Mt(No(t,s),r.shape));const a=Wo(r);return vo(xn(t,mt(a,"float32")))}}}},Tu={kernelName:"Elu",outputsToSave:[!0],gradFunc:(e,t)=>{const[n]=t,r=t=>t.eluDer(e,n),o={dy:e,y:n};return{x:()=>xe.runKernelFunc(r,o,null,"EluGrad")}}},Mu={kernelName:"Erf",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t,r=Sn(Hr(vo(Wo(n))),2/Math.sqrt(Math.PI));return{x:()=>Sn(e,r)}}},$u={kernelName:"Exp",outputsToSave:[!0],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(e,n)}}},_u={kernelName:"Expm1",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(e,Hr(n))}}},Bu={kernelName:"Floor",gradFunc:e=>({x:()=>Wr(e)})},Cu={kernelName:"FloorDiv",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,o=Lr(n.shape,r.shape);return{a:()=>{const t=xn(e,mt(r,"float32")),s=zr(n.shape,o);return s.length>0?Mt(No(t,s),n.shape):t},b:()=>{let t=Sn(e,mt(n,"float32"));const s=zr(r.shape,o);s.length>0&&(t=Mt(No(t,s),r.shape));const a=Wo(r);return vo(xn(t,mt(a,"float32")))}}}},Ru={kernelName:"FusedBatchNorm",inputsToSave:["x","mean","variance","scale"],gradFunc:(e,t,n)=>{const{varianceEpsilon:r}=n,[o,s,a,i]=t,u=null==i?co(1):i,l=zr(s.shape,o.shape),c=[];if(1===s.rank){for(let e=0;e<o.shape.length-1;++e)c.push(o.shape[e]);c.push(1)}const h=Do(o,s),p=Sn(e,u),d=_s(kn(a,co(r))),f=Sn(Sn(Sn(d,d),d),co(-.5));return{x:()=>1===s.rank?Mt(Sn(Sn(e,Yr(Mt(d,[1,1,1,s.shape[0]]),c)),u),o.shape):Mt(Sn(Sn(e,d),u),o.shape),mean:()=>{let e=Sn(Sn(d,co(-1)),p);return 1===s.rank&&(e=No(e,l)),Mt(e,s.shape)},variance:()=>{let e=Sn(Sn(f,h),p);return 1===s.rank&&(e=No(e,l)),Mt(e,s.shape)},scale:()=>{const t=Sn(h,d);let n=Sn(e,t);return 1===s.rank&&(n=No(n,l)),Mt(n,s.shape)},offset:()=>{let t=e;return 1===s.rank&&(t=No(t,l)),Mt(t,s.shape)}}}},Pu={kernelName:"GatherV2",inputsToSave:["x","indices"],gradFunc:(e,t,n)=>{const[r,o]=t,{axis:s}=n,a=E(s,r.shape)[0];return{x:()=>{const t=r.shape,n=o.size,i=t.slice(0,a),u=i.length,l=t.slice(s,t.length).slice(1),c=l.length,h=zu(0,u),p=zu(u+1,u+1+c),d=Lu([i,[n],l]),f=Mt(e,d),m=Mt(o,[n]),g=Lu([[u],h,p]),b=Bt(f,g);let y=ia(b,m,r.shape[a]);const w=_n(g);return y=Bt(y,w),y},indices:()=>o}}};function zu(e,t){const n=[];for(let r=e;r<t;++r)n.push(r);return n}function Lu(e){const t=[];for(let n=0;n<e.length;++n)for(let r=0;r<e[n].length;++r)t.push(e[n][r]);return t}const qu={kernelName:"GreaterEqual",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t;return{a:()=>Wr(n),b:()=>Wr(r)}}},Ou={kernelName:"Identity",gradFunc:e=>({x:()=>mt(e,"float32")})},Wu={kernelName:"IsFinite",gradFunc:e=>({x:()=>Wr(e)})},Ku={kernelName:"IsInf",gradFunc:e=>({x:()=>Wr(e)})},Gu={kernelName:"IsNan",gradFunc:e=>({x:()=>Wr(e)})},Uu={kernelName:"Log1p",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>xn(e,kn(n,1))}}},Vu={kernelName:"Log",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>xn(e,mt(n,"float32"))}}},Hu={kernelName:"LogSoftmax",inputsToSave:[],outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r]=t,{axis:o}=n;return{logits:()=>{const t=Hr(r);return Do(e,Sn(No(e,o,!0),t))}}}};const ju=Me({localResponseNormalizationBackprop_:function(e,t,n,r=5,o=1,s=1,a=.5){const i={x:e,y:t,dy:n},u={depthRadius:r,bias:o,alpha:s,beta:a};return xe.runKernelFunc(i=>i.LRNGrad(n,e,t,r,o,s,a),i,null,"LRNBackprop",u)}}),Ju={kernelName:"LRN",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r,o]=t,{depthRadius:s,bias:a,alpha:i,beta:u}=n;return{x:()=>ju(r,o,e,s,a,i,u)}}};function Yu(e,t,n,r,o){return t.rank<n.rank&&(t=Mt(t,Mn(t.shape,r))),e.rank<n.rank&&(e=Mt(e,Mn(e.shape,r))),{x:()=>{const r=Sn(e,mt(qr(n,t),e.dtype));return null==o?r:Bt(r,o)}}}const Zu={kernelName:"Max",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const r=n,{reductionIndices:o}=r,[s,a]=t,i=E(o,s.shape),u=$n(i,s.rank),l=Yu(e,a,s,i,u);return{x:()=>{let e=l.x();return null!=u&&(e=Bt(e)),e}}}},Xu={kernelName:"Maximum",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t;return{a:()=>Sn(e,mt(oo(n,r),"float32")),b:()=>Sn(e,mt(po(n,r),"float32"))}}};const Qu=Me({maxPool3dBackprop_:function(e,t,n,r,o,s=[1,1,1],a,i){const u=Ae(e,"dy","maxPool3dBackprop"),l=Ae(t,"input","maxPool3dBackprop"),c=Ae(n,"output","maxPool3dBackprop");let h=u,p=l,d=c,f=!1;4===l.rank&&(f=!0,h=Mt(u,[1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]]),p=Mt(l,[1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]]),d=Mt(c,[1,c.shape[0],c.shape[1],c.shape[2],c.shape[3]])),m(5===h.rank,()=>"Error in maxPool3dBackprop: dy must be rank 5 but got rank "+h.rank+"."),m(5===p.rank,()=>"Error in maxPool3dBackprop: input must be rank 5 but got rank "+p.rank+"."),m(5===d.rank,()=>"Error in maxPool3dBackprop: output must be rank 5 but got rank "+d.rank+"."),m(er(o,s),()=>`Error in maxPool3dBackprop: Either strides or dilations must be 1. Got strides ${o} and dilations '${s}'`),null!=i&&m(v(a),()=>`Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode ${i} but got pad ${a}.`);const g={dy:h,input:p,output:d},b={filterSize:r,strides:o,dilations:s,pad:a,dimRoundingMode:i},y=xe.runKernelFunc(e=>{const t=Un(p.shape,r,o,s,a,i);return e.maxPool3dBackprop(h,p,d,t)},g,null,"MaxPool3DBackprop",b);return f?Mt(y,[y.shape[1],y.shape[2],y.shape[3],y.shape[4]]):y}}),el={kernelName:"MaxPool3D",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r,o]=t,{filterSize:s,strides:a,dilations:i,pad:u,dimRoundingMode:l}=n,c=null==i?[1,1,1]:i;return{x:()=>Qu(e,r,o,s,a,c,u,l)}}};const tl=Me({maxPoolBackprop_:function(e,t,n,r,o,s,a){const i=Ae(e,"dy","maxPoolBackprop"),u=Ae(t,"input","maxPoolBackprop"),l=Ae(n,"output","maxPoolBackprop");m(u.rank===i.rank,()=>`Rank of input (${u.rank}) does not match rank of dy (${i.rank})`),m(4===i.rank,()=>"Error in maxPoolBackprop: dy must be rank 4 but got rank "+i.rank+"."),m(4===u.rank,()=>"Error in maxPoolBackprop: input must be rank 4 but got rank "+u.rank+"."),null!=a&&m(v(s),()=>`Error in maxPoolBackprop: pad must be an integer when using, dimRoundingMode ${a} but got pad ${s}.`);const c={dy:i,input:u,output:l},h={filterSize:r,strides:o,pad:s,dimRoundingMode:a};return xe.runKernelFunc(e=>{const t=Gn(u.shape,r,o,1,s,a);return e.maxPoolBackprop(i,u,l,t)},c,null,"MaxPoolBackprop",h)}}),nl={kernelName:"PadV2",inputsToSave:["x"],gradFunc:(e,t,n)=>{const r=t[0],{paddings:o}=n,s=o.map(e=>e[0]);return{x:()=>ur(e,s,r.shape)}}},rl={kernelName:"SpaceToBatchND",gradFunc:(e,t,n)=>{const{blockShape:r,paddings:o}=n;return{x:()=>hr(e,r,o)}}},ol={kernelName:"SplitV",gradFunc:(e,t,n)=>{const{axis:r}=n;return{x:()=>ar(e,r)}}};const sl=[Zi,Xi,Qi,eu,tu,nu,ru,ou,su,au,iu,uu,cu,pu,du,fu,mu,gu,bu,yu,wu,vu,ku,Su,Eu,Du,Nu,Iu,Fu,Au,Tu,Mu,$u,_u,Cu,Bu,Ru,Pu,qu,Ou,Wu,Ku,Gu,Uu,Vu,Hu,Ju,Zu,Zu,Xu,el,{kernelName:"MaxPool",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r,o]=t,{filterSize:s,strides:a,pad:i}=n;return{x:()=>tl(e,r,o,s,a,i)}}},{kernelName:"Min",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const r=n,{axis:o}=r,[s,a]=t,i=E(o,s.shape),u=$n(i,s.rank),l=Yu(e,a,s,i,u);return{x:()=>{let e=l.x();return null!=u&&(e=Bt(e)),e}}}},{kernelName:"Minimum",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t;return{a:()=>Sn(e,mt(fo(n,r),"float32")),b:()=>Sn(e,mt(ro(n,r),"float32"))}}},{kernelName:"Mod",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,o=Lr(n.shape,r.shape);return{a:()=>{const t=zr(n.shape,o);return t.length>0?Mt(No(e,t),n.shape):e},b:()=>{const t=Sn(e,vo(Qr(xn(n,r)))),s=zr(r.shape,o);return s.length>0?Mt(No(t,s),r.shape):t}}}},{kernelName:"Multiply",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,o=Lr(n.shape,r.shape);return{a:()=>{const t=Sn(e,mt(r,"float32")),s=zr(n.shape,o);return s.length>0?Mt(No(t,s),n.shape):t},b:()=>{const t=Sn(e,mt(n,"float32")),s=zr(r.shape,o);return s.length>0?Mt(No(t,s),r.shape):t}}}},{kernelName:"Negate",gradFunc:e=>({x:()=>vo(e)})},{kernelName:"OneHot",inputsToSave:["indices"],gradFunc:(e,t)=>{const n=t[0];return{indices:()=>Ro(n.shape,"float32")}}},{kernelName:"OnesLike",gradFunc:e=>({x:()=>Wr(e)})},nl,nl,{kernelName:"Pow",inputsToSave:["a","b"],outputsToSave:[!0],gradFunc:(e,t)=>{const[n,r,o]=t,s=n,a=r,i=Lr(s.shape,a.shape);return{a:()=>{const t=mt(a,"float32");let n=Sn(e,Sn(t,rs(s,Do(t,co(1)))));const r=zr(s.shape,i);return r.length>0&&(n=No(n,r)),Mt(n,s.shape)},b:()=>{const t=ro(s,0),n=Or(t,go(s),Wr(s));let r=Sn(e,Sn(o,n));const u=zr(a.shape,i);return u.length>0&&(r=No(r,u)),Mt(r,a.shape)}}}},{kernelName:"Prelu",inputsToSave:["x","alpha"],gradFunc:(e,t)=>{const[n,r]=t,o=ro(n,0);return{x:()=>Or(o,e,Sn(e,r)),alpha:()=>{let t=Or(o,Wr(e),Sn(e,n));const s=zr(r.shape,e.shape);return s.length>0&&(t=No(t,s)),Mt(t,r.shape)}}}},{kernelName:"Reciprocal",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>xn(e,vo(Wo(n)))}}},{kernelName:"Relu6",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t,r=Sn(fo(n,6),ta(n));return{x:()=>Sn(e,mt(r,"float32"))}}},{kernelName:"Relu",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(e,mt(ta(n),"float32"))}}},{kernelName:"Reshape",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Mt(e,n.shape)}}},{kernelName:"ResizeBilinear",inputsToSave:["images"],gradFunc:(e,t,n)=>{const[r]=t,o=t=>{const{alignCorners:o}=n;return t.resizeBilinearBackprop(e,r,o)},s={images:r};return{images:()=>xe.runKernelFunc(o,s,null,"ResizeBilinearGrad",n)}}},{kernelName:"ResizeNearestNeighbor",inputsToSave:["images"],gradFunc:(e,t,n)=>{const[r]=t,o=t=>{const{alignCorners:o}=n;return t.resizeNearestNeighborBackprop(e,r,o)},s={images:r};return{images:()=>xe.runKernelFunc(o,s,null,"ResizeNearestNeighborGrad",n)}}},{kernelName:"Reverse",gradFunc:(e,t,n)=>{const{dims:r}=n,o=E(r,e.shape);return{x:()=>Is(e,o)}}},{kernelName:"Round",gradFunc:e=>({x:()=>Wr(e)})},{kernelName:"Rsqrt",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>vo(xn(e,Sn(rs(n,1.5),2)))}}},{kernelName:"SelectV2",inputsToSave:["condition"],gradFunc:(e,t)=>{const[n]=t;return{condition:()=>mt(Wr(n),"float32"),t:()=>Sn(e,mt(n,e.dtype)),e:()=>Sn(e,mt(To(n),e.dtype))}}},{kernelName:"Selu",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>{const t=ro(n,co(0)),r=co(1.7580993408473768),o=co(1.0507009873554805),s=Sn(e,o),a=Sn(Sn(e,r),Hr(mt(n,"float32")));return Or(t,s,a)}}}},{kernelName:"Sigmoid",outputsToSave:[!0],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(e,Sn(n,Do(co(1),n)))}}},{kernelName:"Sign",gradFunc:e=>({x:()=>Wr(e)})},{kernelName:"Sin",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(Mr(mt(n,"float32")),e)}}},{kernelName:"Sinh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn($r(mt(n,"float32")),e)}}},{kernelName:"Slice",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{begin:o,size:s}=n,a=r.shape,[i,u]=sn(r,o,s),l=[];for(let t=0;t<e.rank;t++)l.push([i[t],a[t]-i[t]-u[t]]);return{x:()=>Yo(e,l)}}},{kernelName:"Softmax",outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r]=t,{dim:o}=n,s=Sn(e,r);return{logits:()=>Do(s,Sn(No(s,[o],!0),r))}}},{kernelName:"Softplus",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(e,ir(n))}}},rl,rl,ol,ol,{kernelName:"Sqrt",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>xn(e,Sn(Zs(mt(n,"float32")),2))}}},{kernelName:"SquaredDifference",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,o=co(2);return{a:()=>Sn(e,Sn(o,Do(n,r))),b:()=>Sn(e,Sn(o,Do(r,n)))}}},{kernelName:"Square",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(e,Sn(mt(n,"float32"),2))}}},{kernelName:"Step",gradFunc:e=>({x:()=>Wr(e)})},{kernelName:"Sub",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,o=Lr(n.shape,r.shape);return{a:()=>{let t=e;const r=zr(n.shape,o);return r.length>0&&(t=No(t,r)),Mt(t,n.shape)},b:()=>{let t=e;const n=zr(r.shape,o);return n.length>0&&(t=No(t,n)),Mt(vo(t),r.shape)}}}},{kernelName:"Sum",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,o=r.shape.slice(),{axis:s}=n;E(s,r.shape).forEach(e=>{o[e]=1});const a=Mt(e,o),i=Sn(a,Po(r.shape,"float32"));return{x:()=>i}}},{kernelName:"Tan",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>xn(e,Wo(Mr(n)))}}},{kernelName:"Tanh",outputsToSave:[!0],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Sn(Do(co(1),Wo(n)),e)}}},{kernelName:"Tile",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{reps:o}=n;return{x:()=>{let t=Wr(r);if(1===r.rank)for(let n=0;n<o[0];++n)t=kn(t,ur(e,[n*r.shape[0]],[r.shape[0]]));else if(2===r.rank)for(let n=0;n<o[0];++n)for(let s=0;s<o[1];++s)t=kn(t,ur(e,[n*r.shape[0],s*r.shape[1]],[r.shape[0],r.shape[1]]));else if(3===r.rank)for(let n=0;n<o[0];++n)for(let s=0;s<o[1];++s)for(let a=0;a<o[2];++a)t=kn(t,ur(e,[n*r.shape[0],s*r.shape[1],a*r.shape[2]],[r.shape[0],r.shape[1],r.shape[2]]));else{if(4!==r.rank)throw new Error("Gradient for tile operation is not implemented for rank-"+r.rank+" tensors yet.");for(let n=0;n<o[0];++n)for(let s=0;s<o[1];++s)for(let a=0;a<o[2];++a)for(let i=0;i<o[3];++i)t=kn(t,ur(e,[n*r.shape[0],s*r.shape[1],a*r.shape[2],i*r.shape[3]],[r.shape[0],r.shape[1],r.shape[2],r.shape[3]]))}return t}}}},{kernelName:"Transpose",gradFunc:(e,t,n)=>{const r=n,{perm:o}=r,s=_n(o);return{x:()=>Bt(e,s)}}},{kernelName:"Unpack",gradFunc:(e,t,n)=>{const r=n,{axis:o}=r;return{value:()=>ea(e,o)}}},{kernelName:"UnsortedSegmentSum",inputsToSave:["segmentIds"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>function(e,t){const n=lo(t,Wr(t)),r=no(e,n);let o=oo(t,co(0,"int32"));const s=r.rank-o.rank;for(let e=0;e<s;++e)o=jr(o,e+1);o=Ao(o,Po(r.shape,"bool"));const a=Wr(r);return Or(o,r,a)}(e,n)}}},{kernelName:"ZerosLike",gradFunc:e=>({x:()=>Wr(e)})}];for(const e of sl)h(e);ae.prototype.abs=function(){return this.throwIfDisposed(),En(this)},ae.prototype.acos=function(){return this.throwIfDisposed(),Dn(this)},ae.prototype.acosh=function(){return this.throwIfDisposed(),Nn(this)},ae.prototype.addStrict=function(e){return this.throwIfDisposed(),ya(this,e)},ae.prototype.add=function(e){return this.throwIfDisposed(),kn(this,e)},ae.prototype.all=function(e,t){return this.throwIfDisposed(),Cn(this,e,t)},ae.prototype.any=function(e,t){return this.throwIfDisposed(),Rn(this,e,t)},ae.prototype.argMax=function(e){return this.throwIfDisposed(),Pn(this,e)},ae.prototype.argMin=function(e){return this.throwIfDisposed(),zn(this,e)},ae.prototype.asScalar=function(){return this.throwIfDisposed(),m(1===this.size,()=>"The array must have only 1 element."),Mt(this,[])},ae.prototype.asType=function(e){return this.throwIfDisposed(),mt(this,e)},ae.prototype.as1D=function(){return this.throwIfDisposed(),Mt(this,[this.size])},ae.prototype.as2D=function(e,t){return this.throwIfDisposed(),Mt(this,[e,t])},ae.prototype.as3D=function(e,t,n){return this.throwIfDisposed(),Mt(this,[e,t,n])},ae.prototype.as4D=function(e,t,n,r){return this.throwIfDisposed(),Mt(this,[e,t,n,r])},ae.prototype.as5D=function(e,t,n,r,o){return this.throwIfDisposed(),Mt(this,[e,t,n,r,o])},ae.prototype.asin=function(){return this.throwIfDisposed(),Ln(this)},ae.prototype.asinh=function(){return this.throwIfDisposed(),qn(this)},ae.prototype.atan=function(){return this.throwIfDisposed(),On(this)},ae.prototype.atan2=function(e){return this.throwIfDisposed(),Wn(this,e)},ae.prototype.atanh=function(){return this.throwIfDisposed(),Kn(this)},ae.prototype.avgPool=function(e,t,n,r){return this.throwIfDisposed(),nr(this,e,t,n,r)},ae.prototype.batchToSpaceND=function(e,t){return this.throwIfDisposed(),hr(this,e,t)},ae.prototype.batchNorm=function(e,t,n,r,o){return this.throwIfDisposed(),dr(this,e,t,n,r,o)},ae.prototype.broadcastTo=function(e){return this.throwIfDisposed(),br(this,e)},ae.prototype.cast=function(e){return this.throwIfDisposed(),mt(this,e)},ae.prototype.ceil=function(){return this.throwIfDisposed(),yr(this)},ae.prototype.clipByValue=function(e,t){return this.throwIfDisposed(),wr(this,e,t)},ae.prototype.concat=function(e,t){return this.throwIfDisposed(),e instanceof ae&&(e=[e]),ar([this,...e],t)},ae.prototype.conv1d=function(e,t,n,r,o,s){return this.throwIfDisposed(),Dr(this,e,t,n,r,o,s)},ae.prototype.conv2dTranspose=function(e,t,n,r,o){return this.throwIfDisposed(),Ir(this,e,t,n,r,o)},ae.prototype.conv2d=function(e,t,n,r,o,s){return this.throwIfDisposed(),Er(this,e,t,n,r,o,s)},ae.prototype.cos=function(){return this.throwIfDisposed(),Mr(this)},ae.prototype.cosh=function(){return this.throwIfDisposed(),$r(this)},ae.prototype.cumsum=function(e,t,n){return this.throwIfDisposed(),_r(this,e,t,n)},ae.prototype.depthToSpace=function(e,t){return this.throwIfDisposed(),Br(this,e,t)},ae.prototype.depthwiseConv2D=function(e,t,n,r,o,s){return gn("depthwiseConv2D is deprecated, use depthwiseConv2d instead"),this.throwIfDisposed(),Cr(this,e,t,n,r,o,s)},ae.prototype.depthwiseConv2d=function(e,t,n,r,o,s){return this.throwIfDisposed(),Cr(this,e,t,n,r,o,s)},ae.prototype.dilation2d=function(e,t,n,r,o){return this.throwIfDisposed(),Pr(this,e,t,n,r,o)},ae.prototype.divNoNan=function(e){return this.throwIfDisposed(),Kr(this,e)},ae.prototype.divStrict=function(e){return this.throwIfDisposed(),wa(this,e)},ae.prototype.div=function(e){return this.throwIfDisposed(),xn(this,e)},ae.prototype.dot=function(e){return this.throwIfDisposed(),Gr(this,e)},ae.prototype.elu=function(){return this.throwIfDisposed(),Ur(this)},ae.prototype.equalStrict=function(e){return this.throwIfDisposed(),pa(this,e)},ae.prototype.equal=function(e){return this.throwIfDisposed(),qr(this,e)},ae.prototype.erf=function(){return this.throwIfDisposed(),Vr(this)},ae.prototype.exp=function(){return this.throwIfDisposed(),Hr(this)},ae.prototype.expandDims=function(e){return this.throwIfDisposed(),jr(this,e)},ae.prototype.expm1=function(){return this.throwIfDisposed(),Jr(this)},ae.prototype.fft=function(){return this.throwIfDisposed(),Us(this)},ae.prototype.flatten=function(){return this.throwIfDisposed(),Mt(this,[this.size])},ae.prototype.floor=function(){return this.throwIfDisposed(),Qr(this)},ae.prototype.floorDiv=function(e){return this.throwIfDisposed(),vn(this,e)},ae.prototype.gather=function(e,t){return this.throwIfDisposed(),no(this,e,t)},ae.prototype.greaterEqualStrict=function(e){return this.throwIfDisposed(),da(this,e)},ae.prototype.greaterEqual=function(e){return this.throwIfDisposed(),oo(this,e)},ae.prototype.greaterStrict=function(e){return this.throwIfDisposed(),fa(this,e)},ae.prototype.greater=function(e){return this.throwIfDisposed(),ro(this,e)},ae.prototype.ifft=function(){return this.throwIfDisposed(),Vs(this)},ae.prototype.irfft=function(){return this.throwIfDisposed(),Hs(this)},ae.prototype.isFinite=function(){return this.throwIfDisposed(),ao(this)},ae.prototype.isInf=function(){return this.throwIfDisposed(),io(this)},ae.prototype.isNaN=function(){return this.throwIfDisposed(),uo(this)},ae.prototype.leakyRelu=function(e){return this.throwIfDisposed(),ho(this,e)},ae.prototype.lessEqualStrict=function(e){return this.throwIfDisposed(),ma(this,e)},ae.prototype.lessEqual=function(e){return this.throwIfDisposed(),fo(this,e)},ae.prototype.lessStrict=function(e){return this.throwIfDisposed(),ga(this,e)},ae.prototype.less=function(e){return this.throwIfDisposed(),po(this,e)},ae.prototype.localResponseNormalization=function(e,t,n,r){return this.throwIfDisposed(),mo(this,e,t,n,r)},ae.prototype.logSigmoid=function(){return this.throwIfDisposed(),So(this)},ae.prototype.logSoftmax=function(e){return this.throwIfDisposed(),Io(this,e)},ae.prototype.logSumExp=function(e,t){return this.throwIfDisposed(),Fo(this,e,t)},ae.prototype.log=function(){return this.throwIfDisposed(),go(this)},ae.prototype.log1p=function(){return this.throwIfDisposed(),bo(this)},ae.prototype.logicalAnd=function(e){return this.throwIfDisposed(),Ao(this,e)},ae.prototype.logicalNot=function(){return this.throwIfDisposed(),To(this)},ae.prototype.logicalOr=function(e){return this.throwIfDisposed(),Mo(this,e)},ae.prototype.logicalXor=function(e){return this.throwIfDisposed(),$o(this,e)},ae.prototype.matMul=function(e,t,n){return this.throwIfDisposed(),$t(this,e,t,n)},ae.prototype.maxPool=function(e,t,n,r){return this.throwIfDisposed(),_o(this,e,t,n,r)},ae.prototype.max=function(e,t){return this.throwIfDisposed(),Eo(this,e,t)},ae.prototype.maximumStrict=function(e){return this.throwIfDisposed(),ka(this,e)},ae.prototype.maximum=function(e){return this.throwIfDisposed(),lo(this,e)},ae.prototype.mean=function(e,t){return this.throwIfDisposed(),zo(this,e,t)},ae.prototype.min=function(e,t){return this.throwIfDisposed(),Lo(this,e,t)},ae.prototype.minimumStrict=function(e){return this.throwIfDisposed(),va(this,e)},ae.prototype.minimum=function(e){return this.throwIfDisposed(),qo(this,e)},ae.prototype.modStrict=function(e){return this.throwIfDisposed(),xa(this,e)},ae.prototype.mod=function(e){return this.throwIfDisposed(),Oo(this,e)},ae.prototype.mulStrict=function(e){return this.throwIfDisposed(),Sa(this,e)},ae.prototype.mul=function(e){return this.throwIfDisposed(),Sn(this,e)},ae.prototype.neg=function(){return this.throwIfDisposed(),vo(this)},ae.prototype.norm=function(e,t,n){return this.throwIfDisposed(),Ia(this,e,t,n)},ae.prototype.notEqualStrict=function(e){return this.throwIfDisposed(),ba(this,e)},ae.prototype.notEqual=function(e){return this.throwIfDisposed(),Vo(this,e)},ae.prototype.oneHot=function(e,t=1,n=0){return this.throwIfDisposed(),_t(this,e,t,n)},ae.prototype.onesLike=function(){return this.throwIfDisposed(),jo(this)},ae.prototype.pad=function(e,t){return this.throwIfDisposed(),Yo(this,e,t)},ae.prototype.pool=function(e,t,n,r,o){return this.throwIfDisposed(),ns(this,e,t,n,r,o)},ae.prototype.powStrict=function(e){return this.throwIfDisposed(),Ea(this,e)},ae.prototype.pow=function(e){return this.throwIfDisposed(),rs(this,e)},ae.prototype.prelu=function(e){return this.throwIfDisposed(),os(this,e)},ae.prototype.prod=function(e,t){return this.throwIfDisposed(),ss(this,e,t)},ae.prototype.reciprocal=function(){return this.throwIfDisposed(),Es(this)},ae.prototype.relu=function(){return this.throwIfDisposed(),Ds(this)},ae.prototype.relu6=function(){return this.throwIfDisposed(),Ns(this)},ae.prototype.reshapeAs=function(e){return this.throwIfDisposed(),Mt(this,e.shape)},ae.prototype.reshape=function(e){return this.throwIfDisposed(),Mt(this,e)},ae.prototype.resizeBilinear=function(e,t){return this.throwIfDisposed(),gi(this,e,t)},ae.prototype.resizeNearestNeighbor=function(e,t){return this.throwIfDisposed(),bi(this,e,t)},ae.prototype.reverse=function(e){return this.throwIfDisposed(),Is(this,e)},ae.prototype.rfft=function(){return this.throwIfDisposed(),Ys(this)},ae.prototype.round=function(){return this.throwIfDisposed(),$s(this)},ae.prototype.rsqrt=function(){return this.throwIfDisposed(),_s(this)},ae.prototype.selu=function(){return this.throwIfDisposed(),Bs(this)},ae.prototype.separableConv2d=function(e,t,n,r,o,s){return this.throwIfDisposed(),Cs(this,e,t,n,r,o,s)},ae.prototype.sigmoid=function(){return this.throwIfDisposed(),ir(this)},ae.prototype.sign=function(){return this.throwIfDisposed(),Ps(this)},ae.prototype.sin=function(){return this.throwIfDisposed(),zs(this)},ae.prototype.sinh=function(){return this.throwIfDisposed(),Ls(this)},ae.prototype.slice=function(e,t){return this.throwIfDisposed(),ur(this,e,t)},ae.prototype.softmax=function(e){return this.throwIfDisposed(),Gs(this,e)},ae.prototype.softplus=function(){return this.throwIfDisposed(),xo(this)},ae.prototype.spaceToBatchND=function(e,t){return this.throwIfDisposed(),ts(this,e,t)},ae.prototype.split=function(e,t){return this.throwIfDisposed(),Js(this,e,t)},ae.prototype.sqrt=function(){return this.throwIfDisposed(),Zs(this)},ae.prototype.square=function(){return this.throwIfDisposed(),Wo(this)},ae.prototype.squaredDifference=function(e){return this.throwIfDisposed(),Xs(this,e)},ae.prototype.squaredDifferenceStrict=function(e){return this.throwIfDisposed(),Da(this,e)},ae.prototype.squeeze=function(e){return this.throwIfDisposed(),Qs(this,e)},ae.prototype.stack=function(e,t){this.throwIfDisposed();const n=e instanceof ae?[this,e]:[this,...e];return ea(n,t)},ae.prototype.step=function(e){return this.throwIfDisposed(),ta(this,e)},ae.prototype.stridedSlice=function(e,t,n,r,o,s,a,i){return this.throwIfDisposed(),na(this,e,t,n,r,o,s,a,i)},ae.prototype.subStrict=function(e){return this.throwIfDisposed(),Na(this,e)},ae.prototype.sub=function(e){return this.throwIfDisposed(),Do(this,e)},ae.prototype.sum=function(e,t){return this.throwIfDisposed(),No(this,e,t)},ae.prototype.tan=function(){return this.throwIfDisposed(),ra(this)},ae.prototype.tanh=function(){return this.throwIfDisposed(),lr(this)},ae.prototype.tile=function(e){return this.throwIfDisposed(),Yr(this,e)},ae.prototype.toBool=function(){return this.throwIfDisposed(),mt(this,"bool")},ae.prototype.toFloat=function(){return this.throwIfDisposed(),mt(this,"float32")},ae.prototype.toInt=function(){return this.throwIfDisposed(),mt(this,"int32")},ae.prototype.topk=function(e,t){return this.throwIfDisposed(),sa(this,e,t)},ae.prototype.transpose=function(e){return this.throwIfDisposed(),Bt(this,e)},ae.prototype.unsortedSegmentSum=function(e,t){return this.throwIfDisposed(),ia(this,e,t)},ae.prototype.unstack=function(e){return this.throwIfDisposed(),ua(this,e)},ae.prototype.where=function(e,t){return this.throwIfDisposed(),Or(e,this,t)},ae.prototype.zerosLike=function(){return this.throwIfDisposed(),Wr(this)},e.Abs="Abs",e.Acos="Acos",e.Acosh="Acosh",e.AdadeltaOptimizer=zi,e.AdagradOptimizer=Li,e.AdamOptimizer=qi,e.AdamaxOptimizer=Oi,e.Add="Add",e.AddN="AddN",e.All="All",e.Any="Any",e.ArgMax="ArgMax",e.ArgMin="ArgMin",e.Asin="Asin",e.Asinh="Asinh",e.Atan="Atan",e.Atan2="Atan2",e.Atanh="Atanh",e.AvgPool="AvgPool",e.AvgPool3D="AvgPool3D",e.AvgPool3DBackprop="AvgPool3DBackprop",e.AvgPoolBackprop="AvgPoolBackprop",e.BatchMatMul="BatchMatMul",e.BatchToSpaceND="BatchToSpaceND",e.BroadcastTo="BroadcastTo",e.Cast="Cast",e.Ceil="Ceil",e.ClipByValue="ClipByValue",e.Complex="Complex",e.Concat="Concat",e.Conv2D="Conv2D",e.Conv2DBackpropFilter="Conv2DBackpropFilter",e.Conv2DBackpropInput="Conv2DBackpropInput",e.Conv3D="Conv3D",e.Conv3DBackpropFilterV2="Conv3DBackpropFilterV2",e.Conv3DBackpropInputV2="Conv3DBackpropInputV2",e.Cos="Cos",e.Cosh="Cosh",e.CropAndResize="CropAndResize",e.Cumsum="Cumsum",e.DataStorage=class{constructor(e,t){this.backend=e,this.dataMover=t,this.data=new WeakMap,this.dataIdsCount=0}get(e){return this.data.has(e)||this.dataMover.moveData(this.backend,e),this.data.get(e)}set(e,t){this.dataIdsCount++,this.data.set(e,t)}has(e){return this.data.has(e)}delete(e){return this.dataIdsCount--,this.data.delete(e)}numDataIds(){return this.dataIdsCount}},e.DepthToSpace="DepthToSpace",e.DepthwiseConv2dNative="DepthwiseConv2dNative",e.DepthwiseConv2dNativeBackpropFilter="DepthwiseConv2dNativeBackpropFilter",e.DepthwiseConv2dNativeBackpropInput="DepthwiseConv2dNativeBackpropInput",e.Diag="Diag",e.Dilation2D="Dilation2D",e.Dilation2DBackpropFilter="Dilation2DBackpropFilter",e.Dilation2DBackpropInput="Dilation2DBackpropInput",e.Div="Div",e.Elu="Elu",e.EluGrad="EluGrad",e.Environment=t,e.Equal="Equal",e.Erf="Erf",e.Exp="Exp",e.Expm1="Expm1",e.FFT="FFT",e.Fill="Fill",e.FlipLeftRight="FlipLeftRight",e.Floor="Floor",e.FloorDiv="FloorDiv",e.FromPixels="FromPixels",e.FusedBatchNorm="FusedBatchNorm",e.FusedConv2D="FusedConv2D",e.FusedDepthwiseConv2D="FusedDepthwiseConv2D",e.GatherNd="GatherNd",e.GatherV2="GatherV2",e.Greater="Greater",e.GreaterEqual="GreaterEqual",e.IFFT="IFFT",e.Identity="Identity",e.Imag="Imag",e.IsFinite="IsFinite",e.IsInf="IsInf",e.IsNan="IsNan",e.KernelBackend=class{time(e){return Yi("time")}read(e){return Yi("read")}readSync(e){return Yi("readSync")}numDataIds(){return Yi("numDataIds")}disposeData(e){return Yi("disposeData")}write(e,t,n){return Yi("write")}move(e,t,n,r){return Yi("move")}memory(){return Yi("memory")}floatPrecision(){return Yi("floatPrecision")}epsilon(){return 32===this.floatPrecision()?1e-7:1e-4}batchMatMul(e,t,n,r){return Yi("batchMatMul")}fusedBatchMatMul({a:e,b:t,transposeA:n,transposeB:r,bias:o,activation:s,preluActivationWeights:a}){return Yi("fusedBatchMatMul")}slice(e,t,n){return Yi("slice")}stridedSlice(e,t,n,r){return Yi("stridedSlice")}unstack(e,t){return Yi("unstack")}reverse(e,t){return Yi("reverse")}concat(e,t){return Yi("concat")}neg(e){return Yi("neg")}add(e,t){return Yi("add")}addN(e){return Yi("addN")}subtract(e,t){return Yi("subtract")}multiply(e,t){return Yi("multiply")}realDivide(e,t){return Yi("realDivide")}floorDiv(e,t){return Yi("floorDiv")}sum(e,t){return Yi("sum")}prod(e,t){return Yi("prod")}unsortedSegmentSum(e,t,n){return Yi("unsortedSegmentSum")}argMin(e,t){return Yi("argMin")}argMax(e,t){return Yi("argMax")}equal(e,t){return Yi("equal")}notEqual(e,t){return Yi("notEqual")}less(e,t){return Yi("less")}lessEqual(e,t){return Yi("lessEqual")}greater(e,t){return Yi("greater")}greaterEqual(e,t){return Yi("greaterEqual")}logicalNot(e){return Yi("logicalNot")}logicalAnd(e,t){return Yi("logicalAnd")}logicalOr(e,t){return Yi("logicalOr")}where(e){return Yi("where")}select(e,t,n){return Yi("select")}topk(e,t,n){return Yi("topk")}min(e,t){return Yi("min")}minimum(e,t){return Yi("minimum")}mod(e,t){return Yi("mod")}max(e,t){return Yi("max")}maximum(e,t){return Yi("maximum")}all(e,t){return Yi("all")}any(e,t){return Yi("any")}squaredDifference(e,t){return Yi("squaredDifference")}ceil(e){return Yi("ceil")}floor(e){return Yi("floor")}round(e){return Yi("round")}sign(e){return Yi("sign")}isNaN(e){return Yi("isNaN")}isInf(e){return Yi("isInf")}isFinite(e){return Yi("isFinite")}pow(e,t){return Yi("pow")}exp(e){return Yi("exp")}expm1(e){return Yi("expm1")}softmax(e,t){return Yi("softmax")}log(e){return Yi("log")}log1p(e){return Yi("log1p")}sqrt(e){return Yi("sqrt")}rsqrt(e){return Yi("rsqrt")}square(e){return Yi("square")}reciprocal(e){return Yi("reciprocal")}relu(e){return Yi("relu")}relu6(e){return Yi("relu6")}prelu(e,t){return Yi("prelu")}elu(e){return Yi("elu")}eluDer(e,t){return Yi("eluDer")}selu(e){return Yi("selu")}int(e){return Yi("int")}clip(e,t,n){return Yi("clip")}abs(e){return Yi("abs")}complexAbs(e){return Yi("complexAbs")}sigmoid(e){return Yi("sigmoid")}softplus(e){return Yi("softplus")}sin(e){return Yi("sin")}cos(e){return Yi("cos")}tan(e){return Yi("tan")}asin(e){return Yi("asin")}acos(e){return Yi("acos")}atan(e){return Yi("atan")}atan2(e,t){return Yi("atan2")}sinh(e){return Yi("sinh")}cosh(e){return Yi("cosh")}tanh(e){return Yi("tanh")}asinh(e){return Yi("asinh")}acosh(e){return Yi("acosh")}atanh(e){return Yi("atanh")}erf(e){return Yi("erf")}step(e,t){return Yi("step")}fusedConv2d({input:e,filter:t,convInfo:n,bias:r,activation:o,preluActivationWeights:s}){return Yi("fusedConv2d")}conv2d(e,t,n){return Yi("conv2d")}conv2dDerInput(e,t,n){return Yi("conv2dDerInput")}conv2dDerFilter(e,t,n){return Yi("conv2dDerFilter")}fusedDepthwiseConv2D({input:e,filter:t,convInfo:n,bias:r,activation:o,preluActivationWeights:s}){return Yi("fusedDepthwiseConv2D")}depthwiseConv2D(e,t,n){return Yi("depthwiseConv2D")}depthwiseConv2DDerInput(e,t,n){return Yi("depthwiseConv2DDerInput")}depthwiseConv2DDerFilter(e,t,n){return Yi("depthwiseConv2DDerFilter")}conv3d(e,t,n){return Yi("conv3d")}conv3dDerInput(e,t,n){return Yi("conv3dDerInput")}conv3dDerFilter(e,t,n){return Yi("conv3dDerFilter")}maxPool(e,t){return Yi("maxPool")}maxPoolBackprop(e,t,n,r){return Yi("maxPoolBackprop")}avgPool(e,t){return Yi("avgPool")}avgPoolBackprop(e,t,n){return Yi("avgPoolBackprop")}avgPool3d(e,t){return Yi("avgPool3d")}avgPool3dBackprop(e,t,n){return Yi("avgPool3dBackprop")}maxPool3d(e,t){return Yi("maxPool3d")}maxPool3dBackprop(e,t,n,r){return Yi("maxPool3dBackprop")}reshape(e,t){return Yi("reshape")}cast(e,t){return Yi("cast")}tile(e,t){return Yi("tile")}pad(e,t,n){return Yi("pad")}transpose(e,t){return Yi("transpose")}gather(e,t,n){return Yi("gather")}gatherND(e,t){return Yi("gatherND")}scatterND(e,t,n){return Yi("scatterND")}batchToSpaceND(e,t,n){return Yi("batchToSpaceND")}spaceToBatchND(e,t,n){return Yi("spaceToBatchND")}resizeBilinear(e,t,n,r){return Yi("resizeBilinear")}resizeBilinearBackprop(e,t,n){return Yi("resizeBilinearBackprop")}resizeNearestNeighbor(e,t,n,r){return Yi("resizeNearestNeighbor")}resizeNearestNeighborBackprop(e,t,n){return Yi("resizeNearestNeighborBackprop")}batchNorm(e,t,n,r,o,s){return Yi("batchNorm")}localResponseNormalization4D(e,t,n,r,o){return Yi("localResponseNormalization4D")}LRNGrad(e,t,n,r,o,s,a){return Yi("LRNGrad")}multinomial(e,t,n,r){return Yi("multinomial")}oneHot(e,t,n,r){return Yi("oneHot")}cumsum(e,t,n,r){return Yi("cumsum")}nonMaxSuppression(e,t,n,r,o){return Yi("nonMaxSuppression")}fft(e){return Yi("fft")}ifft(e){return Yi("ifft")}complex(e,t){return Yi("complex")}real(e){return Yi("real")}imag(e){return Yi("imag")}cropAndResize(e,t,n,r,o,s){return Yi("cropAndResize")}depthToSpace(e,t,n){return Yi("depthToSpace")}split(e,t,n){return Yi("split")}sparseToDense(e,t,n,r){return Yi("sparseToDense")}diag(e){return Yi("diag")}fill(e,t,n){return Yi("fill")}onesLike(e){return Yi("onesLike")}zerosLike(e){return Yi("zerosLike")}linspace(e,t,n){return Yi("linspace")}dispose(){return Yi("dispose")}},e.LRN="LRN",e.LRNBackprop="LRNBackprop",e.Less="Less",e.LessEqual="LessEqual",e.LinSpace="LinSpace",e.Log="Log",e.Log1p="Log1p",e.LogSoftmax="LogSoftmax",e.LogicalAnd="LogicalAnd",e.LogicalNot="LogicalNot",e.LogicalOr="LogicalOr",e.Max="Max",e.MaxPool="MaxPool",e.MaxPool3D="MaxPool3D",e.MaxPool3DBackprop="MaxPool3DBackprop",e.MaxPoolBackprop="MaxPoolBackprop",e.MaxPoolWithArgmax="MaxPoolWithArgmax",e.Maximum="Maximum",e.Mean="Mean",e.Min="Min",e.Minimum="Minimum",e.Mod="Mod",e.MomentumOptimizer=Ki,e.Multiply="Multiply",e.Negate="Negate",e.NonMaxSuppressionV3="NonMaxSuppressionV3",e.NonMaxSuppressionV4="NonMaxSuppressionV4",e.NonMaxSuppressionV5="NonMaxSuppressionV5",e.NotEqual="NotEqual",e.OP_SCOPE_SUFFIX="__op",e.OneHot="OneHot",e.OnesLike="OnesLike",e.Optimizer=Pi,e.PadV2="PadV2",e.Pool="Pool",e.Pow="Pow",e.Prelu="Prelu",e.Prod="Prod",e.RMSPropOptimizer=Gi,e.Range="Range",e.Real="Real",e.Reciprocal="Reciprocal",e.Relu="Relu",e.Relu6="Relu6",e.Reshape="Reshape",e.ResizeBilinear="ResizeBilinear",e.ResizeBilinearGrad="ResizeBilinearGrad",e.ResizeNearestNeighbor="ResizeNearestNeighbor",e.ResizeNearestNeighborGrad="ResizeNearestNeighborGrad",e.Reverse="Reverse",e.RotateWithOffset="RotateWithOffset",e.Round="Round",e.Rsqrt="Rsqrt",e.SGDOptimizer=Wi,e.ScatterNd="ScatterNd",e.SelectV2="SelectV2",e.Selu="Selu",e.Sigmoid="Sigmoid",e.Sign="Sign",e.Sin="Sin",e.Sinh="Sinh",e.Slice="Slice",e.Softmax="Softmax",e.Softplus="Softplus",e.SpaceToBatchND="SpaceToBatchND",e.SparseToDense="SparseToDense",e.SplitV="SplitV",e.Sqrt="Sqrt",e.Square="Square",e.SquaredDifference="SquaredDifference",e.Step="Step",e.StridedSlice="StridedSlice",e.Sub="Sub",e.Sum="Sum",e.Tan="Tan",e.Tanh="Tanh",e.Tensor=ae,e.TensorBuffer=re,e.Tile="Tile",e.TopK="TopK",e.Transpose="Transpose",e.Unpack="Unpack",e.UnsortedSegmentSum="UnsortedSegmentSum",e.Variable=ie,e.ZerosLike="ZerosLike",e._FusedMatMul="_FusedMatMul",e.abs=En,e.acos=Dn,e.acosh=Nn,e.add=kn,e.addN=In,e.addStrict=ya,e.all=Cn,e.any=Rn,e.argMax=Pn,e.argMin=zn,e.asin=Ln,e.asinh=qn,e.atan=On,e.atan2=Wn,e.atanh=Kn,e.avgPool=nr,e.avgPool3d=rr,e.backend=function(){return xe.backend},e.backend_util=ji,e.basicLSTMCell=cr,e.batchNorm=dr,e.batchNorm2d=fr,e.batchNorm3d=mr,e.batchNorm4d=gr,e.batchToSpaceND=hr,e.booleanMaskAsync=ha,e.broadcastTo=br,e.browser=qt,e.buffer=ft,e.cast=mt,e.ceil=yr,e.clipByValue=wr,e.clone=gt,e.complex=$e,e.concat=ar,e.concat1d=kr,e.concat2d=vr,e.concat3d=xr,e.concat4d=Sr,e.conv1d=Dr,e.conv2d=Er,e.conv2dTranspose=Ir,e.conv3d=Fr,e.conv3dTranspose=Tr,e.cos=Mr,e.cosh=$r,e.cosineWindow=Ba,e.cumsum=_r,e.customGrad=wo,e.deprecationWarn=gn,e.depthToSpace=Br,e.depthwiseConv2d=Cr,e.device_util=De,e.diag=Rr,e.dilation2d=Pr,e.disableDeprecationWarnings=function(){n().set("DEPRECATION_WARNINGS_ENABLED",!1),console.warn("TensorFlow.js deprecation warnings have been disabled.")},e.dispose=yn,e.disposeVariables=function(){xe.disposeVariables()},e.div=xn,e.divNoNan=Kr,e.divStrict=wa,e.dot=Gr,e.dropout=$a,e.elu=Ur,e.enableDebugMode=function(){n().set("DEBUG",!0)},e.enableProdMode=function(){n().set("PROD",!0)},e.enclosingPowerOfTwo=_a,e.engine=function(){return xe},e.env=n,e.equal=qr,e.equalStrict=pa,e.erf=Vr,e.exp=Hr,e.expandDims=jr,e.expm1=Jr,e.eye=Zr,e.fft=Us,e.fill=Xr,e.findBackend=function(e){return xe.findBackend(e)},e.findBackendFactory=function(e){return xe.findBackendFactory(e)},e.floor=Qr,e.floorDiv=vn,e.fused=Va,e.gather=no,e.gatherND=Ma,e.gather_util=Wt,e.getBackend=function(){return xe.backendName},e.getGradient=l,e.getKernel=u,e.getKernelsForBackend=c,e.grad=function(e){return m(z(e),()=>"The f passed in grad(f) must be a function"),(t,n)=>{const r=Ae(t,"x","tf.grad",null),o=null!=n?Ae(n,"dy","tf.grad"):null;return xe.tidy(()=>{const{value:t,grads:n}=xe.gradients(()=>e(r),[r],o);return null!=o&&g(t.shape,o.shape,"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)"),ko(n),n[0]})}},e.grads=function(e){return m(z(e),()=>"The f passed in grads(f) must be a function"),(t,n)=>{m(Array.isArray(t),()=>"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s");const r=Te(t,"args","tf.grads",null),o=null!=n?Ae(n,"dy","tf.grads"):null;return xe.tidy(()=>{const{value:t,grads:n}=xe.gradients(()=>e(...r),r,o);return null!=o&&g(t.shape,o.shape,"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),ko(n),n})}},e.greater=ro,e.greaterEqual=oo,e.greaterEqualStrict=da,e.greaterStrict=fa,e.ifft=Vs,e.imag=so,e.image=Bi,e.inTopKAsync=Ca,e.io=Tt,e.irfft=Hs,e.isFinite=ao,e.isInf=io,e.isNaN=uo,e.keep=wn,e.kernel_impls=Ji,e.leakyRelu=ho,e.less=po,e.lessEqual=fo,e.lessEqualStrict=ma,e.lessStrict=ga,e.linalg=Ci,e.linspace=function(e,t,n){if(n<=0)throw new Error("The number of values should be positive.");const r={start:e,stop:t,num:n};return xe.runKernelFunc(r=>r.linspace(e,t,n),{},null,"LinSpace",r)},e.localResponseNormalization=mo,e.log=go,e.log1p=bo,e.logSigmoid=So,e.logSoftmax=Io,e.logSumExp=Fo,e.logicalAnd=Ao,e.logicalNot=To,e.logicalOr=Mo,e.logicalXor=$o,e.losses=Ri,e.matMul=$t,e.math=Rt,e.max=Eo,e.maxPool=_o,e.maxPool3d=Bo,e.maxPoolWithArgmax=Co,e.maximum=lo,e.maximumStrict=ka,e.mean=zo,e.memory=function(){return xe.memory()},e.min=Lo,e.minimum=qo,e.minimumStrict=va,e.mod=Oo,e.modStrict=xa,e.moments=Ko,e.movingAverage=Fa,e.mul=Sn,e.mulStrict=Sa,e.multiRNNCell=Go,e.multinomial=Uo,e.neg=vo,e.nextFrame=function(){return new Promise(e=>Hi(()=>e()))},e.norm=Ia,e.notEqual=Vo,e.notEqualStrict=ba,e.oneHot=_t,e.ones=Po,e.onesLike=jo,e.op=Me,e.outerProduct=Jo,e.pad=Yo,e.pad1d=Zo,e.pad2d=Xo,e.pad3d=Qo,e.pad4d=es,e.pool=ns,e.pow=rs,e.powStrict=Ea,e.prelu=os,e.print=bt,e.prod=ss,e.profile=function(e){return xe.profile(e)},e.rand=as,e.randomGamma=ws,e.randomNormal=ks,e.randomUniform=vs,e.range=Ss,e.ready=function(){return xe.ready()},e.real=Ho,e.reciprocal=Es,e.registerBackend=function(e,t,n=1){return xe.registerBackend(e,t,n)},e.registerGradient=h,e.registerKernel=function(e){const{kernelName:t,backendName:n}=e,r=p(t,n);a.has(r)&&console.warn(`The kernel '${t}' for backend '${n}' is already registered`),a.set(r,e)},e.relu=Ds,e.relu6=Ns,e.removeBackend=function(e){xe.removeBackend(e)},e.reshape=Mt,e.reverse=Is,e.reverse1d=Fs,e.reverse2d=As,e.reverse3d=Ts,e.reverse4d=Ms,e.rfft=Ys,e.round=$s,e.rsqrt=_s,e.scalar=co,e.scatterND=Aa,e.scatter_util=Vt,e.selu=Bs,e.separableConv2d=Cs,e.serialization=hn,e.setBackend=function(e){return xe.setBackend(e)},e.setPlatform=function(e,t){n().setPlatform(e,t)},e.setdiff1dAsync=Rs,e.sigmoid=ir,e.sign=Ps,e.signal=_i,e.sin=zs,e.sinh=Ls,e.slice=ur,e.slice1d=qs,e.slice2d=Os,e.slice3d=Ws,e.slice4d=Ks,e.slice_util=an,e.softmax=Gs,e.softplus=xo,e.spaceToBatchND=ts,e.sparseToDense=Ta,e.spectral=$i,e.split=Js,e.sqrt=Zs,e.square=Wo,e.squaredDifference=Xs,e.squaredDifferenceStrict=Da,e.squeeze=Qs,e.stack=ea,e.step=ta,e.stridedSlice=na,e.sub=Do,e.subStrict=Na,e.sum=No,e.sumOutType=function(e){return fe(e,"int32")},e.tan=ra,e.tanh=lr,e.tensor=Be,e.tensor1d=xs,e.tensor2d=oa,e.tensor3d=Pt,e.tensor4d=function(e,t,n){if(b(e),null!=t&&4!==t.length)throw new Error("tensor4d() requires shape to have four numbers");const r=Ie(e,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return _e(e,t,r,n)},e.tensor5d=function(e,t,n){if(b(e),null!=t&&5!==t.length)throw new Error("tensor5d() requires shape to have five numbers");const r=Ie(e,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return _e(e,t,r,n)},e.tensor6d=function(e,t,n){if(b(e),null!=t&&6!==t.length)throw new Error("tensor6d() requires shape to have six numbers");const r=Ie(e,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return _e(e,t=t||r,r,n)},e.tensor_util=ye,e.test_util=mn,e.tidy=bn,e.tile=Yr,e.time=function(e){return xe.time(e)},e.topk=sa,e.train=Vi,e.transpose=Bt,e.truncatedNormal=aa,e.unregisterGradient=function(e){if(!i.has(e))throw new Error(`The gradient '${e}' for backend is not registered`);i.delete(e)},e.unregisterKernel=function(e,t){const n=p(e,t);if(!a.has(n))throw new Error(`The kernel '${e}' for backend '${t}' is not registered`);a.delete(n)},e.unsortedSegmentSum=ia,e.unstack=ua,e.upcastType=fe,e.util=J,e.valueAndGrad=function(e){return m(z(e),()=>"The f passed in valueAndGrad(f) must be a function"),(t,n)=>{m(t instanceof ae,()=>"The x passed in valueAndGrad(f)(x) must be a tensor"),m(null==n||n instanceof ae,()=>"The dy passed in valueAndGrad(f)(x, dy) must be a tensor");const{grads:r,value:o}=xe.gradients(()=>e(t),[t],n);return ko(r),{grad:r[0],value:o}}},e.valueAndGrads=function(e){return m(z(e),()=>"The f passed in valueAndGrads(f) must be a function"),(t,n)=>{m(Array.isArray(t)&&t.every(e=>e instanceof ae),()=>"The args passed in valueAndGrads(f)(args) must be array of tensors"),m(null==n||n instanceof ae,()=>"The dy passed in valueAndGrads(f)(args, dy) must be a tensor");const r=xe.gradients(()=>e(...t),t,n);return null!=n&&g(r.value.shape,n.shape,"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),ko(r.grads),r}},e.variable=function(e,t=!0,n,r){return xe.makeVariable(e,t,n,r)},e.variableGrads=yo,e.version_core="2.4.0",e.where=Or,e.whereAsync=ca,e.zeros=Ro,e.zerosLike=Wr,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-core.es2017.min.js.map
